var _jsxFileName = 'src/lib/components/Template.js';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import cx from 'classnames';
import { getUniqueId } from '../utility/utility';
import { Dropdown, DropdownToggle, DropdownMenu, DropdownItem } from 'reactstrap';

import TemplateItem from './TemplateItem';
import TemplateTypeChoice from './TemplateTypeChoice';
import templateTypeFilter from './templateTypeFilter';
import { RESPONSE_TYPES, CHANNEL_RESPONSE_TYPES } from './TemplateResponseTypes';
import ToggleSwitch from '../atoms/Toggle';
import TemplateImportExport from './TemplateImportExport';

var Template = function (_React$Component) {
  _inherits(Template, _React$Component);

  function Template(props) {
    _classCallCheck(this, Template);

    console.log('App Version:: ', '0.7.7');

    var _this = _possibleConstructorReturn(this, (Template.__proto__ || Object.getPrototypeOf(Template)).call(this, props));

    _this.channelKey = function (channels, channel) {
      var channelKey = 'default';
      for (var i = 0; i < channels.length; i++) {
        if (channels[i].value === channel) {
          return channels[i].key;
        }
      }
      return channelKey;
    };

    _this.channelValue = function (channels, channel) {
      var channelValue = 'default';
      for (var i = 0; i < channels.length; i++) {
        if (channels[i].key === channel.toLowerCase()) {
          return channels[i].value;
        }
      }
      return channelValue;
    };

    _this.languageValue = function (languages, language) {
      var languageValue = '';
      for (var i = 0; i < languages.length; i++) {
        if (languages[i].key === language) {
          return languages[i].value;
        }
      }
      return languageValue;
    };

    _this.state = {
      dropdownOpen: false,
      languageDropdownOpen: false,
      responseTypes: RESPONSE_TYPES,
      showTemplateTypeChoice: true,
      preview: true,
      channel: 'default',
      channelDropdownLabel: 'default',
      langCode: 'en',
      hideLanguageDropdown: false
    };
    _this.toggle = _this.toggle.bind(_this);
    _this.togglePreview = _this.togglePreview.bind(_this);
    _this.toggleLanguageDropdown = _this.toggleLanguageDropdown.bind(_this);
    _this.hideAndShowTemplateTypeChoice = _this.hideAndShowTemplateTypeChoice.bind(_this);
    _this.onChannelClick = _this.onChannelClick.bind(_this);
    _this.onAddNewChannel = _this.onAddNewChannel.bind(_this);
    _this.filterResponseTypes = _this.filterResponseTypes.bind(_this);
    return _this;
  }

  _createClass(Template, [{
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps) {
      var responseTypes = [].concat(_toConsumableArray(RESPONSE_TYPES));
      var __responseTypesProps = this.props.responseTypes;

      var _props = this.props,
          langCode = _props.langCode,
          channel = _props.channel,
          languages = _props.languages;


      var __responseTypesPrevProps = prevProps.responseTypes;
      if (__responseTypesPrevProps && __responseTypesProps) {
        if (__responseTypesProps.length !== __responseTypesPrevProps.length) {
          // Merge the state and props
          responseTypes = responseTypes.concat(__responseTypesProps);
          this.setState({
            responseTypes: responseTypes
          });
        }
      }

      if (prevProps.langCode !== langCode) {
        this.setState({
          langCode: langCode,
          hideLanguageDropdown: true
        });
      }

      if (prevProps.channel !== channel) {
        this.filterResponseTypes(channel);
        this.setState({
          channel: channel
        });
      }
      if (prevProps.languages !== languages) {
        this.setState({
          languages: languages
        });
      }
    }
  }, {
    key: 'onChannelClick',
    value: function onChannelClick(channel) {
      var _this2 = this;

      var _props2 = this.props,
          answer = _props2.answer,
          channels = _props2.channels;

      var newChannel = true;
      this.setState({
        channel: channel
      });
      var onAddNewChannel = this.props.onAddNewChannel;
      var channelKey = this.channelKey(channels, channel);
      answer.forEach(function (ans, index) {
        if (ans.channel.toLowerCase() === channelKey.toLowerCase() && ans.language === _this2.state.langCode) {
          _this2.props.onChannelClick(index);
          newChannel = false;
        }
      });
      if (newChannel) {
        onAddNewChannel(channelKey, this.state.langCode);
      }
      this.filterResponseTypes(channel);
    }
  }, {
    key: 'onLanguageChange',
    value: function onLanguageChange(langCode) {
      var _props3 = this.props,
          answer = _props3.answer,
          onAnswerChange = _props3.onAnswerChange,
          onChannelClick = _props3.onChannelClick,
          channels = _props3.channels;
      var currentIndex = this.props.currentIndex;

      var _messages = JSON.parse(JSON.stringify(answer[0].messages));

      var channel = this.state.channel;

      var currentChannel = this.channelKey(channels, channel);

      var newchannel = true;

      //* For the dropdown label
      this.setState({
        langCode: langCode
      });

      if (langCode) {
        //! To create a new answer object having the language or use the existing object
        answer.some(function (ans, index) {
          if (currentChannel.toLowerCase() === ans.channel.toLowerCase() && langCode === ans.language) {
            onChannelClick(index);
            newchannel = false;
          }
        });

        if (newchannel) {
          _messages.forEach(function (message, msgIndex) {
            var index = 0;
            var key = Math.floor(Math.random() * 1000) + 1;
            while (true) {
              if (msgIndex === 0 || index === msgIndex) {
                message['key'] = key;
                break;
              } else if (_messages[index].key !== key) {
                ++index;
              } else {
                key = Math.floor(Math.random() * 1000) + 1;
                index = 0;
              }
            }
          });
          _messages.forEach(function (message) {
            var oldId = message.id;
            message['id'] = getUniqueId().substring(0, 24).replace(/-/g, '');

            if (message.type === 'dynamic' && message.title === 'Custom') {
              message.content = message.content.replace(oldId, message.id);
              message.templateMarkup = message.templateMarkup.replace(oldId, message.id);
              message.dynamicTemplate = true;
            }
          });

          var answerData = {
            language: langCode,
            channel: currentChannel,
            messages: _messages,
            save: null
          };
          if (answer[0].cust_seg) {
            answerData['cust_seg'] = answer[0].cust_seg;
          }
          var _currentIndex = this.props.currentIndex;

          _currentIndex = answer.length;

          onChannelClick(_currentIndex);
          onAnswerChange(answerData, _currentIndex);
        }
      }
    }
  }, {
    key: 'onAddNewChannel',
    value: function onAddNewChannel(channel) {
      var onAddNewChannel = this.props.onAddNewChannel;


      this.setState({
        channel: channel.value
      });
      onAddNewChannel(channel.key, this.state.langCode);
      this.filterResponseTypes(channel.value);
    }
  }, {
    key: 'filterResponseTypes',
    value: function filterResponseTypes(channel) {
      var channel_response_types = CHANNEL_RESPONSE_TYPES[channel];

      if (channel === 'websdk' || channel === 'Webapp') {
        var response_types = RESPONSE_TYPES.map(function (response) {
          return Object.assign({}, response);
        });

        response_types.forEach(function (response) {
          delete response.hide;
        });

        this.setState({
          responseTypes: response_types
        });
      } else if (channel_response_types) {
        var filtered_channel_response_types = RESPONSE_TYPES.filter(function (response) {
          return channel_response_types.indexOf(response.type) !== -1;
        }).map(function (response) {
          return Object.assign({}, response);
        });

        if (channel === 'Facebook' || channel === 'Amazon Alexa' || channel === 'Google Assistant') {
          filtered_channel_response_types.forEach(function (response) {
            delete response.hide;
          });
        }
        this.setState({
          responseTypes: filtered_channel_response_types
        });
      } else {
        if (channel != 'default') {
          var _response_types = RESPONSE_TYPES.map(function (response) {
            return Object.assign({}, response);
          });

          _response_types.forEach(function (response) {
            if (response.type === 'dynamic' && response.title === 'Custom') {
              delete response.hide;
            }
          });
          this.setState({
            responseTypes: _response_types
          });
        } else {
          this.setState({
            responseTypes: RESPONSE_TYPES
          });
        }
      }
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      var responseTypes = this.state.responseTypes;

      var __responseTypesProps = this.props.responseTypes;
      var _props4 = this.props,
          langCode = _props4.langCode,
          answer = _props4.answer,
          onChannelClick = _props4.onChannelClick,
          channels = _props4.channels;

      if (langCode) {
        this.setState({
          langCode: langCode,
          hideLanguageDropdown: true
        });
      }
      if (__responseTypesProps) {
        // Merge the state and props
        responseTypes = responseTypes.concat(__responseTypesProps);
        this.setState({
          responseTypes: responseTypes
        });
      }

      if (answer.length > 1) {
        if (answer[0].channel === 'default' && answer[0].messages.length === 0) {
          onChannelClick(1);
          this.onChannelClick(this.channelValue(channels, answer[1].channel));
        }
      }
    }
  }, {
    key: 'hideAndShowTemplateTypeChoice',
    value: function hideAndShowTemplateTypeChoice(change) {
      if (change !== this.state.showTemplateTypeChoice) {
        this.setState(function (prevState) {
          return {
            showTemplateTypeChoice: !prevState.showTemplateTypeChoice
          };
        });
      }
    }
  }, {
    key: 'toggle',
    value: function toggle() {
      this.setState(function (prevState) {
        return {
          dropdownOpen: !prevState.dropdownOpen
        };
      });
    }
  }, {
    key: 'toggleLanguageDropdown',
    value: function toggleLanguageDropdown() {
      this.setState(function (prevState) {
        return {
          languageDropdownOpen: !prevState.languageDropdownOpen
        };
      });
    }
  }, {
    key: 'togglePreview',
    value: function togglePreview(_ref) {
      var enabled = _ref.enabled;

      this.setState({
        preview: enabled
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var _props5 = this.props,
          answer = _props5.answer,
          showFormatChoicer = _props5.showFormatChoicer,
          onResponeTypeChange = _props5.onResponeTypeChange,
          hideSaveButton = _props5.hideSaveButton,
          s3config = _props5.s3config,
          templateName = _props5.templateName,
          savedTemplateName = _props5.savedTemplateName,
          showTemplateName = _props5.showTemplateName,
          channel = _props5.channel,
          hidelangDropdown = _props5.hidelangDropdown,
          hideChannelDropdown = _props5.hideChannelDropdown,
          channels = _props5.channels,
          languages = _props5.languages,
          S3_bucketDetails = _props5.S3_bucketDetails;
      var currentIndex = this.props.currentIndex;

      var existingChannels = answer.map(function (ans) {
        return ans.channel;
      });
      var isEmpty = templateTypeFilter.answerValidation(answer[currentIndex]).length;
      return React.createElement(
        'div',
        { className: 'bot-response', __source: {
            fileName: _jsxFileName,
            lineNumber: 355
          },
          __self: this
        },
        React.createElement(
          'div',
          { className: 'bot-response__header', __source: {
              fileName: _jsxFileName,
              lineNumber: 356
            },
            __self: this
          },
          answer[currentIndex].messages.length !== 0 && showTemplateName && React.createElement(
            'div',
            { className: 'bot-response__TemplateName', __source: {
                fileName: _jsxFileName,
                lineNumber: 358
              },
              __self: this
            },
            React.createElement(
              'label',
              {
                __source: {
                  fileName: _jsxFileName,
                  lineNumber: 359
                },
                __self: this
              },
              'TemplateName:',
              savedTemplateName && savedTemplateName.trim().length !== 0 ? React.createElement(
                'span',
                {
                  __source: {
                    fileName: _jsxFileName,
                    lineNumber: 362
                  },
                  __self: this
                },
                ' ',
                savedTemplateName
              ) : React.createElement(
                'span',
                {
                  __source: {
                    fileName: _jsxFileName,
                    lineNumber: 364
                  },
                  __self: this
                },
                React.createElement('input', {
                  placeholder: 'Enter Template Name',
                  maxLength: 50,
                  className: 'templateNameInput mt-2 m-t-2 ml-2 m-l-2',
                  value: templateName,
                  rows: '2',
                  onChange: function onChange(event) {
                    return _this3.props.onTemplateNameChange(event.target.value);
                  },
                  __source: {
                    fileName: _jsxFileName,
                    lineNumber: 365
                  },
                  __self: this
                }),
                React.createElement(
                  'span',
                  {
                    className: cx('wordCount', templateName && templateName.length >= 44 && 'bg-r'), __source: {
                      fileName: _jsxFileName,
                      lineNumber: 375
                    },
                    __self: this
                  },
                  50 - (templateName ? templateName.length : 0)
                )
              )
            )
          ),
          React.createElement(
            'div',
            { className: 'bot-response__headerItemWrapper', __source: {
                fileName: _jsxFileName,
                lineNumber: 387
              },
              __self: this
            },
            answer.map(function (answer, index) {
              return React.createElement(
                'div',
                { key: index, __source: {
                    fileName: _jsxFileName,
                    lineNumber: 389
                  },
                  __self: _this3
                },
                index === currentIndex && React.createElement(
                  'div',
                  {
                    className: cx('bot-response__headerItem', {
                      'bot-response__headerItemActive': index === currentIndex
                    }),
                    key: index,
                    role: 'button',
                    onClick: function onClick(event) {
                      _this3.props.onChannelClick(index);
                      _this3.onChannelClick(event.target.value);
                    }, __source: {
                      fileName: _jsxFileName,
                      lineNumber: 391
                    },
                    __self: _this3
                  },
                  answer.channel,
                  !!index && false && React.createElement(
                    'i',
                    {
                      className: 'material-icons',
                      role: 'button',
                      onClick: function onClick(event) {
                        event.preventDefault();
                        event.stopPropagation();
                        _this3.props.onRemoveChannel(index);
                      }, __source: {
                        fileName: _jsxFileName,
                        lineNumber: 403
                      },
                      __self: _this3
                    },
                    'close'
                  )
                )
              );
            })
          ),
          React.createElement(
            'div',
            { className: 'd-flex align-items-center', __source: {
                fileName: _jsxFileName,
                lineNumber: 419
              },
              __self: this
            },
            React.createElement(TemplateImportExport, {
              answer: this.props.answer,
              onAnswerChange: this.props.onAnswerChange,
              __source: {
                fileName: _jsxFileName,
                lineNumber: 420
              },
              __self: this
            }),
            answer[currentIndex].messages.length !== 0 && React.createElement(ToggleSwitch, {
              className: 'bot-response__previewToggle',
              enabled: this.state.preview,
              onStateChanged: this.togglePreview,
              label: 'Preview',
              __source: {
                fileName: _jsxFileName,
                lineNumber: 425
              },
              __self: this
            }),
            (channels.length && !channel) > 0 ? React.createElement(
              'div',
              { className: 'bot-response__headerChannel', __source: {
                  fileName: _jsxFileName,
                  lineNumber: 433
                },
                __self: this
              },
              React.createElement(
                'span',
                { className: 'font-weight-light h6 mb-0 mr-2 m-r-2 ml-2 m-l-2 text-dark', __source: {
                    fileName: _jsxFileName,
                    lineNumber: 434
                  },
                  __self: this
                },
                'Channel:'
              ),
              hideChannelDropdown ? React.createElement(
                'span',
                { className: 'font-weight-dark h6 mb-0 mr-2 m-r-2 text-dark', __source: {
                    fileName: _jsxFileName,
                    lineNumber: 438
                  },
                  __self: this
                },
                channel ? channel : 'Default'
              ) : React.createElement(
                Dropdown,
                {
                  isOpen: this.state.dropdownOpen,
                  toggle: this.toggle,
                  id: 'channelResponse', __source: {
                    fileName: _jsxFileName,
                    lineNumber: 442
                  },
                  __self: this
                },
                React.createElement(
                  DropdownToggle,
                  { caret: true, __source: {
                      fileName: _jsxFileName,
                      lineNumber: 446
                    },
                    __self: this
                  },
                  this.state.channel
                ),
                React.createElement(
                  DropdownMenu,
                  {
                    __source: {
                      fileName: _jsxFileName,
                      lineNumber: 447
                    },
                    __self: this
                  },
                  React.createElement(
                    DropdownItem,
                    {
                      onClick: function onClick() {
                        _this3.onChannelClick('default');
                      },
                      className: cx(existingChannels[currentIndex] === 'default' && 'font-weight-bold'),
                      disabled: existingChannels[currentIndex] === 'default' ? true : false, __source: {
                        fileName: _jsxFileName,
                        lineNumber: 448
                      },
                      __self: this
                    },
                    'default'
                  ),
                  channels.map(function (channel, key) {
                    return !existingChannels.includes(channel.key) ? React.createElement(
                      DropdownItem,
                      {
                        onClick: function onClick() {
                          return _this3.onAddNewChannel(channel);
                        },
                        key: key, __source: {
                          fileName: _jsxFileName,
                          lineNumber: 465
                        },
                        __self: _this3
                      },
                      channel.value
                    ) : React.createElement(
                      DropdownItem,
                      {
                        onClick: function onClick() {
                          _this3.onChannelClick(channel.value);
                        },
                        className: cx(existingChannels[currentIndex].toLowerCase() === channel.key.toLowerCase() && 'font-weight-bold'),
                        disabled: existingChannels[currentIndex].toLowerCase() === channel.key.toLowerCase() ? true : false,
                        key: key, __source: {
                          fileName: _jsxFileName,
                          lineNumber: 471
                        },
                        __self: _this3
                      },
                      channel.value
                    );
                  })
                )
              ),
              React.createElement(
                'span',
                {
                  className: cx('font-weight-light h6 mb-0 ml-4 m-l-4 mr-2 m-r-2 text-dark', this.state.hideLanguageDropdown && 'display-none'), __source: {
                    fileName: _jsxFileName,
                    lineNumber: 493
                  },
                  __self: this
                },
                'Language:'
              ),
              hidelangDropdown ? React.createElement(
                'span',
                {
                  className: cx('font-weight-dark h6 mb-0 mr-2 m-r-2 text-dark', this.state.hideLanguageDropdown && 'display-none'), __source: {
                    fileName: _jsxFileName,
                    lineNumber: 501
                  },
                  __self: this
                },
                this.languageValue(languages, answer[currentIndex].language)
              ) : React.createElement(
                Dropdown,
                {
                  id: 'channelResponse',
                  className: cx(this.state.hideLanguageDropdown && 'display-none'),
                  isOpen: this.state.languageDropdownOpen,
                  toggle: this.toggleLanguageDropdown, __source: {
                    fileName: _jsxFileName,
                    lineNumber: 512
                  },
                  __self: this
                },
                React.createElement(
                  DropdownToggle,
                  { caret: true, __source: {
                      fileName: _jsxFileName,
                      lineNumber: 519
                    },
                    __self: this
                  },
                  this.languageValue(languages, this.state.langCode)
                ),
                React.createElement(
                  DropdownMenu,
                  {
                    __source: {
                      fileName: _jsxFileName,
                      lineNumber: 522
                    },
                    __self: this
                  },
                  languages.map(function (language) {
                    return React.createElement(
                      DropdownItem,
                      {
                        onClick: function onClick() {
                          _this3.onLanguageChange(language.key);
                        },
                        disabled: language === _this3.state.langCode ? true : false, __source: {
                          fileName: _jsxFileName,
                          lineNumber: 525
                        },
                        __self: _this3
                      },
                      language.value
                    );
                  })
                )
              )
            ) : React.createElement(
              'div',
              {
                __source: {
                  fileName: _jsxFileName,
                  lineNumber: 541
                },
                __self: this
              },
              React.createElement(
                'span',
                { className: 'font-weight-light h6 mb-0 mr-2 m-r-2 ml-2 m-l-2 text-dark', __source: {
                    fileName: _jsxFileName,
                    lineNumber: 542
                  },
                  __self: this
                },
                'Channel:'
              ),
              hideChannelDropdown ? React.createElement(
                'span',
                { className: 'font-weight-dark h6 mb-0 mr-2 m-r-2 text-dark', __source: {
                    fileName: _jsxFileName,
                    lineNumber: 546
                  },
                  __self: this
                },
                channel ? channel : 'Default'
              ) : React.createElement(
                Dropdown,
                {
                  isOpen: this.state.dropdownOpen,
                  toggle: this.toggle,
                  id: 'channelResponse', __source: {
                    fileName: _jsxFileName,
                    lineNumber: 550
                  },
                  __self: this
                },
                React.createElement(
                  DropdownToggle,
                  {
                    __source: {
                      fileName: _jsxFileName,
                      lineNumber: 554
                    },
                    __self: this
                  },
                  this.state.channel
                ),
                React.createElement(
                  DropdownMenu,
                  {
                    __source: {
                      fileName: _jsxFileName,
                      lineNumber: 555
                    },
                    __self: this
                  },
                  React.createElement(
                    DropdownItem,
                    {
                      onClick: function onClick() {
                        _this3.onChannelClick(channel || 'default');
                      },
                      className: cx((existingChannels[currentIndex] === 'default' || existingChannels[currentIndex].toLowerCase() === channel.toLowerCase()) && 'font-weight-bold'),
                      disabled: existingChannels[currentIndex] === 'default' || existingChannels[currentIndex].toLowerCase() === channel.toLowerCase() ? true : false, __source: {
                        fileName: _jsxFileName,
                        lineNumber: 556
                      },
                      __self: this
                    },
                    channel ? channel : 'default'
                  )
                )
              ),
              React.createElement(
                'span',
                {
                  className: cx('font-weight-light h6 mb-0 ml-4 m-l-4 mr-2 m-r-2 text-dark', this.state.hideLanguageDropdown && 'display-none'), __source: {
                    fileName: _jsxFileName,
                    lineNumber: 578
                  },
                  __self: this
                },
                'Language:'
              ),
              hidelangDropdown ? React.createElement(
                'span',
                {
                  className: cx('font-weight-dark h6 mb-0 mr-2 m-r-2 text-dark', this.state.hideLanguageDropdown && 'display-none'), __source: {
                    fileName: _jsxFileName,
                    lineNumber: 586
                  },
                  __self: this
                },
                this.languageValue(languages, answer[currentIndex].language)
              ) : React.createElement(
                Dropdown,
                {
                  id: 'channelResponse',
                  className: cx(this.state.hideLanguageDropdown && 'display-none'),
                  isOpen: this.state.languageDropdownOpen,
                  toggle: this.toggleLanguageDropdown, __source: {
                    fileName: _jsxFileName,
                    lineNumber: 597
                  },
                  __self: this
                },
                React.createElement(
                  DropdownToggle,
                  { caret: true, __source: {
                      fileName: _jsxFileName,
                      lineNumber: 604
                    },
                    __self: this
                  },
                  this.languageValue(languages, this.state.langCode)
                ),
                React.createElement(
                  DropdownMenu,
                  {
                    __source: {
                      fileName: _jsxFileName,
                      lineNumber: 607
                    },
                    __self: this
                  },
                  languages.map(function (language) {
                    return React.createElement(
                      DropdownItem,
                      {
                        onClick: function onClick() {
                          _this3.onLanguageChange(language.key);
                        },
                        disabled: language === _this3.state.langCode ? true : false, __source: {
                          fileName: _jsxFileName,
                          lineNumber: 610
                        },
                        __self: _this3
                      },
                      language.value
                    );
                  })
                )
              )
            ),
            isEmpty !== 0 && React.createElement(
              'div',
              { className: 'ml-4 m-l-4', __source: {
                  fileName: _jsxFileName,
                  lineNumber: 628
                },
                __self: this
              },
              answer[currentIndex].save ? React.createElement(
                'button',
                {
                  className: cx('btn btn-primary', hideSaveButton && 'display-none'),
                  href: '#',
                  onClick: function onClick() {
                    return _this3.props.alterSave();
                  }, __source: {
                    fileName: _jsxFileName,
                    lineNumber: 630
                  },
                  __self: this
                },
                'Edit'
              ) : React.createElement(
                'button',
                {
                  className: cx('btn btn-primary', hideSaveButton && 'display-none'),
                  href: '#',
                  onClick: function onClick() {
                    _this3.hideAndShowTemplateTypeChoice(true);
                    _this3.props.handleAnswerSave(answer, currentIndex);
                  }, __source: {
                    fileName: _jsxFileName,
                    lineNumber: 640
                  },
                  __self: this
                },
                'Save'
              )
            )
          )
        ),
        showFormatChoicer ? null : React.createElement(
          'div',
          {
            __source: {
              fileName: _jsxFileName,
              lineNumber: 658
            },
            __self: this
          },
          answer[currentIndex] && answer[currentIndex].messages.length !== 0 && React.createElement(TemplateItem, {
            answer: answer[currentIndex],
            hideAndShowTemplateTypeChoice: this.hideAndShowTemplateTypeChoice,
            onFormatChange: function onFormatChange() {
              return _this3.setState({ showFormatChoicer: true });
            },
            onAnswerChange: function onAnswerChange(answer) {
              _this3.props.onAnswerChange(answer, currentIndex);
            },
            onResponeTypeChange: onResponeTypeChange,
            s3config: s3config,
            intentId: this.props.intentId,
            onTemplateNameChange: function onTemplateNameChange(value) {
              return _this3.props.onTemplateNameChange && _this3.props.onTemplateNameChange(value);
            },
            preview: this.state.preview,
            channel: answer[currentIndex].channel,
            langCode: this.state.langCode,
            S3_bucketDetails: S3_bucketDetails,
            __source: {
              fileName: _jsxFileName,
              lineNumber: 661
            },
            __self: this
          })
        ),
        this.state.showTemplateTypeChoice ? React.createElement(TemplateTypeChoice, {
          types: this.state.responseTypes,
          hideAndShowTemplateTypeChoice: this.hideAndShowTemplateTypeChoice,
          onTypeChange: this.props.onTypeChange,
          editTemplate: this.props.editTemplate,
          showCustomTemplates: this.props.showCustomTemplates,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 688
          },
          __self: this
        }) : null
      );
    }
  }]);

  return Template;
}(React.Component);

export default Template;