var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _jsxFileName = 'src/lib/components/TemplateButton.js',
    _this = this;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import cx from 'classnames';

import IconLink from '../assets/icons/iconIcLink';
import IconBlock from '../assets/icons/iconBlock';
import { someobj, findobjIndex, findobj } from '../utility/utility';
var __checkBoxes = [{
  key: 'data-buttons',
  value: 'true'
}, {
  key: 'data-title',
  value: '' // BUTTON TITLE
}, {
  key: 'data-button-life',
  options: ['WOLO', 'OLO', 'YOLO', 'IMMORTAL'], // RADIO BUTTONS
  value: ''
}];

var Select = function Select(_ref) {
  var _ref$type = _ref.type,
      type = _ref$type === undefined ? 'checkbox' : _ref$type,
      name = _ref.name,
      _ref$checked = _ref.checked,
      checked = _ref$checked === undefined ? false : _ref$checked,
      onChange = _ref.onChange;
  return React.createElement('input', { type: type, name: name, checked: checked, onChange: onChange, __source: {
      fileName: _jsxFileName,
      lineNumber: 24
    },
    __self: _this
  });
};

var TemplateButton = function (_Component) {
  _inherits(TemplateButton, _Component);

  function TemplateButton(props) {
    _classCallCheck(this, TemplateButton);

    var _this2 = _possibleConstructorReturn(this, (TemplateButton.__proto__ || Object.getPrototypeOf(TemplateButton)).call(this, props));

    _this2.state = {
      value: ''
    };
    _this2.handleDataButtonLifeRadioChange = _this2.handleDataButtonLifeRadioChange.bind(_this2);
    _this2.onButtonHeaderChange = _this2.onButtonHeaderChange.bind(_this2);
    _this2.onAddAttributes = _this2.onAddAttributes.bind(_this2);
    _this2.onAttributesChange = _this2.onAttributesChange.bind(_this2);
    _this2.onRemoveAttributes = _this2.onRemoveAttributes.bind(_this2);
    return _this2;
  }

  _createClass(TemplateButton, [{
    key: 'handleChange',
    value: function handleChange(e, key) {
      var _props = this.props,
          index = _props.index,
          content = _props.content,
          onButtonChange = _props.onButtonChange;


      var __checkedItems = Object.assign(content.attributes || [], []);
      var checkBoxes = JSON.parse(JSON.stringify(__checkBoxes));
      var attr = { key: '', value: '' };
      if (someobj(__checkedItems, { key: key })) {
        __checkedItems.splice(findobjIndex(__checkedItems, { key: key }), 1);
      } else {
        attr.key = key;
        attr.value = findobj(checkBoxes, { key: key }).value;
        if (key === 'data-title') {
          attr.key = key;
          attr.value = content.title || '';
        }
        if (key === 'data-button-life') {
          if (__checkedItems[index]) {
            delete __checkedItems[index].options;
          }
        }
        __checkedItems.push(attr);
      }

      onButtonChange(__checkedItems, index, 'attributes');
    }
  }, {
    key: 'onButtonHeaderChange',
    value: function onButtonHeaderChange(event) {
      var _props2 = this.props,
          attributes = _props2.content.attributes,
          index = _props2.index,
          onButtonChange = _props2.onButtonChange;

      if (attributes && someobj(attributes, { key: 'data-title' })) {
        var __attrIndex = findobjIndex(attributes, { key: 'data-title' });
        attributes[__attrIndex].value = event.target.value;
        onButtonChange(attributes, index, 'attributes');
      }
      onButtonChange(event.target.value, index, 'title');
      this.setState({
        value: event.target.value
      });
    }
  }, {
    key: 'handleDataButtonLifeRadioChange',
    value: function handleDataButtonLifeRadioChange(event) {
      var _props3 = this.props,
          attributes = _props3.content.attributes,
          index = _props3.index,
          onButtonChange = _props3.onButtonChange;

      var attr = {};
      attr.key = 'data-button-life';
      attr.value = event.target.value;
      if (someobj(attributes, { key: 'data-button-life' })) {
        attributes.splice(findobjIndex(attributes, { key: 'data-button-life' }), 1);
      }
      attributes.push(attr);
      onButtonChange(attributes, index, 'attributes');
    }
  }, {
    key: 'onAddAttributes',
    value: function onAddAttributes() {
      var _props4 = this.props,
          attributes = _props4.content.attributes,
          index = _props4.index,
          onButtonChange = _props4.onButtonChange;

      if (!attributes) {
        attributes = [];
      }
      attributes.push({
        key: '',
        value: ''
      });
      onButtonChange(attributes, index, 'attributes');
    }
  }, {
    key: 'onAttributesChange',
    value: function onAttributesChange(value, field, key, i) {
      var _props5 = this.props,
          attributes = _props5.content.attributes,
          index = _props5.index,
          onButtonChange = _props5.onButtonChange;

      if (field === 'key') {
        attributes[i].key = value;
      } else {
        attributes[i].value = value;
      }
      onButtonChange(attributes, index, 'attributes');
    }
  }, {
    key: 'onRemoveAttributes',
    value: function onRemoveAttributes(key) {
      var _props6 = this.props,
          attributes = _props6.content.attributes,
          index = _props6.index,
          onButtonChange = _props6.onButtonChange;

      attributes.splice(findobjIndex(attributes, { key: key }), 1);
      onButtonChange(attributes, index, 'attributes');
    }
  }, {
    key: 'renderButtonValueItems',
    value: function renderButtonValueItems(key, handleDataButtonLifeRadioChange, index) {
      var _this3 = this;

      var attributes = this.props.content.attributes;

      switch (key) {
        case 'data-button-life':
          var radioListItems = ['WOLO', 'OLO', 'YOLO', 'IMMORTAL'];
          return React.createElement(
            'form',
            {
              __source: {
                fileName: _jsxFileName,
                lineNumber: 152
              },
              __self: this
            },
            radioListItems.map(function (item) {
              return React.createElement(
                'div',
                { className: 'radio m-l-2 ml-2 buttonliferadiobttns', __source: {
                    fileName: _jsxFileName,
                    lineNumber: 155
                  },
                  __self: _this3
                },
                React.createElement(
                  'label',
                  {
                    __source: {
                      fileName: _jsxFileName,
                      lineNumber: 156
                    },
                    __self: _this3
                  },
                  React.createElement('input', {
                    type: 'radio',
                    value: item,
                    onChange: function onChange(event) {
                      return handleDataButtonLifeRadioChange(event);
                    },
                    checked: someobj(attributes, { key: 'data-button-life' }) && someobj(attributes, { value: item }) ? true : false,
                    __source: {
                      fileName: _jsxFileName,
                      lineNumber: 157
                    },
                    __self: _this3
                  }),
                  item
                )
              );
            })
          );
        default:
          break;
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this4 = this;

      var _props7 = this.props,
          placeholder = _props7.placeholder,
          id = _props7.id,
          index = _props7.index,
          onButtonChange = _props7.onButtonChange,
          content = _props7.content,
          field = _props7.field,
          display = _props7.display,
          intentId = _props7.intentId,
          uniqueKey = _props7.uniqueKey;

      var attributes = [];
      if (content && content.attributes) {
        attributes = content.attributes;
        if (!(attributes instanceof Array)) {
          var keys = Object.keys(attributes);
          var Items = [];
          keys.map(function (key) {
            var obj = {
              key: key,
              value: attributes[key].value
            };
            Items.push(obj);
            return 0;
          });
          attributes = Items;
          content.attributes = attributes;
        }
      }

      var defaultPostBackValue = intentId ? '{"data":{"options":"no"}, "intent": "' + intentId + '"}' : '{"data":{"options":"no"}, "intent": ""}';
      var type = content && content.type ? content.type : 'postback';
      var postback = type === 'postback' && true;
      var externalUrl = type === 'externalUrl' && true;
      var weburl = type === 'weburl' && true;
      var checkBoxes = JSON.parse(JSON.stringify(__checkBoxes));
      return React.createElement(
        'div',
        { className: 'modal buttonModal', id: id, style: { display: display }, __source: {
            fileName: _jsxFileName,
            lineNumber: 219
          },
          __self: this
        },
        React.createElement(
          'div',
          { className: 'modal-dialog', __source: {
              fileName: _jsxFileName,
              lineNumber: 220
            },
            __self: this
          },
          React.createElement(
            'div',
            { className: 'modal-content', __source: {
                fileName: _jsxFileName,
                lineNumber: 221
              },
              __self: this
            },
            React.createElement(
              'div',
              { className: 'modal-header', __source: {
                  fileName: _jsxFileName,
                  lineNumber: 222
                },
                __self: this
              },
              React.createElement(
                'div',
                {
                  className: 'button-header-contents',
                  style: { position: 'relative' }, __source: {
                    fileName: _jsxFileName,
                    lineNumber: 223
                  },
                  __self: this
                },
                React.createElement(
                  'p',
                  {
                    __source: {
                      fileName: _jsxFileName,
                      lineNumber: 226
                    },
                    __self: this
                  },
                  'If subscriber clicks'
                ),
                React.createElement('textarea', {
                  disabled: content && content.type === 'show more' ? true : false,
                  className: 'bot-response__ItemTextArea',
                  cols: '5',
                  rows: content && content.title.length > 29 ? 3 : 1,
                  placeholder: placeholder,
                  value: content && content.title,
                  key: '' + uniqueKey + id + '-title',
                  onChange: function onChange(event) {
                    return _this4.onButtonHeaderChange(event);
                  },
                  __source: {
                    fileName: _jsxFileName,
                    lineNumber: 227
                  },
                  __self: this
                })
              ),
              React.createElement(
                'button',
                {
                  type: 'button',
                  onClick: function onClick() {
                    return _this4.props.onHideModal(index);
                  },
                  className: 'close',
                  'data-target': '#' + id, __source: {
                    fileName: _jsxFileName,
                    lineNumber: 242
                  },
                  __self: this
                },
                '\xD7'
              )
            ),
            React.createElement(
              'div',
              { className: 'modal-body', __source: {
                  fileName: _jsxFileName,
                  lineNumber: 250
                },
                __self: this
              },
              React.createElement(
                'ul',
                { className: 'state-selector', __source: {
                    fileName: _jsxFileName,
                    lineNumber: 251
                  },
                  __self: this
                },
                React.createElement(
                  'li',
                  {
                    className: cx('blocks', postback && 'act'),
                    onClick: function onClick(event) {
                      return !postback && onButtonChange(defaultPostBackValue, index, 'postback');
                    }, __source: {
                      fileName: _jsxFileName,
                      lineNumber: 252
                    },
                    __self: this
                  },
                  React.createElement(IconBlock, {
                    __source: {
                      fileName: _jsxFileName,
                      lineNumber: 258
                    },
                    __self: this
                  }),
                  React.createElement(
                    'span',
                    {
                      __source: {
                        fileName: _jsxFileName,
                        lineNumber: 259
                      },
                      __self: this
                    },
                    'postback'
                  )
                ),
                React.createElement(
                  'li',
                  {
                    className: cx('url', externalUrl && 'act'),
                    onClick: function onClick(event) {
                      return !externalUrl && onButtonChange('', index, 'externalUrl');
                    }, __source: {
                      fileName: _jsxFileName,
                      lineNumber: 261
                    },
                    __self: this
                  },
                  React.createElement(IconLink, {
                    __source: {
                      fileName: _jsxFileName,
                      lineNumber: 266
                    },
                    __self: this
                  }),
                  React.createElement(
                    'span',
                    {
                      __source: {
                        fileName: _jsxFileName,
                        lineNumber: 267
                      },
                      __self: this
                    },
                    'External URL'
                  )
                ),
                React.createElement(
                  'li',
                  {
                    className: cx('url', weburl && 'act'),
                    onClick: function onClick(event) {
                      return !weburl && onButtonChange('', index, 'weburl');
                    }, __source: {
                      fileName: _jsxFileName,
                      lineNumber: 269
                    },
                    __self: this
                  },
                  React.createElement(IconLink, {
                    __source: {
                      fileName: _jsxFileName,
                      lineNumber: 274
                    },
                    __self: this
                  }),
                  React.createElement(
                    'span',
                    {
                      __source: {
                        fileName: _jsxFileName,
                        lineNumber: 275
                      },
                      __self: this
                    },
                    'weburl'
                  )
                )
              )
            ),
            React.createElement(
              'div',
              { className: 'modal-footers mb-2 m-b-2', __source: {
                  fileName: _jsxFileName,
                  lineNumber: 279
                },
                __self: this
              },
              postback && React.createElement(
                'div',
                { className: 'blocksRender', __source: {
                    fileName: _jsxFileName,
                    lineNumber: 282
                  },
                  __self: this
                },
                React.createElement('textarea', {
                  className: 'bot-response__ItemTextArea',
                  cols: '5',
                  rows: '2',
                  placeholder: 'Enter postback data',
                  key: '' + uniqueKey + id + '-postback',
                  onChange: function onChange(event) {
                    _this4.setState({ value: event.target.value });
                    onButtonChange(event.target.value, index, 'postback');
                  },
                  value: content && content[field],
                  __source: {
                    fileName: _jsxFileName,
                    lineNumber: 283
                  },
                  __self: this
                })
              ),
              externalUrl && React.createElement(
                'div',
                { className: 'urlRender', __source: {
                    fileName: _jsxFileName,
                    lineNumber: 298
                  },
                  __self: this
                },
                React.createElement('textarea', {
                  className: 'bot-response__ItemTextArea',
                  cols: '5',
                  rows: '2',
                  placeholder: 'Enter a external URL',
                  key: '' + uniqueKey + id + '-externalUrl',
                  onChange: function onChange(event) {
                    _this4.setState({ value: event.target.value.trim() });
                    onButtonChange(event.target.value.trim(), index, 'externalUrl');
                  },
                  value: content && content[field],
                  __source: {
                    fileName: _jsxFileName,
                    lineNumber: 299
                  },
                  __self: this
                })
              ),
              weburl && React.createElement(
                'div',
                { className: 'urlRender', __source: {
                    fileName: _jsxFileName,
                    lineNumber: 314
                  },
                  __self: this
                },
                React.createElement('textarea', {
                  className: 'bot-response__ItemTextArea',
                  cols: '5',
                  rows: '2',
                  placeholder: 'Enter a external URL',
                  key: '' + uniqueKey + id + '-weburl',
                  onChange: function onChange(event) {
                    _this4.setState({ value: event.target.value.trim() });
                    onButtonChange(event.target.value.trim(), index, 'weburl');
                  },
                  value: content && content[field],
                  __source: {
                    fileName: _jsxFileName,
                    lineNumber: 315
                  },
                  __self: this
                })
              ),
              React.createElement(
                'div',
                { className: 'border-top', __source: {
                    fileName: _jsxFileName,
                    lineNumber: 330
                  },
                  __self: this
                },
                React.createElement(
                  'p',
                  { className: 'mt-2 m-l-2 ml-4 m-l-4', __source: {
                      fileName: _jsxFileName,
                      lineNumber: 331
                    },
                    __self: this
                  },
                  'Attributes'
                ),
                React.createElement(
                  'ul',
                  { className: 'ml-4 m-l-4 bot-response__SelectAttributes', __source: {
                      fileName: _jsxFileName,
                      lineNumber: 332
                    },
                    __self: this
                  },
                  checkBoxes.map(function (item, index) {
                    return React.createElement(
                      'li',
                      { className: '', __source: {
                          fileName: _jsxFileName,
                          lineNumber: 335
                        },
                        __self: _this4
                      },
                      React.createElement(
                        'label',
                        { key: index, __source: {
                            fileName: _jsxFileName,
                            lineNumber: 336
                          },
                          __self: _this4
                        },
                        React.createElement(Select, {
                          name: item.key,
                          checked: attributes && attributes.length > 0 && someobj(attributes, { key: item.key }),
                          onChange: function onChange(e) {
                            return _this4.handleChange(e, item.key);
                          },
                          __source: {
                            fileName: _jsxFileName,
                            lineNumber: 337
                          },
                          __self: _this4
                        }),
                        item.key,
                        attributes && attributes.length > 0 && someobj(attributes, { key: item.key }) && _this4.renderButtonValueItems(item.key, _this4.handleDataButtonLifeRadioChange, index)
                      )
                    );
                  })
                )
              ),
              React.createElement(
                'div',
                { className: 'border-top', __source: {
                    fileName: _jsxFileName,
                    lineNumber: 361
                  },
                  __self: this
                },
                React.createElement(
                  'div',
                  { className: 'bot-response__addExtraAttributes', key: index, __source: {
                      fileName: _jsxFileName,
                      lineNumber: 362
                    },
                    __self: this
                  },
                  attributes && attributes.length > 0 && attributes.map(function (attr, index) {
                    if (!someobj(__checkBoxes, { key: attr.key })) {
                      return React.createElement(
                        'div',
                        { className: 'addAttributes d-flex m-t-3 mt-3 ml-3 m-l-3 mr-3 m-r-3', __source: {
                            fileName: _jsxFileName,
                            lineNumber: 368
                          },
                          __self: _this4
                        },
                        React.createElement('input', {
                          type: 'text',
                          className: 'bot-response__inputMedium',
                          placeholder: 'Enter attribute key',
                          value: attr.key,
                          key: '' + uniqueKey + id + index + '-attrKey',
                          onChange: function onChange(event) {
                            _this4.setState({ value: event.target.value });
                            _this4.onAttributesChange(event.target.value, 'key', attr, index);
                          },
                          __source: {
                            fileName: _jsxFileName,
                            lineNumber: 369
                          },
                          __self: _this4
                        }),
                        React.createElement('input', {
                          type: 'text',
                          className: 'bot-response__inputMedium ml-1',
                          placeholder: 'Enter attibute value',
                          value: attributes[index].key === attr.key && attr.value,
                          key: '' + uniqueKey + id + index + '-attrValue',
                          onChange: function onChange(event) {
                            _this4.setState({ value: event.target.value });
                            _this4.onAttributesChange(event.target.value, 'value', attr, index);
                          },
                          __source: {
                            fileName: _jsxFileName,
                            lineNumber: 385
                          },
                          __self: _this4
                        }),
                        React.createElement(
                          'span',
                          {
                            className: ' ml-1',
                            role: 'button',
                            onClick: function onClick() {
                              return _this4.onRemoveAttributes(attr);
                            }, __source: {
                              fileName: _jsxFileName,
                              lineNumber: 403
                            },
                            __self: _this4
                          },
                          '\xD7'
                        )
                      );
                    }
                  })
                ),
                React.createElement(
                  'button',
                  {
                    className: 'btn btn-primary ml-2 m-l-2 mt-2 m-t-2 mb-2 m-b-2',
                    onClick: this.onAddAttributes, __source: {
                      fileName: _jsxFileName,
                      lineNumber: 414
                    },
                    __self: this
                  },
                  'Add Attributes'
                )
              )
            )
          )
        )
      );
    }
  }]);

  return TemplateButton;
}(Component);

export default TemplateButton;