import _regeneratorRuntime from 'babel-runtime/regenerator';
var _jsxFileName = 'src/lib/components/TemplateImportExport.js';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import FileSaver from 'file-saver';
import { toast } from 'react-toastify';
import IconImport from '../assets/icons/iconImport';
import IconExport from '../assets/icons/iconExport';
import { isJsonValid, sanitizeJSON, desanitizeJSON } from '../utility/utility';

var TemplateImportExport = function (_Component) {
  _inherits(TemplateImportExport, _Component);

  function TemplateImportExport(props) {
    _classCallCheck(this, TemplateImportExport);

    var _this = _possibleConstructorReturn(this, (TemplateImportExport.__proto__ || Object.getPrototypeOf(TemplateImportExport)).call(this, props));

    _this.handleTemplateImport = _this.handleTemplateImport.bind(_this);
    _this.handleTemplateExport = _this.handleTemplateExport.bind(_this);
    return _this;
  }

  _createClass(TemplateImportExport, [{
    key: 'handleTemplateExport',
    value: function handleTemplateExport() {
      var answer = this.props.answer;

      var templateSON = JSON.stringify(sanitizeJSON(answer));
      var blob = new Blob([templateSON], {
        type: 'octet/stream;charset=utf-8'
      });
      FileSaver.saveAs(blob, 'template.json');
    }
  }, {
    key: 'handleTemplateImport',
    value: function handleTemplateImport(event) {
      var _this2 = this;

      var files = Array.from(event.target.files);
      if (files.length > 0) {
        var file = files[0];
        var reader = new FileReader();
        reader.onload = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
          var isValidJson, templateJson;
          return _regeneratorRuntime.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  _context.next = 2;
                  return isJsonValid(reader.result);

                case 2:
                  isValidJson = _context.sent;

                  if (isValidJson) {
                    templateJson = desanitizeJSON(JSON.parse(reader.result));

                    templateJson.forEach(function (answer, currentIndex) {
                      _this2.props.onAnswerChange(answer, currentIndex);
                    });
                    toast.success('Template Imported Successfully');
                  } else {
                    toast.error('JSON format is not valid.');
                  }

                case 4:
                case 'end':
                  return _context.stop();
              }
            }
          }, _callee, _this2);
        }));
        reader.readAsText(file);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      return React.createElement(
        'div',
        { className: 'bot-response__importExport d-flex', __source: {
            fileName: _jsxFileName,
            lineNumber: 45
          },
          __self: this
        },
        React.createElement(
          'div',
          { title: 'Export', className: 'bot-response__export', __source: {
              fileName: _jsxFileName,
              lineNumber: 46
            },
            __self: this
          },
          React.createElement(IconExport, { handleTemplateExport: this.handleTemplateExport, __source: {
              fileName: _jsxFileName,
              lineNumber: 47
            },
            __self: this
          })
        ),
        React.createElement(
          'div',
          { title: 'Import', className: 'bot-response__import', __source: {
              fileName: _jsxFileName,
              lineNumber: 49
            },
            __self: this
          },
          React.createElement('input', {
            type: 'file',
            accept: '.json',
            onChange: function onChange(event) {
              return _this3.handleTemplateImport(event);
            },
            __source: {
              fileName: _jsxFileName,
              lineNumber: 50
            },
            __self: this
          }),
          React.createElement(IconImport, {
            __source: {
              fileName: _jsxFileName,
              lineNumber: 55
            },
            __self: this
          })
        )
      );
    }
  }]);

  return TemplateImportExport;
}(Component);

export default TemplateImportExport;