var _jsxFileName = 'src/lib/components/TemplateItem.js';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import TemplateItemCard from './TemplateItemCard';
import TemplateQuickReply from './TemplateQuickReply';
import TemplateItemButtons from './TemplateItemButtons';
import TemplateItemCarousel from './TemplateItemCarousel';
import TemplateItemList from './TemplateItemList';
import TemplateItemRBList from './TemplateItemRBList';
import TemplateItemCustom from './TemplateItemCustom';
import TemplateItemImage from './TemplateItemImage';
import TextArea from './TemplateTextArea';
import TemplateTypeEdit from './TemplateTypeEdit';
import TemplateItemHook from './TemplateItemHook';
import TemplateSpeechResponse from './TemplateSpeechResponse';
import ToggleSwitch from '../atoms/Toggle';

var TemplateItem = function (_Component) {
  _inherits(TemplateItem, _Component);

  function TemplateItem(props) {
    _classCallCheck(this, TemplateItem);

    var _this = _possibleConstructorReturn(this, (TemplateItem.__proto__ || Object.getPrototypeOf(TemplateItem)).call(this, props));

    _this.state = {
      dropdownOpen: false,
      customTemplateAttributes: [],
      speechToggle: []
    };
    _this.props.onAnswerChange(_this.props.answer);
    _this.onCustomTemplateAttributesChange = _this.onCustomTemplateAttributesChange.bind(_this);
    _this.saveCustomTemplateAttributes = _this.saveCustomTemplateAttributes.bind(_this);
    _this.toggle = _this.toggle.bind(_this);
    _this.onAnswerChange = _this.onAnswerChange.bind(_this);
    _this.onDelete = _this.onDelete.bind(_this);
    _this.testImage = _this.testImage.bind(_this);
    _this.onMessagePosAlter = _this.onMessagePosAlter.bind(_this);
    _this.toggleSpeech = _this.toggleSpeech.bind(_this);
    return _this;
  }

  _createClass(TemplateItem, [{
    key: 'toggle',
    value: function toggle() {
      this.setState(function (prevState) {
        return {
          dropdownOpen: !prevState.dropdownOpen
        };
      });
    }
  }, {
    key: 'onAnswerChange',
    value: function onAnswerChange(data, field, index) {
      var answer = this.props.answer;

      if (field === 'quick_replies') {
        answer.messages[0][field] = data;
      } else {
        if (field === 'speechResponse') {
          if (data || typeof data !== 'boolean') {
            answer.messages[index][field] = typeof data === 'boolean' ? '' : data;
          } else {
            delete answer.messages[index][field];
          }
        } else {
          answer.messages[index][field] = data;
        }

        if (field === 'dynamicTemplate' && data === false) {
          delete answer.messages[index]['templateMarkup'];
          delete answer.messages[index]['dynamicTemplate'];
          if (answer.messages[index]['base'] === 'carousel') {
            delete answer.messages[index]['content'][0]['keyName'];
          } else {
            delete answer.messages[index]['content']['keyName'];
          }
          if (answer.messages[index]['base']) {
            answer.messages[index]['type'] = answer.messages[index]['base'];
            delete answer.messages[index]['base'];
          }
        }
      }

      if (field !== 'quick_replies' && (answer.messages[index].type === 'list' || answer.messages[index].base === 'list')) {
        var item = answer.messages[index].content.list[0];

        if (answer.messages[index].content.header && (answer.messages[index].content.header.image || answer.messages[index].content.header.title)) {
          if (!item.header) {
            var __header = answer.messages[index].content.header;
            __header.header = true;
            answer.messages[index].content.list.unshift(__header);
          }
          answer.messages[index].content.style = 'large';
        } else {
          if (item.header) {
            delete answer.messages[index].content.header.header;
            answer.messages[index].content.header.title = '';
            answer.messages[index].content.header.image = '';

            answer.messages[index].content.list.shift();
          }

          answer.messages[index].content.style = 'compact';
        }
      }

      this.props.onAnswerChange(answer);
    }
  }, {
    key: 'testImage',
    value: function testImage(url, timeoutT) {
      return new Promise(function (resolve, reject) {
        var timeout = timeoutT || 5000;
        var timer,
            img = new Image();
        img.onerror = img.onabort = function () {
          clearTimeout(timer);
          reject(false);
        };
        img.onload = function () {
          clearTimeout(timer);
          resolve(true);
        };
        timer = setTimeout(function () {
          img.src = '//!!!!/noexist.jpg';
          reject('timeout');
        }, timeout);
        img.src = url;
      });
    }
  }, {
    key: 'onDelete',
    value: function onDelete(index, flag) {
      var answer = this.props.answer;
      var messages = answer.messages;
      var speechToggle = this.state.speechToggle;

      speechToggle.splice(index, 1);
      if (typeof index === 'number' && messages[index].type === 'dynamic') {
        this.props.hideAndShowTemplateTypeChoice(true);
      }

      if (flag === 'quick_replies') {
        answer.messages[0].quick_replies = [];
      } else {
        if (index === 0 && messages.length > 1) {
          messages[1].quick_replies = messages[0].quick_replies;
        }
        messages.splice(index, 1);
        answer.messages = messages;
      }
      if (messages.length === 0) {
        this.props.onTemplateNameChange('');
      }
      this.props.onAnswerChange(answer);
      this.setState({
        speechToggle: speechToggle
      });
    }
  }, {
    key: 'onCustomTemplateAttributesChange',
    value: function onCustomTemplateAttributesChange(event, index, key) {
      var customTemplateAttributes = this.state.customTemplateAttributes;


      if (!customTemplateAttributes[index]) {
        customTemplateAttributes[index] = {};
      }

      if (key === 'base') {
        customTemplateAttributes[index][key] = event.target.innerText;
      } else {
        customTemplateAttributes[index][key] = event.target.value;
      }

      this.setState({
        customTemplateAttributes: customTemplateAttributes
      });
    }
  }, {
    key: 'onMessagePosAlter',
    value: function onMessagePosAlter(index, moveUp) {
      var _props = this.props,
          answer = _props.answer,
          messages = _props.answer.messages;

      var _messages = [].concat(messages);
      if (moveUp) {
        if (index === 1) {
          var quick_replies = [].concat(_messages[0].quick_replies);
          _messages[1].quick_replies = quick_replies;
          delete messages[0].quick_replies;
        }
        _messages.splice(index - 1, 0, _messages.splice(index, 1)[0]);
      } else {
        if (index === 0) {
          var _quick_replies = [].concat(_messages[0].quick_replies);
          _messages[1].quick_replies = _quick_replies;
          delete messages[0].quick_replies;
        }
        _messages.splice(index + 1, 0, _messages.splice(index, 1)[0]);
      }
      answer.messages = _messages;
      this.props.onAnswerChange(answer);
    }
  }, {
    key: 'saveCustomTemplateAttributes',
    value: function saveCustomTemplateAttributes(index, key) {
      var _props2 = this.props,
          answer = _props2.answer,
          messages = _props2.answer.messages,
          onAnswerChange = _props2.onAnswerChange;
      var customTemplateAttributes = this.state.customTemplateAttributes;

      messages[index]['name'] = customTemplateAttributes[index]['name'];
      messages[index]['base'] = customTemplateAttributes[index]['base'];
      answer.messages = messages;
      onAnswerChange(answer);
    }
  }, {
    key: 'toggleSpeech',
    value: function toggleSpeech(_ref, index) {
      var enabled = _ref.enabled;
      var speechToggle = this.state.speechToggle;

      speechToggle[index] = enabled;
      this.setState({
        speechToggle: speechToggle
      });
      this.onAnswerChange(enabled, 'speechResponse', index);
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      var messages = this.props.answer.messages;

      var speechToggle = messages.map(function (message) {
        return message.speechResponse ? true : false;
      });
      this.setState({
        speechToggle: speechToggle
      });
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps) {
      if (prevProps.answer.channel !== this.props.answer.channel || prevProps.answer.language !== this.props.answer.language) {
        var messages = this.props.answer.messages;

        var speechToggle = messages.map(function (message) {
          return message.speechResponse ? true : false;
        });
        this.setState({
          speechToggle: speechToggle
        });
      }
    }
  }, {
    key: 'renderResponse',
    value: function renderResponse() {
      var _this2 = this;

      var _props3 = this.props,
          _props3$answer = _props3.answer,
          messages = _props3$answer.messages,
          save = _props3$answer.save,
          onResponeTypeChange = _props3.onResponeTypeChange,
          s3config = _props3.s3config,
          preview = _props3.preview,
          channel = _props3.channel,
          S3_bucketDetails = _props3.S3_bucketDetails;

      var mode = '';
      if (save) {
        mode = 'save';
      }
      if (this.props.mode === 'preview') {
        mode = 'preview';
      }
      return React.createElement(
        'div',
        {
          __source: {
            fileName: _jsxFileName,
            lineNumber: 268
          },
          __self: this
        },
        messages.map(function (message, index) {
          /*
           *
           */
          var type = message.type.toLowerCase();
          if (type === 'dynamic' && message.base && ['text', 'card', 'button', 'hook', 'carousel', 'list', 'image'].indexOf(message.base) >= 0) {
            type = message.base;
          }

          switch (type) {
            case 'card':
              return React.createElement(
                'div',
                {
                  style: { position: 'relative' },
                  className: 'bot-response__TemplateType',
                  key: message['key'], __source: {
                    fileName: _jsxFileName,
                    lineNumber: 287
                  },
                  __self: _this2
                },
                React.createElement(TemplateItemCard, {
                  type: message.type,
                  id: message.type + index,
                  content: message.content,
                  onChange: function onChange(content) {
                    return _this2.onAnswerChange(content, 'content', index);
                  },
                  testImage: _this2.testImage,
                  save: save,
                  mode: mode,
                  intentId: _this2.props.intentId,
                  preview: preview,
                  channel: channel,
                  S3_bucketDetails: S3_bucketDetails,
                  message: message,
                  __source: {
                    fileName: _jsxFileName,
                    lineNumber: 291
                  },
                  __self: _this2
                }),
                mode !== 'preview' && React.createElement(TemplateTypeEdit, {
                  type: message.type,
                  index: index,
                  onDelete: function onDelete(event) {
                    return _this2.onDelete(index);
                  },
                  hideUpIcon: index === 0 ? true : false,
                  hideDownIcon: index === messages.length - 1 ? true : false,
                  onMessagePosAlter: _this2.onMessagePosAlter,
                  __source: {
                    fileName: _jsxFileName,
                    lineNumber: 308
                  },
                  __self: _this2
                }),
                React.createElement(
                  'div',
                  { className: 'bot-response__answerReply', __source: {
                      fileName: _jsxFileName,
                      lineNumber: 319
                    },
                    __self: _this2
                  },
                  _this2.renderSpeechResponse(message, index)
                )
              );
            case 'button':
              return React.createElement(
                'div',
                {
                  style: { position: 'relative' },
                  className: 'bot-response__TemplateType',
                  key: message['key'], __source: {
                    fileName: _jsxFileName,
                    lineNumber: 326
                  },
                  __self: _this2
                },
                React.createElement(TemplateItemButtons, {
                  id: message.type + index,
                  content: message.content,
                  mode: mode,
                  onChange: function onChange(content, key) {
                    return _this2.onAnswerChange(content, key, index);
                  },
                  save: save,
                  intentId: _this2.props.intentId,
                  preview: preview,
                  channel: channel,
                  dynamicTemplate: message.dynamicTemplate,
                  speechResponse: message.speechResponse,
                  uniqueKey: '' + channel + _this2.props.langCode + index,
                  message: message,
                  __source: {
                    fileName: _jsxFileName,
                    lineNumber: 330
                  },
                  __self: _this2
                }),
                React.createElement(TemplateTypeEdit, {
                  type: message.type,
                  index: index,
                  content: message.content,
                  onDelete: function onDelete(event) {
                    return _this2.onDelete(index);
                  },
                  hideUpIcon: index === 0 ? true : false,
                  hideDownIcon: index === messages.length - 1 ? true : false,
                  onMessagePosAlter: _this2.onMessagePosAlter,
                  __source: {
                    fileName: _jsxFileName,
                    lineNumber: 346
                  },
                  __self: _this2
                }),
                React.createElement(
                  'div',
                  { className: 'bot-response__answerReply', __source: {
                      fileName: _jsxFileName,
                      lineNumber: 355
                    },
                    __self: _this2
                  },
                  _this2.renderSpeechResponse(message, index, '' + channel + _this2.props.langCode + index + 'speech')
                )
              );
            case 'hook':
              return React.createElement(
                'div',
                {
                  style: { position: 'relative' },
                  className: 'bot-response__TemplateType',
                  key: message['key'], __source: {
                    fileName: _jsxFileName,
                    lineNumber: 366
                  },
                  __self: _this2
                },
                React.createElement(TemplateItemHook, {
                  id: message.type + index,
                  content: message.content,
                  mode: mode,
                  onChange: function onChange(content, key) {
                    return _this2.onAnswerChange(content, key, index);
                  },
                  save: save,
                  intentId: _this2.props.intentId,
                  preview: preview,
                  channel: channel,
                  dynamicTemplate: message.dynamicTemplate,
                  speechResponse: message.speechResponse,
                  uniqueKey: '' + channel + _this2.props.langCode + index,
                  message: message,
                  __source: {
                    fileName: _jsxFileName,
                    lineNumber: 370
                  },
                  __self: _this2
                }),
                React.createElement(TemplateTypeEdit, {
                  type: message.type,
                  index: index,
                  content: message.content,
                  onDelete: function onDelete(event) {
                    return _this2.onDelete(index);
                  },
                  hideUpIcon: index === 0 ? true : false,
                  hideDownIcon: index === messages.length - 1 ? true : false,
                  onMessagePosAlter: _this2.onMessagePosAlter,
                  __source: {
                    fileName: _jsxFileName,
                    lineNumber: 386
                  },
                  __self: _this2
                }),
                React.createElement(
                  'div',
                  { className: 'bot-response__answerReply', __source: {
                      fileName: _jsxFileName,
                      lineNumber: 395
                    },
                    __self: _this2
                  },
                  _this2.renderSpeechResponse(message, index, '' + channel + _this2.props.langCode + index + 'speech')
                )
              );
            case 'carousel':
              return React.createElement(
                'div',
                {
                  style: { position: 'relative' },
                  className: 'bot-response__TemplateType mt-4',
                  key: message['key'], __source: {
                    fileName: _jsxFileName,
                    lineNumber: 406
                  },
                  __self: _this2
                },
                React.createElement(TemplateItemCarousel, {
                  key: message['key'],
                  type: message.type,
                  content: message.content,
                  testImage: _this2.testImage,
                  mode: mode,
                  id: message.type + index,
                  onChange: function onChange(content, key) {
                    return _this2.onAnswerChange(content, key, index);
                  },
                  save: save,
                  s3config: s3config,
                  onDelete: function onDelete(event) {
                    return _this2.onDelete(index);
                  },
                  oftype: message.oftype || '',
                  intentId: _this2.props.intentId,
                  preview: preview,
                  channel: channel,
                  dynamicTemplate: message.dynamicTemplate,
                  speechResponse: message.speechResponse,
                  messagekey: message['key'],
                  uniqueKey: '' + channel + _this2.props.langCode + index,
                  S3_bucketDetails: S3_bucketDetails,
                  message: message,
                  __source: {
                    fileName: _jsxFileName,
                    lineNumber: 410
                  },
                  __self: _this2
                }),
                React.createElement(TemplateTypeEdit, {
                  type: message.type,
                  oftype: message.oftype,
                  index: index,
                  onDelete: function onDelete(event) {
                    return _this2.onDelete(index);
                  },
                  hideUpIcon: index === 0 ? true : false,
                  hideDownIcon: index === messages.length - 1 ? true : false,
                  onMessagePosAlter: _this2.onMessagePosAlter,
                  __source: {
                    fileName: _jsxFileName,
                    lineNumber: 434
                  },
                  __self: _this2
                }),
                React.createElement(
                  'div',
                  { className: 'bot-response__answerReply', __source: {
                      fileName: _jsxFileName,
                      lineNumber: 443
                    },
                    __self: _this2
                  },
                  _this2.renderSpeechResponse(message, index, '' + channel + _this2.props.langCode + index + 'speech')
                )
              );
            case 'rblist':
              return React.createElement(
                'div',
                {
                  style: { position: 'relative' },
                  className: 'bot-response__TemplateType',
                  key: message['key'], __source: {
                    fileName: _jsxFileName,
                    lineNumber: 454
                  },
                  __self: _this2
                },
                React.createElement(TemplateItemRBList, {
                  content: message.content,
                  showMore: message.showMore,
                  id: message.id,
                  testImage: _this2.testImage,
                  onDelete: function onDelete(event) {
                    return _this2.onDelete(index);
                  },
                  onChange: function onChange(content) {
                    return _this2.onAnswerChange(content, 'content', index);
                  },
                  uniqueKey: '' + channel + _this2.props.langCode + index,
                  mode: mode,
                  save: save,
                  S3_bucketDetails: S3_bucketDetails,
                  message: message,
                  __source: {
                    fileName: _jsxFileName,
                    lineNumber: 458
                  },
                  __self: _this2
                }),
                React.createElement(TemplateTypeEdit, {
                  type: message.type,
                  index: index,
                  onDelete: function onDelete(event) {
                    return _this2.onDelete(index);
                  },
                  hideUpIcon: index === 0 ? true : false,
                  hideDownIcon: index === messages.length - 1 ? true : false,
                  onMessagePosAlter: _this2.onMessagePosAlter,
                  __source: {
                    fileName: _jsxFileName,
                    lineNumber: 473
                  },
                  __self: _this2
                }),
                React.createElement(
                  'div',
                  { className: 'bot-response__answerReply', __source: {
                      fileName: _jsxFileName,
                      lineNumber: 481
                    },
                    __self: _this2
                  },
                  _this2.renderSpeechResponse(message, index, '' + channel + _this2.props.langCode + index + 'speech')
                )
              );
            case 'list':
              return React.createElement(
                'div',
                {
                  style: { position: 'relative' },
                  className: 'bot-response__TemplateType',
                  key: message['key'], __source: {
                    fileName: _jsxFileName,
                    lineNumber: 492
                  },
                  __self: _this2
                },
                React.createElement(TemplateItemList, {
                  content: message.content,
                  id: message.type + index,
                  onDelete: function onDelete(event) {
                    return _this2.onDelete(index);
                  },
                  testImage: _this2.testImage,
                  onChange: function onChange(content, key) {
                    return _this2.onAnswerChange(content, key, index);
                  },
                  mode: mode,
                  save: save,
                  s3config: s3config,
                  intentId: _this2.props.intentId,
                  preview: preview,
                  channel: channel,
                  dynamicTemplate: message.dynamicTemplate,
                  speechResponse: message.speechResponse,
                  uniqueKey: '' + channel + _this2.props.langCode + index,
                  S3_bucketDetails: S3_bucketDetails,
                  message: message,
                  __source: {
                    fileName: _jsxFileName,
                    lineNumber: 496
                  },
                  __self: _this2
                }),
                React.createElement(TemplateTypeEdit, {
                  type: message.type,
                  index: index,
                  onDelete: function onDelete(event) {
                    return _this2.onDelete(index);
                  },
                  hideUpIcon: index === 0 ? true : false,
                  hideDownIcon: index === messages.length - 1 ? true : false,
                  onMessagePosAlter: _this2.onMessagePosAlter,
                  __source: {
                    fileName: _jsxFileName,
                    lineNumber: 516
                  },
                  __self: _this2
                }),
                React.createElement(
                  'div',
                  { className: 'bot-response__answerReply', __source: {
                      fileName: _jsxFileName,
                      lineNumber: 524
                    },
                    __self: _this2
                  },
                  _this2.renderSpeechResponse(message, index, '' + channel + _this2.props.langCode + index + 'speech')
                )
              );
            case 'image':
              return React.createElement(
                'div',
                {
                  style: { position: 'relative' },
                  className: 'bot-response__TemplateType',
                  key: message['key'], __source: {
                    fileName: _jsxFileName,
                    lineNumber: 535
                  },
                  __self: _this2
                },
                React.createElement(TemplateItemImage, {
                  content: message.content,
                  id: message.type + index,
                  index: index,
                  testImage: _this2.testImage,
                  s3config: s3config,
                  onChange: function onChange(content, key) {
                    return _this2.onAnswerChange(content, key, index);
                  },
                  save: save,
                  preview: preview,
                  channel: channel,
                  speechResponse: message.speechResponse,
                  dynamicTemplate: message.dynamicTemplate,
                  uniqueKey: '' + channel + _this2.props.langCode + index,
                  S3_bucketDetails: S3_bucketDetails,
                  message: message,
                  __source: {
                    fileName: _jsxFileName,
                    lineNumber: 539
                  },
                  __self: _this2
                }),
                React.createElement(TemplateTypeEdit, {
                  type: message.type,
                  index: index,
                  prT: true,
                  onDelete: function onDelete(event) {
                    return _this2.onDelete(index);
                  },
                  hideUpIcon: index === 0 ? true : false,
                  hideDownIcon: index === messages.length - 1 ? true : false,
                  onMessagePosAlter: _this2.onMessagePosAlter,
                  __source: {
                    fileName: _jsxFileName,
                    lineNumber: 557
                  },
                  __self: _this2
                }),
                React.createElement(
                  'div',
                  { className: 'bot-response__answerReply', __source: {
                      fileName: _jsxFileName,
                      lineNumber: 566
                    },
                    __self: _this2
                  },
                  _this2.renderSpeechResponse(message, index, '' + channel + _this2.props.langCode + index + 'speech')
                )
              );
            case 'dynamic':
              return React.createElement(
                'div',
                {
                  key: message['key'],
                  className: 'bot-response__dynamicReponse mb-2', __source: {
                    fileName: _jsxFileName,
                    lineNumber: 577
                  },
                  __self: _this2
                },
                React.createElement(
                  'div',
                  {
                    __source: {
                      fileName: _jsxFileName,
                      lineNumber: 580
                    },
                    __self: _this2
                  },
                  _this2.renderCustomTemplate(_this2.onDelete, message, index, save, mode, message['key'], _this2.onAnswerChange, onResponeTypeChange, '' + channel + _this2.props.langCode + index + 'speech')
                ),
                React.createElement(TemplateTypeEdit, {
                  type: message.type,
                  index: index,
                  onDelete: function onDelete(event) {
                    return _this2.onDelete(index);
                  },
                  hideUpIcon: index === 0 ? true : false,
                  hideDownIcon: index === messages.length - 1 ? true : false,
                  onMessagePosAlter: _this2.onMessagePosAlter,
                  __source: {
                    fileName: _jsxFileName,
                    lineNumber: 593
                  },
                  __self: _this2
                }),
                React.createElement(
                  'div',
                  { className: 'bot-response__answerReply', __source: {
                      fileName: _jsxFileName,
                      lineNumber: 601
                    },
                    __self: _this2
                  },
                  _this2.renderSpeechResponse(message, index, '' + channel + _this2.props.langCode + index + 'speech')
                )
              );
            case 'text':
            case 'ssml':
            default:
              return React.createElement(
                'div',
                {
                  style: { position: 'relative' },
                  className: 'bot-response__TemplateType',
                  key: message['key'], __source: {
                    fileName: _jsxFileName,
                    lineNumber: 614
                  },
                  __self: _this2
                },
                React.createElement(TextArea, {
                  type: message.type,
                  className: 'mt-1 m-t-1',
                  placeholder: 'Enter Text',
                  content: message.content,
                  onChange: function onChange(data, key) {
                    return _this2.onAnswerChange(data, key, index);
                  },
                  id: message.type + index,
                  mode: mode,
                  rows: '1',
                  preview: preview,
                  channel: channel,
                  uniqueKey: '' + channel + _this2.props.langCode + index,
                  __source: {
                    fileName: _jsxFileName,
                    lineNumber: 618
                  },
                  __self: _this2
                }),
                React.createElement(TemplateTypeEdit, {
                  type: message.type,
                  index: index,
                  prT: true,
                  onDelete: function onDelete(event) {
                    return _this2.onDelete(index);
                  },
                  hideUpIcon: index === 0 ? true : false,
                  hideDownIcon: index === messages.length - 1 ? true : false,
                  onMessagePosAlter: _this2.onMessagePosAlter,
                  __source: {
                    fileName: _jsxFileName,
                    lineNumber: 633
                  },
                  __self: _this2
                }),
                React.createElement('hr', {
                  __source: {
                    fileName: _jsxFileName,
                    lineNumber: 642
                  },
                  __self: _this2
                }),
                React.createElement(
                  'div',
                  { className: 'bot-response__answerReply', __source: {
                      fileName: _jsxFileName,
                      lineNumber: 643
                    },
                    __self: _this2
                  },
                  _this2.renderSpeechResponse(message, index, '' + channel + _this2.props.langCode + index + 'speech')
                )
              );
          }
        })
      );
    }
  }, {
    key: 'renderCustomTemplate',
    value: function renderCustomTemplate(onDelete, message, index, save, mode, key, onAnswerChange, onResponeTypeChange, uniqueKey) {
      var _this3 = this,
          _React$createElement;

      if (message.source) {
        switch (message.source) {
          case 'rblist':
            return React.createElement(
              'div',
              {
                style: { position: 'relative' },
                className: 'bot-response__TemplateType',
                key: key, __source: {
                  fileName: _jsxFileName,
                  lineNumber: 672
                },
                __self: this
              },
              React.createElement(TemplateItemRBList, {
                dynamicTemplate: message.dynamicTemplate,
                content: message.content,
                keyName: message.keyName,
                showMore: message.showMore,
                id: message.id,
                testImage: this.testImage,
                onDelete: function onDelete(event) {
                  return _this3.onDelete(index);
                },
                onChange: function onChange(content, key) {
                  return _this3.onAnswerChange(content, key, index);
                },
                mode: mode,
                save: save,
                uniqueKey: uniqueKey,
                S3_bucketDetails: this.props.S3_bucketDetails,
                message: message,
                __source: {
                  fileName: _jsxFileName,
                  lineNumber: 676
                },
                __self: this
              }),
              React.createElement(TemplateTypeEdit, {
                type: message.type,
                index: index,
                onDelete: function onDelete(event) {
                  return _this3.onDelete(index);
                },
                __source: {
                  fileName: _jsxFileName,
                  lineNumber: 693
                },
                __self: this
              })
            );
          default:
            return null;
        }
      }
      switch (message.base) {
        case 'rblist':
        case 'rbconf':
        default:
          return React.createElement(
            'div',
            {
              key: key,
              style: { position: 'relative' },
              className: 'bot-response__TemplateType', __source: {
                fileName: _jsxFileName,
                lineNumber: 709
              },
              __self: this
            },
            React.createElement(TemplateItemCustom, (_React$createElement = {
              message: message,
              key: key,
              base: message.base,
              content: message.content,
              id: message.id,
              onDelete: function onDelete(event) {
                return _this3.onDelete(index);
              },
              onChange: function onChange(content, key) {
                return _this3.onAnswerChange(content, key, index);
              },
              onResponeTypeChange: onResponeTypeChange,
              mode: mode,
              save: save,
              hideAndShowTemplateTypeChoice: this.props.hideAndShowTemplateTypeChoice,
              uniqueKey: uniqueKey,
              S3_bucketDetails: this.props.S3_bucketDetails
            }, _defineProperty(_React$createElement, 'message', message), _defineProperty(_React$createElement, '__source', {
              fileName: _jsxFileName,
              lineNumber: 713
            }), _defineProperty(_React$createElement, '__self', this), _React$createElement))
          );
      }
    }
  }, {
    key: 'renderReply',
    value: function renderReply() {
      var _this4 = this;

      var _props4 = this.props,
          messages = _props4.answer.messages,
          answer = _props4.answer,
          currentIndex = _props4.currentIndex,
          channel = _props4.channel;

      return React.createElement(
        'div',
        {
          __source: {
            fileName: _jsxFileName,
            lineNumber: 745
          },
          __self: this
        },
        messages.length !== 0 && messages[0].quick_replies && React.createElement(
          'div',
          {
            style: { position: 'relative', minHeight: '50px' },
            className: 'bot-response__TemplateType', __source: {
              fileName: _jsxFileName,
              lineNumber: 747
            },
            __self: this
          },
          React.createElement(TemplateQuickReply, {
            save: answer.save,
            messages: messages,
            replies: answer.messages[0].quick_replies,
            onChange: function onChange(replies) {
              return _this4.onAnswerChange(replies, 'quick_replies');
            },
            uniqueKey: '' + channel + this.props.langCode + '-quickReplies',
            onAnswerChange: this.onAnswerChange,
            __source: {
              fileName: _jsxFileName,
              lineNumber: 750
            },
            __self: this
          }),
          React.createElement(TemplateTypeEdit, {
            replies: answer.messages[0].quick_replies,
            index: messages.length,
            type: 'quick replies',
            content: answer.messages[0].quick_replies,
            onSave: function onSave(event) {
              return _this4.onSave(currentIndex, 'quick_replies');
            },
            onDelete: function onDelete(event) {
              return _this4.onDelete(currentIndex, 'quick_replies');
            },
            __source: {
              fileName: _jsxFileName,
              lineNumber: 760
            },
            __self: this
          })
        )
      );
    }
  }, {
    key: 'renderSpeechResponse',
    value: function renderSpeechResponse(message, index, uniqueKey) {
      var _this5 = this;

      return React.createElement(
        'div',
        { className: 'bot-response__TemplateType', __source: {
            fileName: _jsxFileName,
            lineNumber: 776
          },
          __self: this
        },
        React.createElement(
          'div',
          {
            __source: {
              fileName: _jsxFileName,
              lineNumber: 777
            },
            __self: this
          },
          React.createElement(ToggleSwitch, {
            className: 'bot-response__speechToggle',
            enabled: this.state.speechToggle[index],
            onStateChanged: function onStateChanged(enabled) {
              return _this5.toggleSpeech(enabled, index);
            },
            label: 'Speech Response',
            __source: {
              fileName: _jsxFileName,
              lineNumber: 778
            },
            __self: this
          })
        ),
        message.speechResponse !== undefined && React.createElement(TemplateSpeechResponse, {
          speechResponse: message.speechResponse,
          onChange: function onChange(speechResponse) {
            return _this5.onAnswerChange(speechResponse, 'speechResponse', index);
          },
          uniqueKey: uniqueKey,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 786
          },
          __self: this
        })
      );
    }
  }, {
    key: 'render',
    value: function render() {
      return React.createElement(
        'div',
        { className: 'bot-response__answer', __source: {
            fileName: _jsxFileName,
            lineNumber: 799
          },
          __self: this
        },
        React.createElement(
          'div',
          { className: 'bot-response__answerBody', __source: {
              fileName: _jsxFileName,
              lineNumber: 800
            },
            __self: this
          },
          this.renderResponse()
        ),
        React.createElement(
          'div',
          { className: 'bot-response__answerReply', __source: {
              fileName: _jsxFileName,
              lineNumber: 801
            },
            __self: this
          },
          this.renderReply()
        )
      );
    }
  }]);

  return TemplateItem;
}(Component);

export default TemplateItem;