var _jsxFileName = 'src/lib/components/TemplateItemButtons.js';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import cx from 'classnames';

import Buttons from './TemplateButton';
import IconResponseDelete from '../assets/icons/IconResponseDelete';
import IconAdd from '../assets/icons/IconAdd';

import TemplateButtonPreview from './TemplateButtonPreview';

import { isDynamicContent } from '../utility/utility';
import generateTemplateMarkup from './TemplateItemMarkupGenerator';
import CustomTemplateAtrribute from './CustomTemplateAttribute';

var defaultRows = 2;

var TemplateItemCard = function (_Component) {
  _inherits(TemplateItemCard, _Component);

  function TemplateItemCard(props) {
    _classCallCheck(this, TemplateItemCard);

    var _this = _possibleConstructorReturn(this, (TemplateItemCard.__proto__ || Object.getPrototypeOf(TemplateItemCard)).call(this, props));

    _this.state = {
      addButtonModal: null,
      editButtonModal: [],
      rows: defaultRows
    };
    _this.hideAddButtonModal = _this.hideAddButtonModal.bind(_this);
    _this.showAddButtonModal = _this.showAddButtonModal.bind(_this);
    _this.hideEditButtonModal = _this.hideEditButtonModal.bind(_this);
    _this.showEditButtonModal = _this.showEditButtonModal.bind(_this);
    return _this;
  }

  _createClass(TemplateItemCard, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var content = this.props.content;

      var editButtonModal = [];
      content.buttons.map(function () {
        editButtonModal.push(null);
        return '';
      });
      if (content.title) {
        var rows = ~~(content.title.length / 35) + 1;
        if (rows > defaultRows) {
          this.setState({
            rows: rows
          });
        }
      }

      this.setState({
        addButtonModal: null,
        editButtonModal: editButtonModal
      });
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps) {
      if (prevProps.speechResponse !== this.props.speechResponse) {
        var _props = this.props,
            dynamicTemplate = _props.dynamicTemplate,
            speechResponse = _props.speechResponse,
            onChange = _props.onChange,
            content = _props.content,
            message = _props.message;

        var custom = message['customTemplateName'];
        if (message['quick_replies'] && message['quick_replies'].length) {
          var quickreply_templateMarkup = message['quickreply_templateMarkup'];
        }
        if (dynamicTemplate && speechResponse) {
          onChange(generateTemplateMarkup(content, 'button', speechResponse, quickreply_templateMarkup, custom), 'templateMarkup');
        }
      }
    }
  }, {
    key: 'generateDynamicContent',
    value: function generateDynamicContent() {
      var _props2 = this.props,
          content = _props2.content,
          onChange = _props2.onChange,
          speechResponse = _props2.speechResponse,
          message = _props2.message;

      var custom = message['customTemplateName'];
      if (message['quick_replies'] && message['quick_replies'].length) {
        var quickreply_templateMarkup = message['quickreply_templateMarkup'];
      }
      if (content.title && isDynamicContent(content.title) || content.buttons[0] && (isDynamicContent(content.buttons[0].title) || isDynamicContent(content.buttons[0].payload))) {
        onChange('button', 'base');
        onChange('dynamic', 'type');
        onChange(true, 'dynamicTemplate');
        onChange(generateTemplateMarkup(content, 'button', speechResponse, quickreply_templateMarkup, custom), 'templateMarkup');
      } else {
        onChange(false, 'dynamicTemplate');
      }
    }
  }, {
    key: 'onChange',
    value: function onChange(event, field) {
      var _props3 = this.props,
          content = _props3.content,
          onChange = _props3.onChange;

      if (field === 'title') {
        var rows = ~~(event.target.value.length / 36) + 1;
        if (rows > defaultRows) {
          this.setState({
            rows: rows
          });
        } else {
          this.setState({
            rows: defaultRows
          });
        }
      }
      content[field] = event.target.value;
      this.generateDynamicContent();
      onChange(content, 'content');
    }
  }, {
    key: 'onAddButton',
    value: function onAddButton(type) {
      var _props4 = this.props,
          content = _props4.content,
          onChange = _props4.onChange,
          intentId = _props4.intentId;

      var editButtonModal = [].concat(this.state.editButtonModal);
      content.buttons = content.buttons || [];
      content.buttons.push({
        title: '',
        type: type,
        payload: intentId ? '{"data":{"options":"no"}, "intent": "' + intentId + '"}' : '{"data":{"options":"no"}, "intent": ""}'
      });
      editButtonModal.push(null);
      this.setState({
        editButtonModal: editButtonModal
      });
      onChange(content, 'content');
      this.showAddButtonModal();
    }
  }, {
    key: 'onButtonChange',
    value: function onButtonChange(value, index, field) {
      var _props5 = this.props,
          content = _props5.content,
          onChange = _props5.onChange;

      if (field !== 'title' && field !== 'attributes') {
        content.buttons[index]['type'] = field;
        content.buttons[index]['payload'] = value;
      } else {
        content.buttons[index][field] = value;
      }
      this.generateDynamicContent();
      onChange(content, 'content');
    }
  }, {
    key: 'onButtonRemove',
    value: function onButtonRemove(index) {
      var _props6 = this.props,
          content = _props6.content,
          onChange = _props6.onChange;

      content.buttons.splice(index, 1);
      this.generateDynamicContent();
      onChange(content, 'content');
      document.querySelector('body').classList.remove('modal-open');
    }
  }, {
    key: 'showAddButtonModal',
    value: function showAddButtonModal() {
      this.setState({
        addButtonModal: false
      });
    }
  }, {
    key: 'hideAddButtonModal',
    value: function hideAddButtonModal() {
      this.setState({
        addButtonModal: true
      });
      document.querySelector('body').classList.remove('modal-open');
    }
  }, {
    key: 'showEditButtonModal',
    value: function showEditButtonModal(index) {
      var editButtonModal = [].concat(this.state.editButtonModal);
      editButtonModal[index] = false;
      this.setState({
        editButtonModal: editButtonModal
      });
    }
  }, {
    key: 'hideEditButtonModal',
    value: function hideEditButtonModal(index) {
      var editButtonModal = [].concat(this.state.editButtonModal);
      editButtonModal[index] = true;
      this.setState({
        editButtonModal: editButtonModal
      });
      document.querySelector('body').classList.remove('modal-open');
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props7 = this.props,
          content = _props7.content,
          save = _props7.save,
          mode = _props7.mode,
          id = _props7.id,
          intentId = _props7.intentId,
          channel = _props7.channel,
          preview = _props7.preview,
          uniqueKey = _props7.uniqueKey,
          message = _props7.message;
      var rows = this.state.rows;

      return React.createElement(
        'div',
        {
          __source: {
            fileName: _jsxFileName,
            lineNumber: 188
          },
          __self: this
        },
        React.createElement(
          'div',
          { className: 'bot-response__ItemButtons', __source: {
              fileName: _jsxFileName,
              lineNumber: 189
            },
            __self: this
          },
          (channel === 'wn' || channel === 'wg' || channel === 'gw') && React.createElement(CustomTemplateAtrribute, {
            message: message,
            onChange: this.props.onChange,
            uniqueKey: uniqueKey,
            __source: {
              fileName: _jsxFileName,
              lineNumber: 191
            },
            __self: this
          }),
          React.createElement(
            'div',
            {
              className: 'bot-response__ItemButtonsTitle',
              key: 'buttonTitle-' + channel, __source: {
                fileName: _jsxFileName,
                lineNumber: 197
              },
              __self: this
            },
            React.createElement('textarea', {
              disabled: save,
              type: 'text',
              placeholder: 'Enter title',
              className: 'bot-response__inputLarge',
              maxLength: '640',
              rows: rows,
              value: content.title,
              key: uniqueKey,
              onChange: function onChange(event) {
                _this2.setState({ value: event.target.value });
                _this2.onChange(event, 'title');
              },
              __source: {
                fileName: _jsxFileName,
                lineNumber: 200
              },
              __self: this
            })
          ),
          mode !== 'preview' ? React.createElement(
            'div',
            {
              __source: {
                fileName: _jsxFileName,
                lineNumber: 216
              },
              __self: this
            },
            content.buttons.map(function (button, index) {
              return React.createElement(
                'div',
                { className: 'buttonsPreview', key: index, __source: {
                    fileName: _jsxFileName,
                    lineNumber: 218
                  },
                  __self: _this2
                },
                React.createElement(
                  'div',
                  {
                    className: cx('preview', (!button.title || !button['payload']) && 'errorButton'),
                    'data-target': '#edit' + id + 'Button' + index,
                    'data-toggle': 'modal',
                    'data-backdrop': 'false',
                    onClick: function onClick() {
                      return _this2.showEditButtonModal(index);
                    }, __source: {
                      fileName: _jsxFileName,
                      lineNumber: 219
                    },
                    __self: _this2
                  },
                  React.createElement(
                    'div',
                    {
                      className: cx('buttonName mt-1 m-t-1', !button.title && 'errorName'), __source: {
                        fileName: _jsxFileName,
                        lineNumber: 228
                      },
                      __self: _this2
                    },
                    button.title ? button.title : 'Enter button name'
                  )
                ),
                React.createElement(
                  'div',
                  {
                    className: 'iconTrash',
                    onClick: function onClick() {
                      return _this2.onButtonRemove(index);
                    }, __source: {
                      fileName: _jsxFileName,
                      lineNumber: 236
                    },
                    __self: _this2
                  },
                  React.createElement(IconResponseDelete, {
                    __source: {
                      fileName: _jsxFileName,
                      lineNumber: 239
                    },
                    __self: _this2
                  })
                ),
                React.createElement(
                  'div',
                  { className: 'buttonsPreviewPopUp', __source: {
                      fileName: _jsxFileName,
                      lineNumber: 241
                    },
                    __self: _this2
                  },
                  React.createElement(Buttons, {
                    field: 'payload',
                    id: 'edit' + id + 'Button' + index,
                    index: index,
                    placeholder: 'Enter button name',
                    content: button,
                    onButtonChange: _this2.onButtonChange.bind(_this2),
                    onHideModal: function onHideModal(index) {
                      return _this2.hideEditButtonModal(index);
                    },
                    intentId: intentId,
                    uniqueKey: uniqueKey,
                    display: _this2.state.editButtonModal[index] ? 'none' : _this2.state.editButtonModal[index] !== null ? 'block' : '',
                    channel: channel,
                    __source: {
                      fileName: _jsxFileName,
                      lineNumber: 242
                    },
                    __self: _this2
                  })
                )
              );
            }),
            React.createElement(
              'div',
              { className: 'buttonsPreview', __source: {
                  fileName: _jsxFileName,
                  lineNumber: 264
                },
                __self: this
              },
              React.createElement(
                'div',
                {
                  className: 'addButtonAction',
                  'data-toggle': 'modal',
                  'data-target': '#add' + id + 'Button' + content.buttons.length,
                  onClick: function onClick(event) {
                    return _this2.onAddButton('postback');
                  },
                  'data-backdrop': 'false', __source: {
                    fileName: _jsxFileName,
                    lineNumber: 265
                  },
                  __self: this
                },
                React.createElement(IconAdd, {
                  __source: {
                    fileName: _jsxFileName,
                    lineNumber: 271
                  },
                  __self: this
                }),
                React.createElement(
                  'span',
                  {
                    __source: {
                      fileName: _jsxFileName,
                      lineNumber: 272
                    },
                    __self: this
                  },
                  'Add button'
                )
              ),
              React.createElement(Buttons, {
                field: 'payload',
                id: 'add' + id + 'Button' + content.buttons.length,
                index: content.buttons.length - 1,
                placeholder: 'Enter button name',
                onButtonChange: this.onButtonChange.bind(this),
                content: content.buttons[content.buttons.length - 1],
                handleSave: function handleSave(event) {
                  return _this2.handleSave(event);
                },
                onHideModal: this.hideAddButtonModal,
                intentId: intentId,
                uniqueKey: uniqueKey,
                display: this.state.addButtonModal ? 'none' : this.state.addButtonModal !== null ? 'block' : '',
                channel: channel,
                __source: {
                  fileName: _jsxFileName,
                  lineNumber: 274
                },
                __self: this
              })
            )
          ) : React.createElement(
            'div',
            {
              __source: {
                fileName: _jsxFileName,
                lineNumber: 297
              },
              __self: this
            },
            content.buttons.map(function (button) {
              return React.createElement(
                'div',
                {
                  className: cx('preview', (!button.title || !button['payload']) && 'errorButton'), __source: {
                    fileName: _jsxFileName,
                    lineNumber: 299
                  },
                  __self: _this2
                },
                React.createElement(
                  'div',
                  { className: cx('buttonName mt-1 m-t-1'), __source: {
                      fileName: _jsxFileName,
                      lineNumber: 304
                    },
                    __self: _this2
                  },
                  button.title ? button.title : 'Enter button name'
                )
              );
            })
          ),
          React.createElement(TemplateButtonPreview, {
            content: content,
            preview: preview,
            channel: channel,
            __source: {
              fileName: _jsxFileName,
              lineNumber: 311
            },
            __self: this
          })
        ),
        React.createElement('hr', {
          __source: {
            fileName: _jsxFileName,
            lineNumber: 317
          },
          __self: this
        })
      );
    }
  }]);

  return TemplateItemCard;
}(Component);

export default TemplateItemCard;