import _regeneratorRuntime from 'babel-runtime/regenerator';
var _jsxFileName = 'src/lib/components/TemplateItemCard.js';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import cx from 'classnames';

import IconResponseDelete from '../assets/icons/IconResponseDelete';
import IconAdd from '../assets/icons/IconAdd';
import Buttons from './TemplateButton';
import TemplateImageUpload from './TemplateItemUploadImage';
import TemplateCardPreview from './TemplateCardPreview';
import IconMove from '../assets/icons/IconMove';
import CustomTemplateAtrribute from './CustomTemplateAttribute';

var TemplateItemCard = function (_Component) {
  _inherits(TemplateItemCard, _Component);

  function TemplateItemCard(props) {
    _classCallCheck(this, TemplateItemCard);

    var _this = _possibleConstructorReturn(this, (TemplateItemCard.__proto__ || Object.getPrototypeOf(TemplateItemCard)).call(this, props));

    _this.state = {
      isImageValid: null,
      buttonIndex: null,
      addButtonModal: null,
      editButtonModal: [],
      deleteCardModal: null
    };
    _this.onButtonChange = _this.onButtonChange.bind(_this);
    _this.onAddButton = _this.onAddButton.bind(_this);
    _this.onButtonIndexChange = _this.onButtonIndexChange.bind(_this);
    _this.onRemoveImage = _this.onRemoveImage.bind(_this);
    _this.hideAddButtonModal = _this.hideAddButtonModal.bind(_this);
    _this.showAddButtonModal = _this.showAddButtonModal.bind(_this);
    _this.hideEditButtonModal = _this.hideEditButtonModal.bind(_this);
    _this.showEditButtonModal = _this.showEditButtonModal.bind(_this);
    _this.alterDeleteCardModal = _this.alterDeleteCardModal.bind(_this);
    _this.onChange = _this.onChange.bind(_this);
    _this.isValidImage = _this.isValidImage.bind(_this);
    return _this;
  }

  _createClass(TemplateItemCard, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var content = this.props.content;

      if (content.image) {
        this.isValidImage(content.image);
      }
      var editButtonModal = [];
      content.buttons.map(function () {
        editButtonModal.push(null);
        return '';
      });
      this.setState({
        addButtonModal: null,
        editButtonModal: editButtonModal,
        deleteCardModal: null
      });
    }
  }, {
    key: 'isValidImage',
    value: function () {
      var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(url) {
        var isImageValid;
        return _regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (!(url.indexOf('data:image') >= 0)) {
                  _context.next = 4;
                  break;
                }

                this.setState({ isImageValid: true });
                _context.next = 15;
                break;

              case 4:
                _context.prev = 4;
                _context.next = 7;
                return this.props.testImage(url);

              case 7:
                isImageValid = _context.sent;

                this.setState({ isImageValid: isImageValid });
                _context.next = 15;
                break;

              case 11:
                _context.prev = 11;
                _context.t0 = _context['catch'](4);

                this.setState({ isImageValid: false });
                console.error(_context.t0);

              case 15:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this, [[4, 11]]);
      }));

      function isValidImage(_x) {
        return _ref.apply(this, arguments);
      }

      return isValidImage;
    }()
  }, {
    key: 'generateDynamicContent',
    value: function generateDynamicContent() {
      var _props = this.props,
          content = _props.content,
          onChange = _props.onChange;


      if (content.title && this.isDynamicContent(content.title)) {
        content.dynamicTemplate = true;
        content.templateMarkup = this.getTemplateMarkup();
      } else {
        delete content.dynamicTemplate;
      }

      onChange(content);
    }
  }, {
    key: 'onChange',
    value: function onChange(event, field) {
      var _props2 = this.props,
          content = _props2.content,
          onChange = _props2.onChange,
          oftype = _props2.oftype;

      var value = event.target.value.trim();

      if (oftype === 'video') {
        if (value.indexOf('youtube') >= 0) {
          var youTubeId = this.getYouTubeId(value);
          value = 'https://www.youtube.com/embed/' + youTubeId;
        }

        if (value.indexOf('vimeo') >= 0) {
          var vimeoId = this.getVimeoId(value);
          value = 'https://player.vimeo.com/video/' + vimeoId;
        }
      }

      //! Don't execute for carousel
      if (oftype !== 'card' && oftype !== 'carousel') {
        this.generateDynamicContent();
      }
      onChange(Object.assign({}, content, _defineProperty({}, field, value)));
      if (field === 'image') {
        this.isValidImage(value);
      }
    }
  }, {
    key: 'getYouTubeId',
    value: function getYouTubeId(url) {
      var regExp = /^.*(youtu.be\/|v\/|u\/\w\/|embed\/|watch\?v=|\&v=)([^#\&\?]*).*/;
      var match = url.match(regExp);

      if (match && match[2].length > 0) {
        return match[2];
      }
    }
  }, {
    key: 'getVimeoId',
    value: function getVimeoId(url) {
      var match = /vimeo.*\/(\d+)/i.exec(url);

      if (match) {
        return match[1];
      }
    }
  }, {
    key: 'getTemplateMarkup',
    value: function getTemplateMarkup() {
      var content = this.props.content;


      return '<div class="panel panel-default button-div border-radius-top-20" data-element="true" data-title="" data-subtitle="" data-image="{{' + content.image + '}}"> \n      <div class="panel-heading card-image"> \n        <img src="{{' + content.image + '}}" class="img-responsive"> \n      </div> \n      <div class="panel-body"> \n        <div class="row"> \n          <div class="col-xs-12 buttondesign"> \n            <h5 class="uob-amex card-title" style="font-weight: bold;">{{' + content.title + '}}</h5> \n            <p class="account-number">{{' + content.subtitle + '}}</p> \n          </div> \n        </div> \n      </div> \n      ' + this.getButtons() + '\n    </div>';
    }
  }, {
    key: 'getButtons',
    value: function getButtons() {
      var content = this.props.content;


      if (content) {
        var title = content.title,
            subtitle = content.subtitle,
            image = content.image,
            buttons = content.buttons;

        if (this.isDynamicContent(title) && this.isDynamicContent(subtitle) && this.isDynamicContent(image) && buttons.length > 0) {
          var buttonWithAttributes = '';

          buttons.forEach(function (button) {
            var attributes = button.attributes;
            if (attributes) {
              var buttonElement = document.createElement('button');
              buttonElement.innerText = button.title;

              Object.keys(attributes).forEach(function (key) {
                buttonElement.setAttribute(attributes[key].key, attributes[key].value);
              });

              buttonWithAttributes += buttonElement.outerHTML;
            }
          });

          return buttonWithAttributes;
        } else if (buttons.length === 0) {
          return '';
        }
      }
    }
  }, {
    key: 'onRemoveImage',
    value: function onRemoveImage() {
      var _props3 = this.props,
          content = _props3.content,
          onChange = _props3.onChange;

      content.image = '';
      onChange(content);
      this.setState({
        isImageValid: null
      });
    }
  }, {
    key: 'onRemove',
    value: function onRemove() {
      var _props4 = this.props,
          onRemove = _props4.onRemove,
          showRemove = _props4.showRemove;

      if (showRemove) {
        onRemove();
        this.setState({
          deleteCardModal: null
        });
      }
    }
  }, {
    key: 'onAddButton',
    value: function onAddButton(type) {
      var _props5 = this.props,
          content = _props5.content,
          onChange = _props5.onChange,
          intentId = _props5.intentId;

      var editButtonModal = [].concat(this.state.editButtonModal);
      content.buttons = content.buttons || [];
      content.buttons.push({
        title: '',
        type: type,
        payload: intentId ? '{"data":{"options":"no"}, "intent": "' + intentId + '"}' : '{"data":{"options":"no"}, "intent": ""}'
      });
      editButtonModal.push(null);
      this.setState({
        editButtonModal: editButtonModal
      });
      onChange(content);
      this.showAddButtonModal();
    }
  }, {
    key: 'onButtonChange',
    value: function onButtonChange(value, index, field) {
      var _props6 = this.props,
          content = _props6.content,
          onChange = _props6.onChange,
          oftype = _props6.oftype;

      if (field === 'attributes') {
        content.buttons[index]['attributes'] = value;
      } else if (field !== 'title') {
        content.buttons[index]['type'] = field;
        content.buttons[index]['payload'] = value;
      } else {
        content.buttons[index][field] = value;
      }
      if (oftype !== 'card') {
        this.generateDynamicContent();
      }
      onChange(content);
    }
  }, {
    key: 'onButtonRemove',
    value: function onButtonRemove(index) {
      var _props7 = this.props,
          content = _props7.content,
          onChange = _props7.onChange;

      content.buttons.splice(index, 1);
      onChange(content);
    }
  }, {
    key: 'onButtonIndexChange',
    value: function onButtonIndexChange(index) {
      this.setState({
        buttonIndex: index
      });
      this.showEditButtonModal(index);
    }
  }, {
    key: 'showAddButtonModal',
    value: function showAddButtonModal() {
      this.setState({
        addButtonModal: false
      });
    }
  }, {
    key: 'hideAddButtonModal',
    value: function hideAddButtonModal() {
      this.setState({
        addButtonModal: true
      });
      document.querySelector('body').classList.remove('modal-open');
    }
  }, {
    key: 'showEditButtonModal',
    value: function showEditButtonModal(index) {
      var editButtonModal = [].concat(this.state.editButtonModal);
      editButtonModal[index] = false;
      this.setState({
        editButtonModal: editButtonModal
      });
    }
  }, {
    key: 'hideEditButtonModal',
    value: function hideEditButtonModal(index) {
      var editButtonModal = [].concat(this.state.editButtonModal);
      editButtonModal[index] = true;
      this.setState({
        editButtonModal: editButtonModal
      });
      document.querySelector('body').classList.remove('modal-open');
    }
  }, {
    key: 'alterDeleteCardModal',
    value: function alterDeleteCardModal(value) {
      this.setState({
        deleteCardModal: value
      });
      document.querySelector('body').classList.remove('modal-open');
    }
  }, {
    key: 'isDynamicContent',
    value: function isDynamicContent(string) {
      return string.indexOf('{{') >= 0 && string.indexOf('}}') >= 0;
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props8 = this.props,
          content = _props8.content,
          save = _props8.save,
          mode = _props8.mode,
          showRemove = _props8.showRemove,
          cardIndex = _props8.cardIndex,
          id = _props8.id,
          intentId = _props8.intentId,
          oftype = _props8.oftype,
          preview = _props8.preview,
          channel = _props8.channel,
          s3config = _props8.s3config,
          dynamicTemplate = _props8.dynamicTemplate,
          uniqueKey = _props8.uniqueKey,
          S3_bucketDetails = _props8.S3_bucketDetails,
          message = _props8.message;

      var deleteCardDisplay = this.state.deleteCardModal ? 'none' : this.state.deleteCardModal !== null ? 'block' : '';

      return React.createElement(
        'div',
        {
          className: cx(mode !== 'preview' && 'bot-response__ItemCard w-i', mode === 'preview' && 'bot-response__ItemCardPreview w-i', showRemove && 'mr-3 m-r-3', cardIndex && dynamicTemplate && 'mt-44'), __source: {
            fileName: _jsxFileName,
            lineNumber: 308
          },
          __self: this
        },
        (channel === 'wn' || channel === 'wg' || channel === 'gw') && React.createElement(CustomTemplateAtrribute, {
          message: message,
          onChange: this.props.onChange,
          uniqueKey: uniqueKey,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 316
          },
          __self: this
        }),
        showRemove && oftype !== 'card' && React.createElement(IconMove, {
          index: cardIndex,
          onMessagePosAlter: this.props.onMessagePosAlter,
          horizontal: true,
          hideUpIcon: this.props.hideUpIcon,
          hideDownIcon: this.props.hideDownIcon,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 323
          },
          __self: this
        }),
        React.createElement(
          'div',
          {
            className: cx('bot-response__ItemCardBody w-i', (!content.title || !content.subtitle) && 'cardError'), __source: {
              fileName: _jsxFileName,
              lineNumber: 331
            },
            __self: this
          },
          showRemove && !save && oftype !== 'card' && oftype !== 'video' && React.createElement(
            'div',
            {
              className: 'iconTrash',
              'data-target': 'deleteCardModal' + id,
              'data-toggle': 'modal',
              'data-backdrop': 'false',
              onClick: function onClick() {
                return _this2.alterDeleteCardModal(false);
              }, __source: {
                fileName: _jsxFileName,
                lineNumber: 337
              },
              __self: this
            },
            React.createElement(IconResponseDelete, {
              __source: {
                fileName: _jsxFileName,
                lineNumber: 343
              },
              __self: this
            })
          ),
          React.createElement(
            'div',
            {
              className: 'modal deleteCardModal',
              id: 'deleteCardModal' + id,
              style: { display: deleteCardDisplay }, __source: {
                fileName: _jsxFileName,
                lineNumber: 347
              },
              __self: this
            },
            React.createElement(
              'div',
              { className: 'modal-dialog', __source: {
                  fileName: _jsxFileName,
                  lineNumber: 351
                },
                __self: this
              },
              React.createElement(
                'div',
                { className: 'modal-content', __source: {
                    fileName: _jsxFileName,
                    lineNumber: 352
                  },
                  __self: this
                },
                React.createElement(
                  'div',
                  { className: 'modal-header', __source: {
                      fileName: _jsxFileName,
                      lineNumber: 353
                    },
                    __self: this
                  },
                  'Are you sure you want to remove this card?',
                  React.createElement(
                    'button',
                    {
                      type: 'button',
                      onClick: function onClick() {
                        return _this2.alterDeleteCardModal(true);
                      },
                      className: 'close',
                      'data-target': '#' + id, __source: {
                        fileName: _jsxFileName,
                        lineNumber: 355
                      },
                      __self: this
                    },
                    '\xD7'
                  )
                ),
                React.createElement(
                  'div',
                  { className: 'modal-footers', __source: {
                      fileName: _jsxFileName,
                      lineNumber: 363
                    },
                    __self: this
                  },
                  React.createElement(
                    'button',
                    {
                      className: 'cancelCardModalButton',
                      onClick: function onClick() {
                        return _this2.alterDeleteCardModal(true);
                      }, __source: {
                        fileName: _jsxFileName,
                        lineNumber: 364
                      },
                      __self: this
                    },
                    ' ',
                    'cancel'
                  ),
                  React.createElement(
                    'button',
                    {
                      className: 'deleteCardModalButton',
                      onClick: function onClick() {
                        return _this2.onRemove();
                      }, __source: {
                        fileName: _jsxFileName,
                        lineNumber: 370
                      },
                      __self: this
                    },
                    'Delete'
                  )
                )
              )
            )
          ),
          React.createElement(TemplateImageUpload, {
            save: save,
            mode: mode,
            content: content,
            isImageValid: this.state.isImageValid,
            onRemoveImage: this.onRemoveImage,
            onImageInputUrl: this.onChange,
            onChange: this.props.onChange,
            isValidImage: this.isValidImage,
            config: s3config,
            isVideoTemplate: oftype === 'video' ? true : false,
            S3_bucketDetails: S3_bucketDetails,
            __source: {
              fileName: _jsxFileName,
              lineNumber: 379
            },
            __self: this
          }),
          React.createElement(
            'div',
            { key: 'card-' + channel, className: 'bot-response__ItemCardFooter', __source: {
                fileName: _jsxFileName,
                lineNumber: 392
              },
              __self: this
            },
            React.createElement(
              'div',
              {
                className: cx('bot-response__ItemTitle', !content.title.length && 'error'), __source: {
                  fileName: _jsxFileName,
                  lineNumber: 393
                },
                __self: this
              },
              mode === 'preview' ? React.createElement(
                'h5',
                {
                  __source: {
                    fileName: _jsxFileName,
                    lineNumber: 399
                  },
                  __self: this
                },
                content.title
              ) : React.createElement('textarea', {
                rows: content.title.length > 80 ? '5' : '3',
                placeholder: 'Heading (required)',
                disabled: mode === 'save' || mode === 'preview' ? true : false,
                key: 'title-' + this.props.uniqueKey,
                value: content.title,
                onChange: function onChange(event) {
                  _this2.setState({ value: event.target.value });
                  _this2.onChange(event, 'title');
                },
                __source: {
                  fileName: _jsxFileName,
                  lineNumber: 401
                },
                __self: this
              })
            ),
            React.createElement(
              'div',
              { className: 'bot-response__ItemSubtitle', __source: {
                  fileName: _jsxFileName,
                  lineNumber: 416
                },
                __self: this
              },
              mode === 'preview' ? React.createElement(
                'span',
                {
                  __source: {
                    fileName: _jsxFileName,
                    lineNumber: 418
                  },
                  __self: this
                },
                content.subtitle
              ) : React.createElement('textarea', {
                rows: content.subtitle.length > 80 ? '5' : '3',
                placeholder: 'Subtitle or description',
                disabled: mode === 'save' || mode === 'preview' ? true : false,
                key: 'subtitle-' + this.props.uniqueKey,
                value: content.subtitle,
                onChange: function onChange(event) {
                  _this2.setState({ value: event.target.value });
                  _this2.onChange(event, 'subtitle');
                },
                __source: {
                  fileName: _jsxFileName,
                  lineNumber: 420
                },
                __self: this
              })
            )
          ),
          mode !== 'preview' && React.createElement(
            'div',
            {
              __source: {
                fileName: _jsxFileName,
                lineNumber: 437
              },
              __self: this
            },
            content.buttons.map(function (button, index) {
              return React.createElement(
                'div',
                { className: 'buttonsPreview', key: index, __source: {
                    fileName: _jsxFileName,
                    lineNumber: 439
                  },
                  __self: _this2
                },
                React.createElement(
                  'div',
                  {
                    className: cx('preview', (!button.title || !button['payload']) && 'errorButton'),
                    'data-target': cx(showRemove ? '#editCarousel' + id + 'Button' + cardIndex : '#editCard' + id + 'Button') + index,
                    'data-toggle': 'modal',
                    'data-backdrop': 'false',
                    onClick: function onClick(event) {
                      return _this2.onButtonIndexChange(index);
                    }, __source: {
                      fileName: _jsxFileName,
                      lineNumber: 440
                    },
                    __self: _this2
                  },
                  React.createElement(
                    'div',
                    {
                      className: cx('buttonName mt-1 m-t-1', !button.title && 'errorName'), __source: {
                        fileName: _jsxFileName,
                        lineNumber: 455
                      },
                      __self: _this2
                    },
                    button.title ? button.title : 'Enter button name'
                  )
                ),
                React.createElement(
                  'div',
                  {
                    className: 'iconTrash',
                    onClick: function onClick() {
                      return _this2.onButtonRemove(index);
                    }, __source: {
                      fileName: _jsxFileName,
                      lineNumber: 463
                    },
                    __self: _this2
                  },
                  React.createElement(IconResponseDelete, {
                    __source: {
                      fileName: _jsxFileName,
                      lineNumber: 466
                    },
                    __self: _this2
                  })
                ),
                React.createElement(
                  'div',
                  { className: 'buttonsPreviewPopUp', __source: {
                      fileName: _jsxFileName,
                      lineNumber: 468
                    },
                    __self: _this2
                  },
                  React.createElement(Buttons, {
                    field: 'payload',
                    id: cx(showRemove ? 'editCarousel' + id + 'Button' + cardIndex : 'editCard' + id + 'Button') + index,
                    index: index,
                    placeholder: 'Enter button name',
                    content: button,
                    source: 'card',
                    attributes: button.attributes,
                    onButtonChange: _this2.onButtonChange,
                    handleSave: function handleSave(event) {
                      return _this2.handleSave(event);
                    },
                    onHideModal: function onHideModal(index) {
                      return _this2.hideEditButtonModal(index);
                    },
                    uniqueKey: uniqueKey,
                    display: _this2.state.editButtonModal[index] ? 'none' : _this2.state.editButtonModal[index] !== null ? 'block' : '',
                    __source: {
                      fileName: _jsxFileName,
                      lineNumber: 469
                    },
                    __self: _this2
                  })
                )
              );
            }),
            React.createElement(
              'div',
              { className: 'buttonsPreview', __source: {
                  fileName: _jsxFileName,
                  lineNumber: 498
                },
                __self: this
              },
              React.createElement(
                'div',
                {
                  className: 'addButtonAction',
                  'data-toggle': 'modal',
                  'data-target': cx(showRemove ? '#addCarousel' + id + 'Button' + cardIndex : '#addCard' + id + 'Button') + content.buttons.length,
                  'data-backdrop': 'false',
                  onClick: function onClick(event) {
                    return _this2.onAddButton('postback');
                  }, __source: {
                    fileName: _jsxFileName,
                    lineNumber: 499
                  },
                  __self: this
                },
                React.createElement(IconAdd, {
                  __source: {
                    fileName: _jsxFileName,
                    lineNumber: 511
                  },
                  __self: this
                }),
                React.createElement(
                  'span',
                  {
                    __source: {
                      fileName: _jsxFileName,
                      lineNumber: 512
                    },
                    __self: this
                  },
                  'Add button (optional)'
                )
              ),
              React.createElement(Buttons, {
                field: 'payload',
                id: cx(showRemove ? 'addCarousel' + id + 'Button' + cardIndex : 'addCard' + id + 'Button') + content.buttons.length,
                index: content.buttons.length - 1,
                placeholder: 'Enter button name',
                onButtonChange: this.onButtonChange,
                source: 'card',
                content: content.buttons[content.buttons.length - 1],
                handleSave: function handleSave(event) {
                  return _this2.handleSave(event);
                },
                onHideModal: this.hideAddButtonModal,
                intentId: intentId,
                uniqueKey: uniqueKey,
                display: this.state.addButtonModal ? 'none' : this.state.addButtonModal !== null ? 'block' : '',
                __source: {
                  fileName: _jsxFileName,
                  lineNumber: 514
                },
                __self: this
              })
            )
          ),
          mode === 'preview' && React.createElement(
            'div',
            {
              __source: {
                fileName: _jsxFileName,
                lineNumber: 544
              },
              __self: this
            },
            content.buttons.map(function (button) {
              return React.createElement(
                'div',
                {
                  className: cx('preview', (!button.title || !button['payload']) && 'errorButton'), __source: {
                    fileName: _jsxFileName,
                    lineNumber: 546
                  },
                  __self: _this2
                },
                React.createElement(
                  'div',
                  { className: cx('buttonName mt-1 m-t-1'), __source: {
                      fileName: _jsxFileName,
                      lineNumber: 551
                    },
                    __self: _this2
                  },
                  button.title ? button.title : 'Enter button name'
                )
              );
            })
          )
        ),
        oftype && React.createElement(TemplateCardPreview, {
          preview: preview,
          channel: channel,
          content: content,
          onChange: this.props.onSpeechChange,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 560
          },
          __self: this
        })
      );
    }
  }]);

  return TemplateItemCard;
}(Component);

export default TemplateItemCard;