var _jsxFileName = 'src/lib/components/TemplateItemCarousel.js';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import cx from 'classnames';

import TemplateItemCard from './TemplateItemCard';
import IconAdd from '../assets/icons/IconAdd';
import { isDynamicContent } from '../utility/utility';
import generateTemplateMarkup from './TemplateItemMarkupGenerator';

var TemplateItemCarousel = function (_Component) {
  _inherits(TemplateItemCarousel, _Component);

  function TemplateItemCarousel() {
    _classCallCheck(this, TemplateItemCarousel);

    return _possibleConstructorReturn(this, (TemplateItemCarousel.__proto__ || Object.getPrototypeOf(TemplateItemCarousel)).apply(this, arguments));
  }

  _createClass(TemplateItemCarousel, [{
    key: 'onItemChange',
    value: function onItemChange(item, index) {
      var _props = this.props,
          content = _props.content,
          onChange = _props.onChange,
          oftype = _props.oftype;

      content[index] = item;
      onChange(content, 'content');

      var card = content[0];
      if (oftype !== 'video') {
        this.generateDynamicContent(card);
      }
    }
  }, {
    key: 'generateDynamicContent',
    value: function generateDynamicContent(card) {
      var _props2 = this.props,
          onChange = _props2.onChange,
          oftype = _props2.oftype,
          speechResponse = _props2.speechResponse,
          message = _props2.message;

      var custom = message['customTemplateName'];
      if (message['quick_replies'] && message['quick_replies'].length) {
        var quickreply_templateMarkup = message['quickreply_templateMarkup'];
      }
      if (isDynamicContent(card.title) || isDynamicContent(card.subtitle) || isDynamicContent(card.image) || card.buttons[0] && (isDynamicContent(card.buttons[0].title) || isDynamicContent(card.buttons[0].payload))) {
        onChange('carousel', 'base');
        onChange('dynamic', 'type');
        onChange(true, 'dynamicTemplate');
        if (oftype) {
          onChange(generateTemplateMarkup(card, oftype, speechResponse, quickreply_templateMarkup, custom), 'templateMarkup');
        } else {
          onChange(generateTemplateMarkup(card, 'carousel', speechResponse, quickreply_templateMarkup, custom), 'templateMarkup');
        }
      } else {
        onChange(false, 'dynamicTemplate');
      }
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps) {
      if (prevProps.speechResponse !== this.props.speechResponse) {
        var _props3 = this.props,
            dynamicTemplate = _props3.dynamicTemplate,
            speechResponse = _props3.speechResponse,
            onChange = _props3.onChange,
            content = _props3.content,
            oftype = _props3.oftype,
            message = _props3.message;

        var custom = message['customTemplateName'];
        if (message['quick_replies'] && message['quick_replies'].dynamicTemplate) {
          var quickreply_templateMarkup = message['quickreply_templateMarkup'];
        }
        if (dynamicTemplate && speechResponse) {
          if (oftype) {
            onChange(generateTemplateMarkup(content[0], oftype, speechResponse, quickreply_templateMarkup, custom), 'templateMarkup');
          } else {
            onChange(generateTemplateMarkup(content[0], 'carousel', speechResponse, quickreply_templateMarkup, custom), 'templateMarkup');
          }
        }
      }
    }
  }, {
    key: 'onItemRemove',
    value: function onItemRemove(index) {
      var _props4 = this.props,
          content = _props4.content,
          onChange = _props4.onChange;

      content.splice(index, 1);
      onChange(content, 'content');
      if (!content.length) {
        this.props.onDelete();
      }
    }
  }, {
    key: 'onAddCard',
    value: function onAddCard() {
      var _props5 = this.props,
          content = _props5.content,
          onChange = _props5.onChange;

      var item = {
        title: '',
        subtitle: '',
        image: '',
        buttons: []
      };
      var key = Math.floor(Math.random() * 1000) + 1;
      var itemsCount = content.length;
      var index = 0;
      while (true) {
        if (itemsCount === 0 || index === itemsCount) {
          item['key'] = key;
          break;
        } else if (content[index].key !== key) {
          ++index;
        } else {
          key = Math.floor(Math.random() * 1000) + 1;
          index = 0;
        }
      }
      content.push(item);
      onChange(content, 'content');
    }
  }, {
    key: 'componentWillMount',
    value: function componentWillMount() {
      var _props6 = this.props,
          content = _props6.content,
          onChange = _props6.onChange;

      var key = Math.floor(Math.random() * 1000) + 1;
      content.forEach(function (item, itemIndex) {
        var index = 0;
        while (true) {
          if (itemIndex === 0 || index === itemIndex) {
            item['key'] = key;
            break;
          } else if (content[index].key !== key) {
            ++index;
          } else {
            key = Math.floor(Math.random() * 1000) + 1;
            index = 0;
          }
        }
      });

      onChange(content, 'content');
    }
  }, {
    key: 'onMessagePosAlter',
    value: function onMessagePosAlter(index, moveUp) {
      var _props7 = this.props,
          content = _props7.content,
          onChange = _props7.onChange;

      var _content = [].concat(content);
      if (moveUp) {
        _content.splice(index - 1, 0, _content.splice(index, 1)[0]);
      } else {
        _content.splice(index + 1, 0, _content.splice(index, 1)[0]);
      }
      onChange(_content, 'content');
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props8 = this.props,
          content = _props8.content,
          save = _props8.save,
          testImage = _props8.testImage,
          id = _props8.id,
          mode = _props8.mode,
          intentId = _props8.intentId,
          oftype = _props8.oftype,
          preview = _props8.preview,
          channel = _props8.channel,
          s3config = _props8.s3config,
          dynamicTemplate = _props8.dynamicTemplate,
          uniqueKey = _props8.uniqueKey,
          S3_bucketDetails = _props8.S3_bucketDetails,
          message = _props8.message;

      return React.createElement(
        'div',
        { className: 'w-i', __source: {
            fileName: _jsxFileName,
            lineNumber: 194
          },
          __self: this
        },
        mode !== 'preview' && dynamicTemplate && React.createElement(
          'div',
          { key: 'carousel-' + channel, className: 'bot-response__Key', __source: {
              fileName: _jsxFileName,
              lineNumber: 196
            },
            __self: this
          },
          React.createElement('textarea', {
            className: 'w-100',
            maxLength: '80',
            placeholder: 'Enter key name:',
            key: uniqueKey + '-keyName',
            value: content[0].keyName,
            onChange: function onChange(event) {
              _this2.setState({ value: event.target.value });
              content[0]['keyName'] = event.target.value;
              _this2.generateDynamicContent(content[0]);
              _this2.props.onChange(content, 'content');
            },
            __source: {
              fileName: _jsxFileName,
              lineNumber: 197
            },
            __self: this
          })
        ),
        React.createElement(
          'div',
          { className: 'bot-response__ItemCarousel w-i', __source: {
              fileName: _jsxFileName,
              lineNumber: 212
            },
            __self: this
          },
          content.map(function (item, index) {
            return React.createElement(TemplateItemCard, {
              content: item,
              id: id,
              onChange: function onChange(data) {
                return _this2.onItemChange(data, index);
              },
              onRemove: function onRemove() {
                return _this2.onItemRemove(index);
              },
              testImage: testImage,
              key: item.key,
              mode: mode,
              cardIndex: index,
              showRemove: true,
              save: save,
              canDrag: true,
              intentId: intentId,
              oftype: oftype,
              preview: preview,
              channel: channel,
              s3config: s3config,
              type: 'carousel',
              dynamicTemplate: dynamicTemplate,
              hideUpIcon: index === 0 ? true : false,
              hideDownIcon: index === content.length - 1 ? true : false,
              onMessagePosAlter: _this2.onMessagePosAlter.bind(_this2),
              uniqueKey: '' + uniqueKey + index,
              S3_bucketDetails: S3_bucketDetails,
              message: message,
              __source: {
                fileName: _jsxFileName,
                lineNumber: 214
              },
              __self: _this2
            });
          }),
          mode !== 'preview' && oftype !== 'card' && oftype !== 'video' && React.createElement(
            'div',
            {
              className: cx('bot-response__ItemCarouselAdd mr-3 m-r-3', dynamicTemplate && 'mt-44'),
              onClick: this.onAddCard.bind(this), __source: {
                fileName: _jsxFileName,
                lineNumber: 242
              },
              __self: this
            },
            React.createElement(IconAdd, { className: 'iconAdd', __source: {
                fileName: _jsxFileName,
                lineNumber: 248
              },
              __self: this
            })
          )
        ),
        React.createElement('hr', {
          __source: {
            fileName: _jsxFileName,
            lineNumber: 252
          },
          __self: this
        })
      );
    }
  }]);

  return TemplateItemCarousel;
}(Component);

export default TemplateItemCarousel;