var _jsxFileName = 'src/lib/components/TemplateItemCustom.js';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import AceEditor from 'react-ace';

import { TabContent, TabPane, Nav, NavItem, NavLink, Row, Col } from 'reactstrap';
import { Dropdown, DropdownToggle, DropdownMenu, DropdownItem } from 'reactstrap';

import cx from 'classnames';

var TemplateItemCustom = function (_Component) {
  _inherits(TemplateItemCustom, _Component);

  function TemplateItemCustom(props) {
    _classCallCheck(this, TemplateItemCustom);

    var _this = _possibleConstructorReturn(this, (TemplateItemCustom.__proto__ || Object.getPrototypeOf(TemplateItemCustom)).call(this, props));

    _this.state = {
      activeTab: '1',
      sourceCode: '',
      dropdownOpen: false,
      name: '',
      base: '',
      customTemplateAttributes: {}
    };

    _this.toggle = _this.toggle.bind(_this);
    _this.dropdownToggle = _this.dropdownToggle.bind(_this);
    _this.handleSourceCodeChange = _this.handleSourceCodeChange.bind(_this);
    return _this;
  }

  _createClass(TemplateItemCustom, [{
    key: 'getUniqueId',
    value: function getUniqueId() {
      var date = new Date();
      var components = [date.getYear(), date.getMonth(), date.getDate(), date.getHours(), date.getMinutes(), date.getSeconds(), date.getMilliseconds()];

      return components.join('');
    }
  }, {
    key: 'onCustomTemplateAttributesChange',
    value: function onCustomTemplateAttributesChange(event, key) {
      var id = this.props.id;

      if (key === 'base') {
        var base = event.target.innerText.toLowerCase();
        var sourceCode = '';

        if (base === 'rblist' || base === 'rbconf') {
          sourceCode = '<div class="panel panel-default list-custom-template"> \n        {{#each payload.accounts}} \n          <div class="panel-body"  data-customTemplate="' + id + '" data-element="true" data-title="{{{title}}}" data-subTitle="{{{subTitle}}}" data-image="{{image}}"> \n            <div class="row"> \n              <div class="col-md-7 col-xs-7">\n                {{#if title}} \n                    <h4 class="list-heading">{{title}}</h4>\n                {{/if}}\n                {{#if subTitle}} \n                    <p class="list-subtitle">{{subTitle}}</p>\n                {{/if}} \n                {{#each buttons}} \n                    <button class="btn btn-primary btn-outline" data-button="true" data-title="{{title}}" data-type="{{type}}" data-payload="{{payload}}" data-webview-type="{{webview_type}}" data-auth="{{auth_required}}" data-intent="{{intent}}" data-postback="{{postback}}" data-extra-payload="{{extra_payload}}" data-button-life="{{life}}" data-message="{{message}}">{{title}}</button> \n                {{/each}}\n                </div> \n              <div class="col-md-5 col-xs-5 text-right"> \n                <img width="100" src="{{image}}" class="img-responsive pull-right"> \n              </div> \n            </div> \n          </div> \n        {{/each}} \n    </div>';
        }
        this.handleSourceCodeChange(sourceCode);

        this.setState({
          sourceCode: sourceCode,
          base: base
        });

        this.props.onChange(base, 'base');
        this.props.onChange(sourceCode, 'content');
      }
      // this.saveCustomTemplateAttributes()

      if (key === 'name') {
        var name = event.target.value;
        this.setState({
          name: name
        });
        this.saveCustomTemplateAttributes(name);
      }
      //@If we directly go to WE, give name first, then change dropdown
      //base was not updating to baseTemplate
      if (this.props.message.name) {
        delete this.props.message['customTemplate'];
        this.props.message.base = 'baseTemplate';
      }
    }
  }, {
    key: 'getTemplateMarkup',
    value: function getTemplateMarkup(id, quickreply, code) {
      if (this.state.base === 'rblist' || this.state.base === 'rbconf') {
        return '<div class="panel panel-default list-custom-template"> \n      {{#each payload.accounts}} \n        <div class="panel-body" data-customTemplate="' + id + '" data-element="true" data-title="{{{title}}}" data-subTitle="{{{subTitle}}}" data-image="{{image}}"> \n          <div class="row"> \n            <div class="col-md-7 col-xs-7">\n              {{#if title}} \n                  <h4 class="list-heading">{{title}}</h4>\n              {{/if}}\n              {{#if subTitle}} \n                  <p class="list-subtitle">{{subTitle}}</p>\n              {{/if}} \n              {{#each buttons}} \n                  <button class="btn btn-primary btn-outline" data-button="true" data-title="{{title}}" data-type="{{type}}" data-payload="{{payload}}" data-webview-type="{{webview_type}}" data-auth="{{auth_required}}" data-intent="{{intent}}" data-postback="{{postback}}" data-extra-payload="{{extra_payload}}" data-button-life="{{life}}" data-message="{{message}}">{{title}}</button> \n              {{/each}}\n              </div> \n            <div class="col-md-5 col-xs-5 text-right"> \n              <img width="100" src="{{image}}" class="img-responsive pull-right"> \n            </div> \n          </div> \n        </div> \n      {{/each}} \n  </div> ' + quickreply;
      } else {
        var replacedCustomTemplateValue = this.replaceCustomTemplateValue(code, id);
        return code.indexOf(id) !== -1 ? code + quickreply : replacedCustomTemplateValue ? replacedCustomTemplateValue + quickreply : ' <div data-customTemplate="' + id + '">' + code + '</div>' + quickreply;
      }
    }
  }, {
    key: 'saveCustomTemplateAttributes',
    value: function saveCustomTemplateAttributes(name, index, key) {
      var _props = this.props,
          onChange = _props.onChange,
          message = _props.message;

      onChange(name, 'name');
      onChange(this.state.base, 'base');
      var quickreply_templateMarkup = '';
      if (message['quick_replies'] && message['quick_replies'].length) {
        quickreply_templateMarkup = message['quickreply_templateMarkup'];
      }
      var templateMarkup = '';
      if (name) {
        templateMarkup = this.getTemplateMarkup(this.props.id, quickreply_templateMarkup, this.state.sourceCode);
      }
      onChange(templateMarkup, 'templateMarkup');
      if (message.name) {
        delete message['customTemplate'];
        message.base = 'baseTemplate';
        //this.props.onResponeTypeChange(message, message.customTemplate);
      }

      this.props.hideAndShowTemplateTypeChoice(true);
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _props2 = this.props,
          content = _props2.content,
          message = _props2.message;

      var sourceCode = '';
      if (content) {
        sourceCode = content;
      }
      this.setState({
        sourceCode: sourceCode
      });
      if (message) {
        this.setState({
          name: message.name,
          base: message.base
        });
      }
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps, prevState) {
      if (prevProps.content !== this.props.content) {
        this.setState({
          sourceCode: this.props.content
        });
      }
    }
  }, {
    key: 'toggle',
    value: function toggle(tab) {
      if (this.state.activeTab !== tab) {
        this.setState({
          activeTab: tab
        });
      }
    }
  }, {
    key: 'dropdownToggle',
    value: function dropdownToggle() {
      this.setState(function (prevState) {
        return {
          dropdownOpen: !prevState.dropdownOpen
        };
      });
    }
  }, {
    key: 'handleSourceCodeChange',
    value: function handleSourceCodeChange(code) {
      var _props3 = this.props,
          onChange = _props3.onChange,
          id = _props3.id,
          message = _props3.message;

      // if (this.state.base === 'rblist' || this.state.base === 'rbconf') {
      // onChange(true, 'customTemplate');
      // } else {

      if (code.trim().length === 0) {
        this.setState({ base: '' });
      }

      if (!id) {
        var _id = this.getUniqueId();
        onChange(_id, 'id');
      }
      onChange(code, 'content');

      var quickreply_templateMarkup = '';
      if (message['quick_replies'] && message['quick_replies'].length) {
        quickreply_templateMarkup = message['quickreply_templateMarkup'];
      }
      var templateMarkup = this.getTemplateMarkup(id, quickreply_templateMarkup, code);
      onChange(templateMarkup, 'templateMarkup');
      onChange(true, 'dynamicTemplate');
      // }
    }
  }, {
    key: 'replaceCustomTemplateValue',
    value: function replaceCustomTemplateValue(str, id) {
      if (str.indexOf('data-customTemplate') === -1) {
        return '';
      }
      var firstIndex = str.indexOf('"', str.indexOf('data-customTemplate') + 19);
      var lastIndex = str.indexOf('"', firstIndex + 1);
      return str.substring(0, firstIndex + 1) + id + str.substring(lastIndex);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props4 = this.props,
          mode = _props4.mode,
          message = _props4.message;

      return React.createElement(
        'div',
        {
          className: 'bot-response__ItemRBList',
          style: { position: 'relative' }, __source: {
            fileName: _jsxFileName,
            lineNumber: 255
          },
          __self: this
        },
        mode !== 'preview' ? React.createElement(
          'div',
          {
            __source: {
              fileName: _jsxFileName,
              lineNumber: 259
            },
            __self: this
          },
          React.createElement(
            'div',
            { className: 'd-flex flex-display', __source: {
                fileName: _jsxFileName,
                lineNumber: 260
              },
              __self: this
            },
            React.createElement('input', {
              type: 'text',
              placeholder: 'Enter name',
              className: 'mb-2 m-b-2',
              value: message.name ? message.name : '',
              style: { height: '42px' },
              onChange: function onChange(event) {
                return _this2.onCustomTemplateAttributesChange(event, 'name');
              },
              __source: {
                fileName: _jsxFileName,
                lineNumber: 261
              },
              __self: this
            }),
            React.createElement(
              Dropdown,
              {
                isOpen: this.state.dropdownOpen,
                toggle: this.dropdownToggle,
                className: 'ml-2 m-l-2 mb-1 mt-1 m-t-1',
                id: 'channelResponse', __source: {
                  fileName: _jsxFileName,
                  lineNumber: 272
                },
                __self: this
              },
              React.createElement(
                DropdownToggle,
                { caret: true, __source: {
                    fileName: _jsxFileName,
                    lineNumber: 277
                  },
                  __self: this
                },
                'Type'
              ),
              React.createElement(
                DropdownMenu,
                {
                  __source: {
                    fileName: _jsxFileName,
                    lineNumber: 278
                  },
                  __self: this
                },
                React.createElement(
                  DropdownItem,
                  {
                    onClick: function onClick(event) {
                      return _this2.onCustomTemplateAttributesChange(event, 'base');
                    }, __source: {
                      fileName: _jsxFileName,
                      lineNumber: 279
                    },
                    __self: this
                  },
                  'rblist'
                ),
                React.createElement(
                  DropdownItem,
                  {
                    onClick: function onClick(event) {
                      return _this2.onCustomTemplateAttributesChange(event, 'base');
                    }, __source: {
                      fileName: _jsxFileName,
                      lineNumber: 285
                    },
                    __self: this
                  },
                  'rbconf'
                ),
                React.createElement(
                  DropdownItem,
                  {
                    onClick: function onClick(event) {
                      return _this2.onCustomTemplateAttributesChange(event, 'base');
                    }, __source: {
                      fileName: _jsxFileName,
                      lineNumber: 291
                    },
                    __self: this
                  },
                  'image'
                )
              )
            )
          ),
          React.createElement(
            Nav,
            { tabs: true, __source: {
                fileName: _jsxFileName,
                lineNumber: 301
              },
              __self: this
            },
            React.createElement(
              NavItem,
              {
                __source: {
                  fileName: _jsxFileName,
                  lineNumber: 302
                },
                __self: this
              },
              React.createElement(
                NavLink,
                {
                  className: cx({ active: this.state.activeTab === '1' }),
                  onClick: function onClick() {
                    _this2.toggle('1');
                  }, __source: {
                    fileName: _jsxFileName,
                    lineNumber: 303
                  },
                  __self: this
                },
                'Source'
              )
            ),
            React.createElement(
              NavItem,
              {
                __source: {
                  fileName: _jsxFileName,
                  lineNumber: 311
                },
                __self: this
              },
              React.createElement(
                NavLink,
                {
                  className: cx({ active: this.state.activeTab === '2' }),
                  onClick: function onClick() {
                    _this2.toggle('2');
                  }, __source: {
                    fileName: _jsxFileName,
                    lineNumber: 312
                  },
                  __self: this
                },
                'Preview'
              )
            )
          ),
          React.createElement(
            TabContent,
            { activeTab: this.state.activeTab, __source: {
                fileName: _jsxFileName,
                lineNumber: 321
              },
              __self: this
            },
            React.createElement(
              TabPane,
              { tabName: 'source', tabId: '1', __source: {
                  fileName: _jsxFileName,
                  lineNumber: 322
                },
                __self: this
              },
              React.createElement(
                Row,
                {
                  __source: {
                    fileName: _jsxFileName,
                    lineNumber: 323
                  },
                  __self: this
                },
                React.createElement(
                  Col,
                  { className: 'codem', __source: {
                      fileName: _jsxFileName,
                      lineNumber: 324
                    },
                    __self: this
                  },
                  React.createElement(AceEditor, {
                    mode: 'html',
                    theme: 'github',
                    onChange: this.handleSourceCodeChange,
                    name: 'source_code',
                    value: this.state.sourceCode || message.content,
                    __source: {
                      fileName: _jsxFileName,
                      lineNumber: 325
                    },
                    __self: this
                  })
                )
              )
            ),
            React.createElement(
              TabPane,
              { tabId: '2', __source: {
                  fileName: _jsxFileName,
                  lineNumber: 335
                },
                __self: this
              },
              React.createElement(
                Row,
                {
                  __source: {
                    fileName: _jsxFileName,
                    lineNumber: 336
                  },
                  __self: this
                },
                React.createElement(
                  Col,
                  {
                    __source: {
                      fileName: _jsxFileName,
                      lineNumber: 337
                    },
                    __self: this
                  },
                  React.createElement('div', {
                    dangerouslySetInnerHTML: {
                      __html: this.state.sourceCode
                    },
                    __source: {
                      fileName: _jsxFileName,
                      lineNumber: 338
                    },
                    __self: this
                  })
                )
              )
            )
          )
        ) : React.createElement(
          'div',
          { className: 'bot-response__ItemTextAreaWrapper', __source: {
              fileName: _jsxFileName,
              lineNumber: 349
            },
            __self: this
          },
          React.createElement(
            'div',
            { className: 'bot-response__ItemTextArea', __source: {
                fileName: _jsxFileName,
                lineNumber: 350
              },
              __self: this
            },
            React.createElement(
              'div',
              { className: 'bot-response__ItemTextPreview', __source: {
                  fileName: _jsxFileName,
                  lineNumber: 351
                },
                __self: this
              },
              'Custom Template'
            )
          )
        )
      );
    }
  }]);

  return TemplateItemCustom;
}(Component);

export default TemplateItemCustom;