import _regeneratorRuntime from 'babel-runtime/regenerator';
var _jsxFileName = 'src/lib/components/TemplateItemImage.js';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';

import TemplateImageUpload from './TemplateItemUploadImage';
import TemplateImagePreview from './TemplateImagePreview';
import { isDynamicContent } from '../utility/utility';
import generateTemplateMarkup from './TemplateItemMarkupGenerator';

var TemplateItemImage = function (_Component) {
  _inherits(TemplateItemImage, _Component);

  function TemplateItemImage(props) {
    _classCallCheck(this, TemplateItemImage);

    var _this = _possibleConstructorReturn(this, (TemplateItemImage.__proto__ || Object.getPrototypeOf(TemplateItemImage)).call(this, props));

    _this.state = {
      isImageValid: null
    };
    _this.onRemoveImage = _this.onRemoveImage.bind(_this);
    _this.onChange = _this.onChange.bind(_this);
    _this.isValidImage = _this.isValidImage.bind(_this);
    return _this;
  }

  _createClass(TemplateItemImage, [{
    key: 'isValidImage',
    value: function () {
      var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(url) {
        var isImageValid;
        return _regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (!(url.indexOf('data:image') >= 0)) {
                  _context.next = 4;
                  break;
                }

                this.setState({ isImageValid: true });
                _context.next = 15;
                break;

              case 4:
                _context.prev = 4;
                _context.next = 7;
                return this.props.testImage(url);

              case 7:
                isImageValid = _context.sent;

                this.setState({ isImageValid: isImageValid });
                _context.next = 15;
                break;

              case 11:
                _context.prev = 11;
                _context.t0 = _context['catch'](4);

                this.setState({ isImageValid: false });
                console.error(_context.t0);

              case 15:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this, [[4, 11]]);
      }));

      function isValidImage(_x) {
        return _ref.apply(this, arguments);
      }

      return isValidImage;
    }()
  }, {
    key: 'onChange',
    value: function onChange(event, field) {
      var _props = this.props,
          content = _props.content,
          onChange = _props.onChange,
          speechResponse = _props.speechResponse,
          message = _props.message;

      content[field] = event.target.value.trim();
      if (isDynamicContent(event.target.value)) {
        if (message['quick_replies'] && message['quick_replies'].length) {
          var quickreply_templateMarkup = message['quickreply_templateMarkup'];
        }
        onChange('image', 'base');
        onChange('dynamic', 'type');
        onChange(true, 'dynamicTemplate');
        onChange(generateTemplateMarkup(content, 'image', speechResponse, quickreply_templateMarkup), 'templateMarkup');
      } else {
        onChange(false, 'dynamicTemplate');
      }
      onChange(content, 'content');
      this.isValidImage(event.target.value);
    }
  }, {
    key: 'onRemoveImage',
    value: function onRemoveImage() {
      var _props2 = this.props,
          content = _props2.content,
          onChange = _props2.onChange;

      content.image = '';
      this.setState({
        isImageValid: null
      });
      onChange(content, 'content');
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      var content = this.props.content;

      if (content.image) {
        this.isValidImage(content.image);
      }
    }
  }, {
    key: 'toggleSpeech',
    value: function toggleSpeech(_ref2) {
      var enabled = _ref2.enabled;

      this.setState({
        preview: enabled
      });
      this.props.onSpeechResponseToggle(enabled, 'speechResponse');
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps) {
      if (prevProps.speechResponse !== this.props.speechResponse) {
        var _props3 = this.props,
            dynamicTemplate = _props3.dynamicTemplate,
            speechResponse = _props3.speechResponse,
            onChange = _props3.onChange,
            content = _props3.content,
            message = _props3.message;

        if (dynamicTemplate && speechResponse) {
          if (message['quick_replies'] && message['quick_replies'].length) {
            var quickreply_templateMarkup = message['quickreply_templateMarkup'];
          }
          onChange(generateTemplateMarkup(content, 'image', speechResponse, quickreply_templateMarkup), 'templateMarkup');
        }
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props4 = this.props,
          content = _props4.content,
          save = _props4.save,
          mode = _props4.mode,
          preview = _props4.preview,
          channel = _props4.channel,
          s3config = _props4.s3config,
          uniqueKey = _props4.uniqueKey,
          S3_bucketDetails = _props4.S3_bucketDetails;
      var isImageValid = this.state.isImageValid;

      return React.createElement(
        'div',
        { className: 'bot-response__ItemCard', __source: {
            fileName: _jsxFileName,
            lineNumber: 110
          },
          __self: this
        },
        React.createElement(
          'div',
          { className: 'bot-response__ItemCardBody', __source: {
              fileName: _jsxFileName,
              lineNumber: 111
            },
            __self: this
          },
          React.createElement(TemplateImageUpload, {
            save: save,
            mode: mode,
            content: content,
            isImageValid: isImageValid,
            onImageInputUrl: this.onChange,
            onRemoveImage: this.onRemoveImage,
            onChange: function onChange(content) {
              _this2.props.onChange(content, 'content');
            },
            isValidImage: this.isValidImage,
            config: s3config,
            keys: 'image-' + channel,
            uniqueKey: uniqueKey,
            S3_bucketDetails: S3_bucketDetails,
            __source: {
              fileName: _jsxFileName,
              lineNumber: 112
            },
            __self: this
          })
        ),
        React.createElement(TemplateImagePreview, {
          content: content,
          channel: channel,
          preview: preview,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 129
          },
          __self: this
        }),
        React.createElement('hr', {
          __source: {
            fileName: _jsxFileName,
            lineNumber: 134
          },
          __self: this
        })
      );
    }
  }]);

  return TemplateItemImage;
}(Component);

export default TemplateItemImage;