import _regeneratorRuntime from 'babel-runtime/regenerator';
var _jsxFileName = 'src/lib/components/TemplateItemList.js';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import cx from 'classnames';

import TemplateItemListChild from './TemplateItemListChild';
import IconAdd from '../assets/icons/IconAdd';
import Buttons from './TemplateButton';
import TemplateImageUpload from './TemplateItemUploadImage';
import { isDynamicContent } from '../utility/utility';
import generateTemplateMarkup from './TemplateItemMarkupGenerator';
import CustomTemplateAtrribute from './CustomTemplateAttribute';
import TemplateListPreview from './TemplateListPreview';

var defaultRows = 2;

var TemplateItemList = function (_Component) {
  _inherits(TemplateItemList, _Component);

  function TemplateItemList(props) {
    _classCallCheck(this, TemplateItemList);

    var _this = _possibleConstructorReturn(this, (TemplateItemList.__proto__ || Object.getPrototypeOf(TemplateItemList)).call(this, props));

    _this.state = {
      itemWithCoverImage: false,
      isImageValid: null,
      showMoreModal: null,
      rows: defaultRows
    };
    _this.onHeaderContentChange = _this.onHeaderContentChange.bind(_this);
    _this.onAddItem = _this.onAddItem.bind(_this);
    _this.isValidImage = _this.isValidImage.bind(_this);
    _this.onItemChange = _this.onItemChange.bind(_this);
    _this.onButtonChange = _this.onButtonChange.bind(_this);
    _this.onAddShowMoreButton = _this.onAddShowMoreButton.bind(_this);
    _this.hideAddButtonModal = _this.hideAddButtonModal.bind(_this);
    return _this;
  }

  _createClass(TemplateItemList, [{
    key: 'onChange',
    value: function onChange(event, field) {
      var _props = this.props,
          content = _props.content,
          onChange = _props.onChange,
          message = _props.message;

      var custom = message['customTemplateName'];
      content[field] = event.target.value;
      onChange(content, 'content');
      if (message['quick_replies'] && message['quick_replies'].length) {
        var quickreply_templateMarkup = message['quickreply_templateMarkup'];
      }
      onChange(generateTemplateMarkup(content, 'list', quickreply_templateMarkup, custom), 'templateMarkup');
    }
  }, {
    key: 'onItemChange',
    value: function onItemChange(item, index) {
      var _props2 = this.props,
          content = _props2.content,
          onChange = _props2.onChange,
          speechResponse = _props2.speechResponse,
          message = _props2.message;

      var __item = content.style === 'compact' ? content.list[0] : content.list[1];

      if (index === 0 || index === 1) {
        __item = item;
      }
      var _item = __item,
          title = _item.title,
          subtitle = _item.subtitle,
          image = _item.image;

      var custom = message['customTemplateName'];
      if (isDynamicContent(title) || isDynamicContent(subtitle) || isDynamicContent(image) || __item.buttons[0] && (isDynamicContent(__item.buttons[0].title) || isDynamicContent(__item.buttons[0].payload)) || content.style === 'large' && isDynamicContent(content.header.title)) {
        if (message['quick_replies'] && message['quick_replies'].length) {
          var quickreply_templateMarkup = message['quickreply_templateMarkup'];
        }
        onChange('list', 'base');
        onChange('dynamic', 'type');
        onChange(true, 'dynamicTemplate');
        onChange(generateTemplateMarkup(content, 'list', speechResponse, quickreply_templateMarkup, custom), 'templateMarkup');
      } else {
        onChange(false, 'dynamicTemplate');
      }

      content.list[index] = item;
      onChange(content, 'content');
    }
  }, {
    key: 'onButtonChange',
    value: function onButtonChange(value, index, field) {
      var _props3 = this.props,
          content = _props3.content,
          showMore = _props3.content.showMore,
          onChange = _props3.onChange,
          message = _props3.message;

      var custom = message['customTemplateName'];

      if (field === 'attributes') {
        showMore.buttons[index]['attributes'] = value;
      } else if (field !== 'title') {
        showMore.buttons[index]['type'] = field;
        showMore.buttons[index]['payload'] = value;
      } else {
        showMore.buttons[index][field] = value;
      }
      if (message['quick_replies'] && message['quick_replies'].length) {
        var quickreply_templateMarkup = message['quickreply_templateMarkup'];
      }
      content.showMore = showMore;
      onChange(content, 'content');
      onChange(generateTemplateMarkup(content, 'list', quickreply_templateMarkup, custom), 'templateMarkup');
    }
  }, {
    key: 'onAddShowMoreButton',
    value: function onAddShowMoreButton(type) {
      var _props4 = this.props,
          content = _props4.content,
          onChange = _props4.onChange,
          intentId = _props4.intentId,
          message = _props4.message;

      var showMoreModal = [].concat(this.state.showMoreModal);
      var custom = message['customTemplateName'];

      if (!content.showMore) {
        content.showMore = {};
        content.showMore.buttons = content.showMore.buttons || [];
        content.showMore.buttons.push({
          title: 'Show More',
          type: type,
          attributes: {},
          payload: intentId ? '{"data":{"options":"no"}, "intent": "' + intentId + '"}' : '{"data":{"options":"no"}, "intent": ""}'
        });
        if (message['quick_replies'].length) {
          var quickreply_templateMarkup = message['quickreply_templateMarkup'];
        }
        onChange(content, 'content');
        onChange(generateTemplateMarkup(content, 'list', quickreply_templateMarkup, custom), 'templateMarkup');
      }

      showMoreModal.push(null);
      this.setState({
        showMoreModal: showMoreModal
      });

      this.setState({
        showMoreModal: false
      });
    }
  }, {
    key: 'hideAddButtonModal',
    value: function hideAddButtonModal() {
      this.setState({
        showMoreModal: true
      });
      document.querySelector('body').classList.remove('modal-open');
    }
  }, {
    key: 'onItemRemove',
    value: function onItemRemove(index) {
      var _props5 = this.props,
          content = _props5.content,
          onChange = _props5.onChange;
      var itemWithCoverImage = this.state.itemWithCoverImage;

      itemWithCoverImage = index === 0 && itemWithCoverImage ? false : itemWithCoverImage;
      this.setState({
        itemWithCoverImage: itemWithCoverImage
      });
      if (index === 0 || content.style === 'large' && index === 1) {
        onChange(false, 'dynamicTemplate');
      }
      content.list.splice(index, 1);
      onChange(content, 'content');
      if (!content.list.length) {
        this.props.onDelete();
      }
    }
  }, {
    key: 'onAddItem',
    value: function onAddItem() {
      var _props6 = this.props,
          content = _props6.content,
          onChange = _props6.onChange;

      var item = {
        title: '',
        subtitle: '',
        image: '',
        buttons: []
      };
      var key = Math.floor(Math.random() * 1000) + 1;
      var itemsCount = content.list.length;
      var index = 0;
      while (true) {
        if (itemsCount === 0 || index === itemsCount) {
          item['key'] = key;
          break;
        } else if (content.list[index].key !== key) {
          ++index;
        } else {
          key = Math.floor(Math.random() * 1000) + 1;
          index = 0;
        }
      }
      content.list.push(item);
      onChange(content, 'content');
    }
  }, {
    key: 'isValidImage',
    value: function () {
      var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(url) {
        var isImageValid;
        return _regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (!(url.indexOf('data:image') >= 0)) {
                  _context.next = 4;
                  break;
                }

                this.setState({ isImageValid: true });
                _context.next = 15;
                break;

              case 4:
                _context.prev = 4;
                _context.next = 7;
                return this.props.testImage(url);

              case 7:
                isImageValid = _context.sent;

                this.setState({ isImageValid: isImageValid });
                _context.next = 15;
                break;

              case 11:
                _context.prev = 11;
                _context.t0 = _context['catch'](4);

                this.setState({ isImageValid: false });
                console.error(_context.t0);

              case 15:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this, [[4, 11]]);
      }));

      function isValidImage(_x) {
        return _ref.apply(this, arguments);
      }

      return isValidImage;
    }()
  }, {
    key: 'onHeaderContentChange',
    value: function onHeaderContentChange(event, field) {
      var _props7 = this.props,
          content = _props7.content,
          onChange = _props7.onChange,
          dynamicTemplate = _props7.dynamicTemplate,
          message = _props7.message;

      content.header[field] = event.target.value.trim();
      var custom = message['customTemplateName'];
      if (message['quick_replies'] && message['quick_replies'].length) {
        var quickreply_templateMarkup = message['quickreply_templateMarkup'];
      }
      if (content.style === 'large') {
        content.list[0][field] = event.target.value;
        if (isDynamicContent(event.target.value) && !dynamicTemplate) {
          onChange(true, 'dynamicTemplate');
          onChange(generateTemplateMarkup(content, 'list', quickreply_templateMarkup, custom), 'templateMarkup');
        }
      }
      if (field === 'image') {
        this.isValidImage(event.target.value);
      } else {
        var rows = ~~(event.target.value.length / 35) + 1;
        if (rows > defaultRows) {
          this.setState({
            rows: rows
          });
        } else {
          this.setState({
            rows: defaultRows
          });
        }
      }
      if (dynamicTemplate) {
        onChange(generateTemplateMarkup(content, 'list', quickreply_templateMarkup, custom), 'templateMarkup');
      }
      onChange(content, 'content');
    }
  }, {
    key: 'onRemoveImage',
    value: function onRemoveImage() {
      var _props8 = this.props,
          content = _props8.content,
          onChange = _props8.onChange;

      content.header.image = '';
      if (content.style === 'large') {
        content.list[0].image = '';
      }
      onChange(content, 'content');
      this.setState({
        isImageValid: null
      });
    }
  }, {
    key: 'componentWillMount',
    value: function componentWillMount() {
      var _props9 = this.props,
          content = _props9.content,
          onChange = _props9.onChange;

      var key = Math.floor(Math.random() * 1000) + 1;
      if (content.title || content.image) {
        var item = {};
        item.title = content.title;
        item.image = content.image;
        content.list.unshift(item);
        content.header = item;
        content.style = 'large';
      }
      if (content.header && content.header.image) {
        this.isValidImage(content.header.image);
      }
      content.list.forEach(function (item, itemIndex) {
        if (itemIndex) {
          var index = 0;
          while (true) {
            if (index === itemIndex) {
              item['key'] = key;
              break;
            } else if (content.list[index].key !== key) {
              ++index;
            } else {
              key = Math.floor(Math.random() * 1000) + 1;
              index = 0;
            }
          }
        }
      });

      onChange(content, 'content');
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps) {
      if (prevProps.speechResponse !== this.props.speechResponse) {
        var _props10 = this.props,
            dynamicTemplate = _props10.dynamicTemplate,
            speechResponse = _props10.speechResponse,
            onChange = _props10.onChange,
            content = _props10.content,
            message = _props10.message;


        if (dynamicTemplate && speechResponse) {
          var custom = message['customTemplateName'];
          if (message['quick_replies'] && message['quick_replies'].length) {
            var quickreply_templateMarkup = message['quickreply_templateMarkup'];
          }
          onChange(generateTemplateMarkup(content, 'list', speechResponse, quickreply_templateMarkup, custom), 'templateMarkup');
        }
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props11 = this.props,
          content = _props11.content,
          save = _props11.save,
          id = _props11.id,
          mode = _props11.mode,
          testImage = _props11.testImage,
          intentId = _props11.intentId,
          preview = _props11.preview,
          channel = _props11.channel,
          s3config = _props11.s3config,
          dynamicTemplate = _props11.dynamicTemplate,
          uniqueKey = _props11.uniqueKey,
          S3_bucketDetails = _props11.S3_bucketDetails,
          message = _props11.message;
      var itemWithCoverImage = this.state.itemWithCoverImage;


      if (!content.header) {
        content.header = {
          title: '',
          image: ''
        };
      }

      return React.createElement(
        'div',
        {
          __source: {
            fileName: _jsxFileName,
            lineNumber: 365
          },
          __self: this
        },
        React.createElement(
          'div',
          {
            className: 'bot-response__ItemList',
            style: { position: 'relative' }, __source: {
              fileName: _jsxFileName,
              lineNumber: 366
            },
            __self: this
          },
          (channel === 'wn' || channel === 'wg' || channel === 'gw') && React.createElement(CustomTemplateAtrribute, {
            message: message,
            onChange: this.props.onChange,
            uniqueKey: uniqueKey,
            __source: {
              fileName: _jsxFileName,
              lineNumber: 370
            },
            __self: this
          }),
          mode !== 'preview' && dynamicTemplate && React.createElement(
            'div',
            { className: 'bot-response__Key', __source: {
                fileName: _jsxFileName,
                lineNumber: 377
              },
              __self: this
            },
            React.createElement('textarea', {
              className: 'w-100',
              maxLength: '80',
              key: uniqueKey + '-keyName',
              placeholder: 'Enter key name:',
              value: content.keyName,
              onChange: function onChange(event) {
                _this2.setState({ value: event.target.value });
                _this2.onChange(event, 'keyName');
              },
              __source: {
                fileName: _jsxFileName,
                lineNumber: 378
              },
              __self: this
            })
          ),
          content.previewUrl && React.createElement('div', {
            className: 'imageRender',
            style: { backgroundImage: 'url(' + content.previewUrl + ')' },
            __source: {
              fileName: _jsxFileName,
              lineNumber: 393
            },
            __self: this
          }),
          React.createElement(
            'div',
            {
              __source: {
                fileName: _jsxFileName,
                lineNumber: 398
              },
              __self: this
            },
            React.createElement(
              'div',
              {
                __source: {
                  fileName: _jsxFileName,
                  lineNumber: 400
                },
                __self: this
              },
              React.createElement(TemplateImageUpload, {
                save: save,
                content: content.header,
                isImageValid: this.state.isImageValid,
                onImageInputUrl: this.onHeaderContentChange,
                onRemoveImage: function onRemoveImage() {
                  return _this2.onRemoveImage();
                },
                mode: mode,
                onChange: function onChange(header) {
                  content.header = header;
                  _this2.props.onChange(content, 'content');
                },
                config: s3config,
                uniqueKey: 'headImage-' + uniqueKey,
                isValidImage: this.isValidImage,
                S3_bucketDetails: this.props.S3_bucketDetails,
                __source: {
                  fileName: _jsxFileName,
                  lineNumber: 401
                },
                __self: this
              }),
              React.createElement(
                'div',
                { className: 'bot-response__ItemListHeader', __source: {
                    fileName: _jsxFileName,
                    lineNumber: 417
                  },
                  __self: this
                },
                React.createElement('textarea', {
                  type: 'text',
                  placeholder: 'Title (Optional)',
                  rows: this.state.rows,
                  value: content.header.title,
                  key: 'headText-' + uniqueKey,
                  onChange: function onChange(event) {
                    _this2.setState({ value: event.target.value });
                    _this2.onHeaderContentChange(event, 'title');
                  },
                  __source: {
                    fileName: _jsxFileName,
                    lineNumber: 418
                  },
                  __self: this
                })
              )
            ),
            content.list.map(function (item, index) {
              return React.createElement(
                'div',
                { key: index, __source: {
                    fileName: _jsxFileName,
                    lineNumber: 434
                  },
                  __self: _this2
                },
                index >= 0 && !item.header && React.createElement(TemplateItemListChild, {
                  channel: channel,
                  key: item.key,
                  listIndex: index,
                  itemsCount: content.style === 'large' ? content.list.length - 1 : content.list.length,
                  testImage: testImage,
                  id: id,
                  save: save,
                  mode: mode,
                  itemWithCoverImage: itemWithCoverImage,
                  item: item,
                  onChange: function onChange(data) {
                    return _this2.onItemChange(data, index);
                  },
                  onRemove: function onRemove() {
                    return _this2.onItemRemove(index);
                  },
                  intentId: intentId,
                  uniqueKey: '' + uniqueKey + index,
                  S3_bucketDetails: S3_bucketDetails,
                  __source: {
                    fileName: _jsxFileName,
                    lineNumber: 436
                  },
                  __self: _this2
                })
              );
            })
          ),
          mode !== 'preview' && React.createElement(
            'div',
            {
              __source: {
                fileName: _jsxFileName,
                lineNumber: 462
              },
              __self: this
            },
            mode !== 'save' ? React.createElement(
              'div',
              {
                __source: {
                  fileName: _jsxFileName,
                  lineNumber: 464
                },
                __self: this
              },
              React.createElement(
                'div',
                {
                  className: 'bot-response__ItemListAdd',
                  onClick: this.onAddItem, __source: {
                    fileName: _jsxFileName,
                    lineNumber: 465
                  },
                  __self: this
                },
                React.createElement(IconAdd, {
                  __source: {
                    fileName: _jsxFileName,
                    lineNumber: 468
                  },
                  __self: this
                }),
                React.createElement(
                  'p',
                  { className: 'm-2', __source: {
                      fileName: _jsxFileName,
                      lineNumber: 469
                    },
                    __self: this
                  },
                  'Add Item'
                )
              ),
              dynamicTemplate ? React.createElement(
                'div',
                { className: 'mt-2 m-t-2', __source: {
                    fileName: _jsxFileName,
                    lineNumber: 472
                  },
                  __self: this
                },
                React.createElement(
                  'button',
                  {
                    'data-toggle': 'modal',
                    'data-target': '#showMore-modal',
                    'data-backdrop': 'false',
                    onClick: function onClick(event) {
                      return _this2.onAddShowMoreButton('postback');
                    },
                    className: 'btn btn-outline-primary w-100', __source: {
                      fileName: _jsxFileName,
                      lineNumber: 473
                    },
                    __self: this
                  },
                  'Show More'
                ),
                React.createElement(
                  'div',
                  { className: 'buttonsPreview', __source: {
                      fileName: _jsxFileName,
                      lineNumber: 481
                    },
                    __self: this
                  },
                  React.createElement(Buttons, {
                    field: 'payload',
                    id: 'showMore-modal',
                    index: 0,
                    placeholder: 'Enter button name',
                    onButtonChange: this.onButtonChange.bind(this),
                    content: content.showMore && content.showMore.buttons[0]
                    // handleSave={event => this.handleSave(event)}
                    , onHideModal: this.hideAddButtonModal,
                    intentId: intentId
                    // source={source}
                    , display: this.state.showMoreModal ? 'none' : this.state.showMoreModal !== null ? 'block' : '',
                    uniqueKey: uniqueKey + '-showMore',
                    __source: {
                      fileName: _jsxFileName,
                      lineNumber: 482
                    },
                    __self: this
                  })
                )
              ) : null
            ) : React.createElement(
              'div',
              { className: 'bot-response__ItemListAdd', __source: {
                  fileName: _jsxFileName,
                  lineNumber: 509
                },
                __self: this
              },
              React.createElement(IconAdd, {
                __source: {
                  fileName: _jsxFileName,
                  lineNumber: 510
                },
                __self: this
              }),
              React.createElement(
                'p',
                { className: 'm-2', __source: {
                    fileName: _jsxFileName,
                    lineNumber: 511
                  },
                  __self: this
                },
                'Add Item'
              )
            )
          ),
          React.createElement(TemplateListPreview, {
            content: JSON.parse(JSON.stringify(content)),
            preview: preview,
            channel: channel,
            __source: {
              fileName: _jsxFileName,
              lineNumber: 516
            },
            __self: this
          })
        ),
        React.createElement('hr', {
          __source: {
            fileName: _jsxFileName,
            lineNumber: 522
          },
          __self: this
        })
      );
    }
  }]);

  return TemplateItemList;
}(Component);

export default TemplateItemList;