import _regeneratorRuntime from 'babel-runtime/regenerator';
var _jsxFileName = 'src/lib/components/TemplateItemListChild.js';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import cx from 'classnames';

import IconCamera from '../assets/icons/IconCamera';
import Buttons from './TemplateButton';
import IconResponseDelete from '../assets/icons/IconResponseDelete';
import IconCross from '../assets/icons/IconCross';
import { generateS3Url } from '../utility/templateAction';
import { toast } from 'react-toastify';

var TemplateItemCard = function (_Component) {
  _inherits(TemplateItemCard, _Component);

  function TemplateItemCard(props) {
    _classCallCheck(this, TemplateItemCard);

    var _this = _possibleConstructorReturn(this, (TemplateItemCard.__proto__ || Object.getPrototypeOf(TemplateItemCard)).call(this, props));

    _this.state = {
      isImageValid: null,
      addButtonModal: null,
      editButtonModal: []
    };
    _this.onButtonAdd = _this.onButtonAdd.bind(_this);
    _this.onButtonChange = _this.onButtonChange.bind(_this);
    _this.onButtonRemove = _this.onButtonRemove.bind(_this);
    _this.onButtonIndexChange = _this.onButtonIndexChange.bind(_this);
    _this.onRemoveImage = _this.onRemoveImage.bind(_this);
    _this.hideAddButtonModal = _this.hideAddButtonModal.bind(_this);
    _this.showAddButtonModal = _this.showAddButtonModal.bind(_this);
    _this.hideEditButtonModal = _this.hideEditButtonModal.bind(_this);
    _this.showEditButtonModal = _this.showEditButtonModal.bind(_this);
    _this.onImageUpload = _this.onImageUpload.bind(_this);
    return _this;
  }

  _createClass(TemplateItemCard, [{
    key: 'isValidImage',
    value: function () {
      var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(url) {
        var isImageValid;
        return _regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.prev = 0;
                _context.next = 3;
                return this.props.testImage(url);

              case 3:
                isImageValid = _context.sent;

                this.setState({ isImageValid: isImageValid });
                _context.next = 11;
                break;

              case 7:
                _context.prev = 7;
                _context.t0 = _context['catch'](0);

                this.setState({ isImageValid: false });
                console.error(_context.t0);

              case 11:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this, [[0, 7]]);
      }));

      function isValidImage(_x) {
        return _ref.apply(this, arguments);
      }

      return isValidImage;
    }()
  }, {
    key: 'onChange',
    value: function onChange(event, field) {
      var _props = this.props,
          item = _props.item,
          onChange = _props.onChange;

      item[field] = event.target.value.trim();
      if (field === 'image') {
        this.isValidImage(event.target.value);
      }
      onChange(item);
      this.setState({ value: event.target.value });
    }
  }, {
    key: 'onRemoveImage',
    value: function onRemoveImage() {
      var _props2 = this.props,
          item = _props2.item,
          onChange = _props2.onChange;

      item.image = '';
      onChange(item);
      this.setState({
        isImageValid: null
      });
    }
  }, {
    key: 'onButtonChange',
    value: function onButtonChange(value, index, field) {
      var _props3 = this.props,
          item = _props3.item,
          onChange = _props3.onChange;

      if (field === 'attributes') {
        item.buttons[index]['attributes'] = value;
      } else if (field !== 'title') {
        item.buttons[index]['type'] = field;
        item.buttons[index]['payload'] = value;
      } else {
        item.buttons[index][field] = value;
      }
      onChange(item);
    }
  }, {
    key: 'onButtonAdd',
    value: function onButtonAdd(type) {
      var _props4 = this.props,
          item = _props4.item,
          onChange = _props4.onChange,
          intentId = _props4.intentId;

      var editButtonModal = [].concat(this.state.editButtonModal);
      item.buttons = item.buttons || [];
      item.buttons.push({
        title: '',
        type: type,
        payload: intentId ? '{"data":{"options":"no"}, "intent": "' + intentId + '"}' : '{"data":{"options":"no"}, "intent": ""}'
      });
      editButtonModal.push(null);
      this.setState({
        editButtonModal: editButtonModal
      });
      this.showAddButtonModal();
      onChange(item);
    }
  }, {
    key: 'onButtonRemove',
    value: function onButtonRemove(index) {
      var _props5 = this.props,
          item = _props5.item,
          onChange = _props5.onChange;

      item.buttons.splice(index, 1);
      onChange(item);
      document.querySelector('body').classList.remove('modal-open');
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      var item = this.props.item;

      if (item.image) {
        this.isValidImage(item.image);
      }
      var editButtonModal = [];
      item.buttons.map(function () {
        editButtonModal.push(null);
        return '';
      });
      this.setState({
        addButtonModal: null,
        editButtonModal: editButtonModal
      });
    }
  }, {
    key: 'onButtonIndexChange',
    value: function onButtonIndexChange(index) {
      this.setState({
        buttonIndex: index
      });
      this.showEditButtonModal(index);
    }
  }, {
    key: 'showAddButtonModal',
    value: function showAddButtonModal() {
      this.setState({
        addButtonModal: false
      });
    }
  }, {
    key: 'hideAddButtonModal',
    value: function hideAddButtonModal() {
      this.setState({
        addButtonModal: true
      });
      document.querySelector('body').classList.remove('modal-open');
    }
  }, {
    key: 'showEditButtonModal',
    value: function showEditButtonModal(index) {
      var editButtonModal = [].concat(this.state.editButtonModal);
      editButtonModal[index] = false;
      this.setState({
        editButtonModal: editButtonModal
      });
    }
  }, {
    key: 'hideEditButtonModal',
    value: function hideEditButtonModal(index) {
      var editButtonModal = [].concat(this.state.editButtonModal);
      editButtonModal[index] = true;
      this.setState({
        editButtonModal: editButtonModal
      });
      document.querySelector('body').classList.remove('modal-open');
    }
  }, {
    key: 'getBase64',
    value: function getBase64(file) {
      return new Promise(function (resolve, reject) {
        var reader = new FileReader();
        reader.readAsDataURL(file);
        reader.onload = function () {
          return resolve(reader.result);
        };
        reader.onerror = function (error) {
          return reject(error);
        };
      });
    }
  }, {
    key: 'onImageUpload',
    value: function () {
      var _ref2 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee2(event, field) {
        var _this2 = this;

        var files, _props6, item, onChange, S3_bucketDetails, oldImageId, file, imageUrl;

        return _regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                files = Array.from(event.target.files);
                _props6 = this.props, item = _props6.item, onChange = _props6.onChange, S3_bucketDetails = _props6.S3_bucketDetails;
                oldImageId = '';

                if (!item.imageId) {
                  item.imageId = Math.floor(Math.random() * Math.pow(10, 10));
                } else {
                  oldImageId = item.imageId;
                  item.imageId = Math.floor(Math.random() * Math.pow(10, 10));
                }

                if (!(files.length > 0)) {
                  _context2.next = 15;
                  break;
                }

                file = files[0];

                if (!S3_bucketDetails) {
                  _context2.next = 14;
                  break;
                }

                _context2.next = 9;
                return generateS3Url(S3_bucketDetails['S3_API_URL'], S3_bucketDetails['X-CSRF-Token'], item.imageId, oldImageId, file);

              case 9:
                imageUrl = _context2.sent;

                onChange(Object.assign({}, item, _defineProperty({}, field, imageUrl)));
                this.props.isValidImage(imageUrl);
                _context2.next = 15;
                break;

              case 14:

                this.getBase64(file).then(function (data) {
                  onChange(Object.assign({}, item, _defineProperty({}, field, data)));
                  _this2.isValidImage(data);
                });

              case 15:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function onImageUpload(_x2, _x3) {
        return _ref2.apply(this, arguments);
      }

      return onImageUpload;
    }()
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var _props7 = this.props,
          item = _props7.item,
          save = _props7.save,
          listIndex = _props7.listIndex,
          itemWithCoverImage = _props7.itemWithCoverImage,
          id = _props7.id,
          mode = _props7.mode,
          itemsCount = _props7.itemsCount,
          key = _props7.key,
          intentId = _props7.intentId,
          source = _props7.source,
          channel = _props7.channel,
          uniqueKey = _props7.uniqueKey;
      var isImageValid = this.state.isImageValid;

      return React.createElement(
        'div',
        { className: 'bot-response__ItemListChild', key: key, __source: {
            fileName: _jsxFileName,
            lineNumber: 195
          },
          __self: this
        },
        React.createElement(
          'div',
          {
            key: 'list-child-' + channel,
            className: cx('bot-response__ItemListChildBody', listIndex === 0 && 'border-top-0', listIndex && 'm-10', itemWithCoverImage && !listIndex && 'bg-ash'), __source: {
              fileName: _jsxFileName,
              lineNumber: 196
            },
            __self: this
          },
          React.createElement(
            'div',
            { className: 'bot-response__ItemListChildContainer', __source: {
                fileName: _jsxFileName,
                lineNumber: 204
              },
              __self: this
            },
            React.createElement(
              'div',
              { className: 'bot-response__ItemListChildContent', __source: {
                  fileName: _jsxFileName,
                  lineNumber: 205
                },
                __self: this
              },
              React.createElement(
                'div',
                {
                  className: cx('bot-response__ItemTitle w-160', !item.title.length && 'error'), __source: {
                    fileName: _jsxFileName,
                    lineNumber: 206
                  },
                  __self: this
                },
                mode !== 'preview' ? React.createElement(
                  'div',
                  {
                    __source: {
                      fileName: _jsxFileName,
                      lineNumber: 212
                    },
                    __self: this
                  },
                  React.createElement('textarea', {
                    rows: item.title.length > 80 ? '5' : '2',
                    placeholder: 'Heading (required)',
                    value: item.title,
                    disabled: mode === 'save' || mode === 'preview' ? true : false,
                    key: 'title-' + uniqueKey,
                    onChange: function onChange(event) {
                      return _this3.onChange(event, 'title');
                    },
                    __source: {
                      fileName: _jsxFileName,
                      lineNumber: 213
                    },
                    __self: this
                  })
                ) : React.createElement(
                  'h5',
                  {
                    __source: {
                      fileName: _jsxFileName,
                      lineNumber: 225
                    },
                    __self: this
                  },
                  item.title
                )
              ),
              React.createElement(
                'div',
                { className: 'bot-response__ItemSubtitle w-160', __source: {
                    fileName: _jsxFileName,
                    lineNumber: 228
                  },
                  __self: this
                },
                mode !== 'preview' ? React.createElement(
                  'div',
                  {
                    __source: {
                      fileName: _jsxFileName,
                      lineNumber: 230
                    },
                    __self: this
                  },
                  React.createElement('textarea', {
                    rows: item.subtitle.length > 80 ? '5' : '2',
                    placeholder: 'Subtitle or description',
                    disabled: mode === 'save' || mode === 'preview' ? true : false,
                    key: 'subtitle-' + uniqueKey,
                    value: item.subtitle,
                    onChange: function onChange(event) {
                      return _this3.onChange(event, 'subtitle');
                    },
                    __source: {
                      fileName: _jsxFileName,
                      lineNumber: 231
                    },
                    __self: this
                  })
                ) : React.createElement(
                  'span',
                  {
                    __source: {
                      fileName: _jsxFileName,
                      lineNumber: 243
                    },
                    __self: this
                  },
                  item.subtitle
                )
              ),
              !save && itemsCount !== 1 && React.createElement(
                'div',
                {
                  className: 'listIconTrash iconTrash',
                  onClick: function onClick() {
                    return _this3.props.onRemove();
                  }, __source: {
                    fileName: _jsxFileName,
                    lineNumber: 247
                  },
                  __self: this
                },
                React.createElement(IconResponseDelete, {
                  __source: {
                    fileName: _jsxFileName,
                    lineNumber: 250
                  },
                  __self: this
                })
              ),
              React.createElement(
                'div',
                { className: 'listButtonsPreview ml-8', __source: {
                    fileName: _jsxFileName,
                    lineNumber: 253
                  },
                  __self: this
                },
                item.buttons.map(function (button, index) {
                  return React.createElement(
                    'div',
                    { className: 'editButtonsPreview', key: index, __source: {
                        fileName: _jsxFileName,
                        lineNumber: 255
                      },
                      __self: _this3
                    },
                    save ? React.createElement(
                      'div',
                      {
                        __source: {
                          fileName: _jsxFileName,
                          lineNumber: 257
                        },
                        __self: _this3
                      },
                      button.title && React.createElement(
                        'button',
                        { className: 'bot-response__inputButton btn btn-primary mt-1 m-t-1', __source: {
                            fileName: _jsxFileName,
                            lineNumber: 259
                          },
                          __self: _this3
                        },
                        button.title
                      )
                    ) : React.createElement(
                      'div',
                      {
                        __source: {
                          fileName: _jsxFileName,
                          lineNumber: 265
                        },
                        __self: _this3
                      },
                      React.createElement(
                        'div',
                        { className: 'buttonWrapper', __source: {
                            fileName: _jsxFileName,
                            lineNumber: 266
                          },
                          __self: _this3
                        },
                        React.createElement(
                          'div',
                          {
                            className: 'buttonTitle',
                            'data-target': '#edit' + id + 'Button' + listIndex + index,
                            'data-toggle': 'modal',
                            'data-backdrop': 'false',
                            onClick: function onClick(event) {
                              return _this3.onButtonIndexChange(index);
                            }, __source: {
                              fileName: _jsxFileName,
                              lineNumber: 267
                            },
                            __self: _this3
                          },
                          button.title ? button.title : 'Enter a button Name'
                        ),
                        React.createElement(
                          'div',
                          {
                            className: 'buttonDelete',
                            onClick: function onClick(event) {
                              return _this3.onButtonRemove(index);
                            }, __source: {
                              fileName: _jsxFileName,
                              lineNumber: 279
                            },
                            __self: _this3
                          },
                          React.createElement(IconResponseDelete, {
                            __source: {
                              fileName: _jsxFileName,
                              lineNumber: 282
                            },
                            __self: _this3
                          })
                        )
                      ),
                      React.createElement(
                        'div',
                        { className: 'buttonsPreview', __source: {
                            fileName: _jsxFileName,
                            lineNumber: 285
                          },
                          __self: _this3
                        },
                        React.createElement(Buttons, {
                          field: 'payload',
                          id: 'edit' + id + 'Button' + listIndex + index,
                          index: index,
                          placeholder: 'Enter button name',
                          content: button,
                          source: source,
                          attributes: item.attributes,
                          onButtonChange: _this3.onButtonChange,
                          handleSave: function handleSave(event) {
                            return _this3.handleSave(event);
                          },
                          onHideModal: function onHideModal(index) {
                            return _this3.hideEditButtonModal(index);
                          },
                          intentId: intentId,
                          display: _this3.state.editButtonModal[index] ? 'none' : _this3.state.editButtonModal[index] !== null ? 'block' : '',
                          uniqueKey: uniqueKey,
                          __source: {
                            fileName: _jsxFileName,
                            lineNumber: 286
                          },
                          __self: _this3
                        })
                      )
                    )
                  );
                }),
                mode !== 'preview' && React.createElement(
                  'div',
                  { className: 'buttonsPreview pl-15', __source: {
                      fileName: _jsxFileName,
                      lineNumber: 315
                    },
                    __self: this
                  },
                  React.createElement(
                    'button',
                    {
                      className: 'btn btn-outline-primary',
                      'data-toggle': 'modal',
                      'data-target': '#add' + id + 'Button' + item.buttons.length + listIndex,
                      'data-backdrop': 'false',
                      onClick: function onClick(event) {
                        return _this3.onButtonAdd('postback');
                      },
                      disabled: mode === 'save' ? true : false, __source: {
                        fileName: _jsxFileName,
                        lineNumber: 316
                      },
                      __self: this
                    },
                    'Add Button'
                  ),
                  React.createElement(Buttons, {
                    field: 'payload',
                    id: 'add' + id + 'Button' + item.buttons.length + listIndex,
                    index: item.buttons.length - 1,
                    placeholder: 'Enter button name',
                    attributes: item.attributes,
                    onButtonChange: this.onButtonChange.bind(this),
                    content: item.buttons[item.buttons.length - 1],
                    handleSave: function handleSave(event) {
                      return _this3.handleSave(event);
                    },
                    onHideModal: this.hideAddButtonModal,
                    intentId: intentId,
                    source: source,
                    display: this.state.addButtonModal ? 'none' : this.state.addButtonModal !== null ? 'block' : '',
                    uniqueKey: uniqueKey,
                    __source: {
                      fileName: _jsxFileName,
                      lineNumber: 327
                    },
                    __self: this
                  })
                )
              )
            ),
            React.createElement(
              'div',
              { className: 'bot-response__ItemListChildImage', __source: {
                  fileName: _jsxFileName,
                  lineNumber: 354
                },
                __self: this
              },
              mode !== 'preview' ? React.createElement(
                'div',
                { className: 'wh-i', __source: {
                    fileName: _jsxFileName,
                    lineNumber: 356
                  },
                  __self: this
                },
                !item.image || !isImageValid ? React.createElement(
                  'div',
                  { className: 'wh-i ', __source: {
                      fileName: _jsxFileName,
                      lineNumber: 358
                    },
                    __self: this
                  },
                  React.createElement(
                    'div',
                    { className: 'imageUploader', __source: {
                        fileName: _jsxFileName,
                        lineNumber: 359
                      },
                      __self: this
                    },
                    React.createElement(IconCamera, {
                      __source: {
                        fileName: _jsxFileName,
                        lineNumber: 360
                      },
                      __self: this
                    }),
                    React.createElement(
                      'span',
                      {
                        __source: {
                          fileName: _jsxFileName,
                          lineNumber: 361
                        },
                        __self: this
                      },
                      'Upload Image'
                    ),
                    React.createElement('input', {
                      disabled: save,
                      key: 'itemImageUpload-' + uniqueKey,
                      type: 'file',
                      className: 'bot-response__ImageInput',
                      onChange: function onChange(event) {
                        return _this3.onImageUpload(event, 'image');
                      },
                      accept: 'image/*',
                      __source: {
                        fileName: _jsxFileName,
                        lineNumber: 362
                      },
                      __self: this
                    })
                  ),
                  React.createElement(
                    'div',
                    { className: 'imageInputUrl', __source: {
                        fileName: _jsxFileName,
                        lineNumber: 371
                      },
                      __self: this
                    },
                    React.createElement('input', {
                      type: 'text',
                      value: item.image,
                      key: 'itemImageInput-' + uniqueKey,
                      placeholder: 'Image URL',
                      onChange: function onChange(event) {
                        return _this3.onChange(event, 'image');
                      },
                      __source: {
                        fileName: _jsxFileName,
                        lineNumber: 372
                      },
                      __self: this
                    })
                  )
                ) : React.createElement(
                  'div',
                  { className: 'listChildImageRender', __source: {
                      fileName: _jsxFileName,
                      lineNumber: 382
                    },
                    __self: this
                  },
                  React.createElement(
                    'div',
                    {
                      className: 'image-holder wh-i',
                      style: { position: 'relative' }, __source: {
                        fileName: _jsxFileName,
                        lineNumber: 383
                      },
                      __self: this
                    },
                    React.createElement('img', { src: item.image, className: 'card-image', alt: '', __source: {
                        fileName: _jsxFileName,
                        lineNumber: 386
                      },
                      __self: this
                    }),
                    React.createElement(
                      'span',
                      { onClick: function onClick(event) {
                          return _this3.onRemoveImage();
                        }, __source: {
                          fileName: _jsxFileName,
                          lineNumber: 387
                        },
                        __self: this
                      },
                      React.createElement(IconCross, {
                        __source: {
                          fileName: _jsxFileName,
                          lineNumber: 388
                        },
                        __self: this
                      })
                    ),
                    React.createElement('div', { className: 'imageDelete', __source: {
                        fileName: _jsxFileName,
                        lineNumber: 390
                      },
                      __self: this
                    })
                  )
                )
              ) : React.createElement('img', {
                src: item.image,
                style: { width: '100%' },
                className: 'card-image',
                alt: '',
                __source: {
                  fileName: _jsxFileName,
                  lineNumber: 396
                },
                __self: this
              })
            )
          )
        )
      );
    }
  }]);

  return TemplateItemCard;
}(Component);

export default TemplateItemCard;