import _regeneratorRuntime from 'babel-runtime/regenerator';
var _jsxFileName = 'src/lib/components/TemplateItemRBList.js';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import AceEditor from 'react-ace';
import { TabContent, TabPane, Nav, NavItem, NavLink, Row, Col } from 'reactstrap';
import PropTypes from 'prop-types';
import cx from 'classnames';

import TemplateItemListChild from './TemplateItemListChild';
import IconAdd from '../assets/icons/IconAdd';

import { getButtons, getSanitizedString, isDynamicContent } from '../utility/utility';

var Handlebars = require('handlebars');

var TemplateItemRBList = function (_Component) {
  _inherits(TemplateItemRBList, _Component);

  function TemplateItemRBList(props) {
    _classCallCheck(this, TemplateItemRBList);

    var _this = _possibleConstructorReturn(this, (TemplateItemRBList.__proto__ || Object.getPrototypeOf(TemplateItemRBList)).call(this, props));

    _this.state = {
      activeTab: '1',
      showMore: {
        title: 'Show more',
        type: 'postback',
        value: ''
      },
      isImageValid: null,
      sourceCode: '<div class="panel panel-default list-custom-template"> \n      {{#each payload.accounts}} \n        <div class="panel-body" data-element="true" data-title="{{{title}}}" data-subTitle="{{{subTitle}}}" data-image="{{image}}"> \n          <div class="row"> \n            <div class="col-md-7 col-xs-7">\n              {{#if title}} \n                  <h4 class="list-heading">{{title}}</h4>\n              {{/if}}\n              {{#if subTitle}} \n                  <p class="list-subtitle">{{subTitle}}</p>\n              {{/if}} \n              {{#each buttons}} \n                  <button class="btn btn-primary btn-outline" data-button="true" data-title="{{title}}" data-type="{{type}}" data-payload="{{payload}}" data-webview-type="{{webview_type}}" data-auth="{{auth_required}}" data-intent="{{intent}}" data-postback="{{postback}}" data-extra-payload="{{extra_payload}}" data-button-life="{{life}}" data-message="{{message}}">{{title}}</button> \n              {{/each}}\n              </div> \n            <div class="col-md-5 col-xs-5 text-right"> \n              <img width="100" src="{{image}}" class="img-responsive pull-right"> \n            </div> \n          </div> \n        </div> \n      {{/each}} \n  </div>',
      previewCode: ''
    };

    _this.toggle = _this.toggle.bind(_this);
    _this.handleSourceCodeChange = _this.handleSourceCodeChange.bind(_this);
    _this.onAddItem = _this.onAddItem.bind(_this);
    _this.onRemoveImage = _this.onRemoveImage.bind(_this);
    _this.getSanitizedData = _this.getSanitizedData.bind(_this);
    _this.onChange = _this.onChange.bind(_this);
    return _this;
  }

  _createClass(TemplateItemRBList, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _props = this.props,
          showMore = _props.content.showMore,
          content = _props.content;


      if (showMore) {
        this.setState({
          showMore: showMore
        });
      }
      if (content.image) {
        this.isValidImage(content.image);
      }
    }
  }, {
    key: 'onRemoveImage',
    value: function onRemoveImage() {
      var _props2 = this.props,
          content = _props2.content,
          onChange = _props2.onChange;

      content.image = '';
      onChange(content, 'content');
      this.setState({
        isImageValid: null
      });
    }
  }, {
    key: 'onChange',
    value: function onChange(event, field) {
      var _props3 = this.props,
          content = _props3.content,
          onChange = _props3.onChange;

      onChange(event.target.value, field);

      var sourceCode = this.getSourceCode();
      if (content.list) {
        var title = content.list[0].title;


        if (isDynamicContent(title)) {
          onChange(sourceCode, 'htmlContent');
          onChange(sourceCode, 'templateMarkup');
        }
      }
    }
  }, {
    key: 'isValidImage',
    value: function () {
      var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(url) {
        var isImageValid;
        return _regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.prev = 0;
                _context.next = 3;
                return this.props.testImage(url);

              case 3:
                isImageValid = _context.sent;

                this.setState({ isImageValid: isImageValid });
                _context.next = 11;
                break;

              case 7:
                _context.prev = 7;
                _context.t0 = _context['catch'](0);

                this.setState({ isImageValid: false });
                console.error(_context.t0);

              case 11:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this, [[0, 7]]);
      }));

      function isValidImage(_x) {
        return _ref.apply(this, arguments);
      }

      return isValidImage;
    }()
  }, {
    key: 'onItemChange',
    value: function onItemChange(item, index) {
      var _props4 = this.props,
          content = _props4.content,
          onChange = _props4.onChange;

      content.list[index] = item;
      onChange(content, 'content');

      var sourceCode = this.getSourceCode();
      if (content.list) {
        var _content$list$ = content.list[0],
            title = _content$list$.title,
            subtitle = _content$list$.subtitle,
            image = _content$list$.image;


        if (isDynamicContent(title) || isDynamicContent(subtitle) || isDynamicContent(image) || content.list[0].buttons[0] && (isDynamicContent(content.list[0].buttons[0].title) || isDynamicContent(content.list[0].buttons[0].payload))) {
          onChange(sourceCode, 'htmlContent');
          onChange(sourceCode, 'templateMarkup');
        } else {
          delete content.list[0].htmlContent;
          delete content.list[0].templateMarkup;
          onChange(content, 'content');
        }
      }
    }
  }, {
    key: 'onAttributesChange',
    value: function onAttributesChange(attributes, type) {
      var onChange = this.props.onChange;

      onChange(attributes, 'tAttributes');
    }
  }, {
    key: 'onItemRemove',
    value: function onItemRemove(index) {
      var _props5 = this.props,
          content = _props5.content,
          onChange = _props5.onChange;


      content.list.splice(index, 1);
      onChange(content, 'content');
      if (!content.list.length) {
        this.props.onDelete();
      }
    }
  }, {
    key: 'onAddItem',
    value: function onAddItem() {
      var _props6 = this.props,
          content = _props6.content,
          onChange = _props6.onChange;

      var item = {
        title: '',
        subtitle: '',
        image: '',
        buttons: []
      };
      var key = Math.floor(Math.random() * 1000) + 1;
      var itemsCount = content.list.length;
      var index = 0;
      while (true) {
        if (itemsCount === 0 || index === itemsCount) {
          item['key'] = key;
          break;
        } else if (content.list[index].key !== key) {
          ++index;
        } else {
          key = Math.floor(Math.random() * 1000) + 1;
          index = 0;
        }
      }
      content.list.push(item);
      onChange(content, 'content');
    }
  }, {
    key: 'onButtonChanges',
    value: function onButtonChanges(value, index, type) {
      var _props7 = this.props,
          content = _props7.content,
          onChange = _props7.onChange;
      var showMore = this.state.showMore;


      content.showMore = {};
      if (type !== 'title') {
        content.showMore.type = showMore.type = type;
        content.showMore.value = showMore.value = value;
      }

      onChange(content, 'content');
    }
  }, {
    key: 'unflatten',
    value: function unflatten(data) {
      if (Object(data) !== data || Array.isArray(data)) {
        return data;
      }
      var result = {},
          cur,
          prop,
          idx,
          last,
          temp;
      for (var p in data) {
        cur = result;prop = '';last = 0;
        do {
          idx = p.indexOf('.', last);
          temp = p.substring(last, idx !== -1 ? idx : undefined);
          cur = cur[prop] || (cur[prop] = !isNaN(parseInt(temp)) ? [] : {});
          prop = temp;
          last = idx + 1;
        } while (idx >= 0);
        cur[prop] = data[p];
      }
      return result[''];
    }
  }, {
    key: 'toggle',
    value: function toggle(tab) {
      var _this2 = this;

      if (this.state.activeTab !== tab) {
        if (tab === '2') {
          if (!this.props.dynamicTemplate) {
            var sourceCode = this.getSourceCode();
            this.setState({ sourceCode: sourceCode });
          }
        } else if (tab === '3') {
          var source = this.state.sourceCode;
          var template = Handlebars.compile(source);

          var keyName = this.props.keyName;
          // To mimic the RB Data for the RB  List
          var data = {};
          data[keyName] = [];
          data = this.unflatten(data);

          this.props.content.list.forEach(function (item) {
            var object = [];
            object[_this2.getSanitizedData(item.title)] = 'Easy Access Savings Account - xxxx 6545';
            object[_this2.getSanitizedData(item.subtitle)] = 'Your balance is Rs. 1,21,15,54,957.84';
            object[_this2.getSanitizedData(item.image)] = 'https://axissit.s3.amazonaws.com/savingsAccount.png';
            data[keyName].push(object);
          });

          var previewCode = template(data);
          this.setState({
            previewCode: previewCode
          });
        }

        this.setState({
          activeTab: tab
        });
      }
    }
  }, {
    key: 'handleSourceCodeChange',
    value: function handleSourceCodeChange(code) {
      var onChange = this.props.onChange;

      onChange(true, 'dynamicTemplate');
      this.setState({ sourceCode: code });
    }

    /*
     * Remove the braces, if the title, subtitle is dynamic content
     */

  }, {
    key: 'getSanitizedData',
    value: function getSanitizedData(string) {
      return string.replace(/[{}]/g, '');
    }
  }, {
    key: 'getStaticListMarkup',
    value: function getStaticListMarkup(child, id) {
      var title = child.title,
          subtitle = child.subtitle,
          image = child.image;


      return '\n    <div class="panel-body" data-customTemplate="' + id + '" data-element="true" data-title="' + title + '" data-subTitle="' + subtitle + '" data-image="' + image + '"> \n    <div class="row"> \n      <div class="col-md-5 col-xs-5 text-right"> \n        <img width="100" src="' + image + '" class="img-responsive pull-right"> \n      </div> \n      <div class="col-md-7 col-xs-7">\n        <h4 class="list-heading">' + title + '</h4>\n        <p class="list-subtitle">' + subtitle + '</p>\n      </div> \n    </div> \n  </div> ';
    }
  }, {
    key: 'getSourceCode',
    value: function getSourceCode() {
      var _this3 = this;

      var _props8 = this.props,
          id = _props8.id,
          list = _props8.content.list,
          keyName = _props8.keyName;


      if (list) {
        var _list$ = list[0],
            title = _list$.title,
            subtitle = _list$.subtitle,
            image = _list$.image;


        if (isDynamicContent(title) && isDynamicContent(subtitle) && isDynamicContent(image)) {
          return '<div class="panel panel-default list-custom-template"> \n      {{#each ' + keyName + '}} \n        <div class="panel-body" data-customTemplate="' + id + '" data-element="true" data-title="' + title + '" data-subTitle="' + subtitle + '" data-image="' + image + '"> \n          <div class="row"> \n            <div class="col-md-7 col-xs-7">\n              {{#if ' + (isDynamicContent(title) ? getSanitizedString(title) : ' ') + '}} \n          <h4 class="list-heading">' + title + '</h4>\n              {{/if}}\n              {{#if ' + (isDynamicContent(subtitle) ? getSanitizedString(subtitle) : ' ') + '}} \n                  <p class="list-subtitle">' + subtitle + '</p>\n              {{/if}}  \n                ' + getButtons(list[0]) + '\n               </div> \n            <div class="col-md-5 col-xs-5 text-right"> \n              <img width="100" src="' + image + '" class="img-responsive pull-right"> \n            </div> \n          </div> \n        </div> \n      {{/each}} \n  </div>';
        } else {
          var sourceCode = '<div class="panel panel-default list-custom-template">' + list.map(function (child) {
            return _this3.getStaticListMarkup(child, id);
          });

          sourceCode += '\n</div>';

          return sourceCode;
        }
      }
    }
  }, {
    key: 'componentWillMount',
    value: function componentWillMount() {
      var _props9 = this.props,
          content = _props9.content,
          onChange = _props9.onChange;

      var key = Math.floor(Math.random() * 1000) + 1;
      content.list.forEach(function (item, itemIndex) {
        var index = 0;
        while (true) {
          if (itemIndex === 0 || index === itemIndex) {
            item['key'] = key;
            break;
          } else if (content.list[index].key !== key) {
            ++index;
          } else {
            key = Math.floor(Math.random() * 1000) + 1;
            index = 0;
          }
        }
      });
      onChange(content);
    }
  }, {
    key: 'getTemplateMarkup',
    value: function getTemplateMarkup(id) {
      return '<div data-customTemplate="' + id + '">' + this.state.sourceCode + '</div>';
    }
  }, {
    key: 'render',
    value: function render() {
      var _this4 = this;

      var _props10 = this.props,
          content = _props10.content,
          save = _props10.save,
          id = _props10.id,
          mode = _props10.mode,
          testImage = _props10.testImage,
          keyName = _props10.keyName,
          uniqueKey = _props10.uniqueKey;
      // const { isImageValid } = this.state;

      return React.createElement(
        'div',
        {
          className: 'bot-response__ItemRBList',
          style: { position: 'relative' }, __source: {
            fileName: _jsxFileName,
            lineNumber: 421
          },
          __self: this
        },
        mode !== 'preview' ? React.createElement(
          'div',
          {
            __source: {
              fileName: _jsxFileName,
              lineNumber: 425
            },
            __self: this
          },
          React.createElement(
            Nav,
            { tabs: true, __source: {
                fileName: _jsxFileName,
                lineNumber: 426
              },
              __self: this
            },
            React.createElement(
              NavItem,
              {
                __source: {
                  fileName: _jsxFileName,
                  lineNumber: 427
                },
                __self: this
              },
              React.createElement(
                NavLink,
                {
                  className: cx({ active: this.state.activeTab === '1' }),
                  onClick: function onClick() {
                    _this4.toggle('1');
                  }, __source: {
                    fileName: _jsxFileName,
                    lineNumber: 428
                  },
                  __self: this
                },
                'Definition'
              )
            ),
            React.createElement(
              NavItem,
              {
                __source: {
                  fileName: _jsxFileName,
                  lineNumber: 436
                },
                __self: this
              },
              React.createElement(
                NavLink,
                {
                  className: cx({ active: this.state.activeTab === '2' }),
                  onClick: function onClick() {
                    _this4.toggle('2');
                  }, __source: {
                    fileName: _jsxFileName,
                    lineNumber: 437
                  },
                  __self: this
                },
                'Source'
              )
            ),
            React.createElement(
              NavItem,
              {
                __source: {
                  fileName: _jsxFileName,
                  lineNumber: 445
                },
                __self: this
              },
              React.createElement(
                NavLink,
                {
                  className: cx({ active: this.state.activeTab === '3' }),
                  onClick: function onClick() {
                    _this4.toggle('3');
                  }, __source: {
                    fileName: _jsxFileName,
                    lineNumber: 446
                  },
                  __self: this
                },
                'Preview'
              )
            )
          ),
          React.createElement(
            TabContent,
            { activeTab: this.state.activeTab, __source: {
                fileName: _jsxFileName,
                lineNumber: 455
              },
              __self: this
            },
            React.createElement(
              TabPane,
              { tabId: '1', __source: {
                  fileName: _jsxFileName,
                  lineNumber: 456
                },
                __self: this
              },
              React.createElement(
                Row,
                {
                  __source: {
                    fileName: _jsxFileName,
                    lineNumber: 457
                  },
                  __self: this
                },
                React.createElement(
                  Col,
                  {
                    __source: {
                      fileName: _jsxFileName,
                      lineNumber: 458
                    },
                    __self: this
                  },
                  React.createElement(
                    'div',
                    { className: 'bot-response__Key', __source: {
                        fileName: _jsxFileName,
                        lineNumber: 459
                      },
                      __self: this
                    },
                    React.createElement('textarea', {
                      className: 'w-100',
                      maxLength: '80',
                      placeholder: 'Enter key name:',
                      key: uniqueKey + '-keyName',
                      value: keyName,
                      onChange: function onChange(event) {
                        return _this4.onChange(event, 'keyName');
                      },
                      __source: {
                        fileName: _jsxFileName,
                        lineNumber: 460
                      },
                      __self: this
                    })
                  ),
                  React.createElement(
                    'div',
                    {
                      __source: {
                        fileName: _jsxFileName,
                        lineNumber: 469
                      },
                      __self: this
                    },
                    content.list.map(function (item, index) {
                      return React.createElement(
                        'div',
                        { key: index, __source: {
                            fileName: _jsxFileName,
                            lineNumber: 471
                          },
                          __self: _this4
                        },
                        React.createElement(TemplateItemListChild, {
                          key: item.key,
                          source: 'rblist',
                          listIndex: index,
                          itemsCount: content.list.length,
                          testImage: testImage,
                          id: id,
                          save: save,
                          mode: mode,
                          item: item,
                          onChange: function onChange(data) {
                            return _this4.onItemChange(data, index);
                          },
                          onRemove: function onRemove() {
                            return _this4.onItemRemove(index);
                          },
                          uniqueKey: '' + uniqueKey + index,
                          S3_bucketDetails: _this4.props.S3_bucketDetails,
                          __source: {
                            fileName: _jsxFileName,
                            lineNumber: 472
                          },
                          __self: _this4
                        })
                      );
                    })
                  ),
                  mode !== 'preview' && React.createElement(
                    'div',
                    {
                      __source: {
                        fileName: _jsxFileName,
                        lineNumber: 491
                      },
                      __self: this
                    },
                    React.createElement(
                      'div',
                      {
                        className: 'bot-response__ItemListAdd',
                        onClick: this.onAddItem, __source: {
                          fileName: _jsxFileName,
                          lineNumber: 493
                        },
                        __self: this
                      },
                      React.createElement(IconAdd, {
                        __source: {
                          fileName: _jsxFileName,
                          lineNumber: 496
                        },
                        __self: this
                      }),
                      React.createElement(
                        'p',
                        { className: 'm-2', __source: {
                            fileName: _jsxFileName,
                            lineNumber: 497
                          },
                          __self: this
                        },
                        'Add List Item'
                      )
                    )
                  )
                )
              )
            ),
            React.createElement(
              TabPane,
              { tabId: '2', __source: {
                  fileName: _jsxFileName,
                  lineNumber: 505
                },
                __self: this
              },
              React.createElement(
                Row,
                {
                  __source: {
                    fileName: _jsxFileName,
                    lineNumber: 506
                  },
                  __self: this
                },
                React.createElement(
                  Col,
                  { className: 'codem', __source: {
                      fileName: _jsxFileName,
                      lineNumber: 507
                    },
                    __self: this
                  },
                  React.createElement(AceEditor, {
                    onChange: this.handleSourceCodeChange,
                    name: 'source_code',
                    value: this.state.sourceCode,
                    __source: {
                      fileName: _jsxFileName,
                      lineNumber: 508
                    },
                    __self: this
                  })
                )
              )
            ),
            React.createElement(
              TabPane,
              { tabId: '3', __source: {
                  fileName: _jsxFileName,
                  lineNumber: 516
                },
                __self: this
              },
              React.createElement(
                Row,
                {
                  __source: {
                    fileName: _jsxFileName,
                    lineNumber: 517
                  },
                  __self: this
                },
                React.createElement(
                  Col,
                  {
                    __source: {
                      fileName: _jsxFileName,
                      lineNumber: 518
                    },
                    __self: this
                  },
                  React.createElement('div', {
                    dangerouslySetInnerHTML: {
                      __html: this.state.previewCode
                    },
                    __source: {
                      fileName: _jsxFileName,
                      lineNumber: 519
                    },
                    __self: this
                  })
                )
              )
            )
          )
        ) : null,
        React.createElement(
          'div',
          { className: cx('__preview', mode !== 'preview' && 'd-none'), __source: {
              fileName: _jsxFileName,
              lineNumber: 531
            },
            __self: this
          },
          React.createElement(
            'div',
            { className: 'bot-response__ItemButtonsTitle', __source: {
                fileName: _jsxFileName,
                lineNumber: 532
              },
              __self: this
            },
            React.createElement(
              'h6',
              {
                __source: {
                  fileName: _jsxFileName,
                  lineNumber: 533
                },
                __self: this
              },
              content.title
            )
          ),
          React.createElement(
            'div',
            {
              __source: {
                fileName: _jsxFileName,
                lineNumber: 535
              },
              __self: this
            },
            content.list.map(function (item, index) {
              return React.createElement(
                'div',
                {
                  __source: {
                    fileName: _jsxFileName,
                    lineNumber: 537
                  },
                  __self: _this4
                },
                React.createElement(TemplateItemListChild, {
                  key: item.key,
                  listIndex: index,
                  itemsCount: content.list.length,
                  testImage: testImage,
                  id: id,
                  save: true,
                  mode: 'preview',
                  item: item,
                  dynamicTemplate: true,
                  uniqueKey: '' + uniqueKey + index,
                  __source: {
                    fileName: _jsxFileName,
                    lineNumber: 538
                  },
                  __self: _this4
                })
              );
            })
          )
        )
      );
    }
  }]);

  return TemplateItemRBList;
}(Component);

TemplateItemRBList.propTypes = {
  mode: PropTypes.string,
  save: PropTypes.bool,
  content: PropTypes.object
};

export default TemplateItemRBList;