import _regeneratorRuntime from 'babel-runtime/regenerator';
var _jsxFileName = 'src/lib/components/TemplateItemUploadImage.js';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import cx from 'classnames';
import AWS from 'aws-sdk';

import IconCross from '../assets/icons/IconCross';
import IconCamera from '../assets/icons/IconCamera';
import IconEdit from '../assets/icons/IconEdit';
import { generateS3Url } from '../utility/templateAction';
import { toast } from 'react-toastify';

var ImageUpload = function (_Component) {
  _inherits(ImageUpload, _Component);

  function ImageUpload(props) {
    _classCallCheck(this, ImageUpload);

    var _this = _possibleConstructorReturn(this, (ImageUpload.__proto__ || Object.getPrototypeOf(ImageUpload)).call(this, props));

    _this.state = {
      imageEdited: false
    };
    _this.onImageUpload = _this.onImageUpload.bind(_this);
    _this.onImageEdit = _this.onImageEdit.bind(_this);
    return _this;
  }

  _createClass(ImageUpload, [{
    key: 'getBase64',
    value: function getBase64(file) {
      return new Promise(function (resolve, reject) {
        var reader = new FileReader();
        reader.readAsDataURL(file);
        reader.onload = function () {
          return resolve(reader.result);
        };
        reader.onerror = function (error) {
          return reject(error);
        };
      });
    }
  }, {
    key: 'onImageUpload',
    value: function () {
      var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(event, field, type) {
        var _this2 = this;

        var files, _props, content, onChange, S3_bucketDetails, oldImageId, file, imageUrl;

        return _regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                files = Array.from(event.target.files);
                _props = this.props, content = _props.content, onChange = _props.onChange, S3_bucketDetails = _props.S3_bucketDetails;
                oldImageId = '';

                if (!content.imageId) {
                  content.imageId = Math.floor(Math.random() * Math.pow(10, 10));
                } else {
                  oldImageId = content.imageId;
                  content.imageId = Math.floor(Math.random() * Math.pow(10, 10));
                }

                if (!(files.length > 0)) {
                  _context.next = 15;
                  break;
                }

                file = files[0];

                if (!S3_bucketDetails) {
                  _context.next = 14;
                  break;
                }

                _context.next = 9;
                return generateS3Url(S3_bucketDetails['S3_API_URL'], S3_bucketDetails['X-CSRF-Token'], content.imageId, oldImageId, file);

              case 9:
                imageUrl = _context.sent;

                onChange(Object.assign({}, content, _defineProperty({}, field, imageUrl)));
                this.props.isValidImage(imageUrl);
                _context.next = 15;
                break;

              case 14:
                this.getBase64(file).then(function (data) {
                  onChange(Object.assign({}, content, _defineProperty({}, field, data)));
                  _this2.props.isValidImage(data);
                });

              case 15:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function onImageUpload(_x, _x2, _x3) {
        return _ref.apply(this, arguments);
      }

      return onImageUpload;
    }()
  }, {
    key: 'onImageEdit',
    value: function onImageEdit() {
      var isValidImage = this.props.isValidImage;

      this.setState({
        imageEdited: true
      });
      isValidImage('');
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var _props2 = this.props,
          mode = _props2.mode,
          content = _props2.content,
          isImageValid = _props2.isImageValid,
          save = _props2.save,
          type = _props2.type,
          uniqueKey = _props2.uniqueKey,
          isVideoTemplate = _props2.isVideoTemplate,
          S3_bucketDetails = _props2.S3_bucketDetails;

      return React.createElement(
        'div',
        { className: 'bot-response__ItemCardImage', __source: {
            fileName: _jsxFileName,
            lineNumber: 73
          },
          __self: this
        },
        mode === 'preview' ? React.createElement(
          'div',
          { className: 'bot-response__ItemCardImageRender', __source: {
              fileName: _jsxFileName,
              lineNumber: 75
            },
            __self: this
          },
          React.createElement(
            'div',
            { className: 'image-holder', style: { position: 'relative' }, __source: {
                fileName: _jsxFileName,
                lineNumber: 76
              },
              __self: this
            },
            React.createElement('img', { src: content.image, className: 'card-image', alt: '', __source: {
                fileName: _jsxFileName,
                lineNumber: 77
              },
              __self: this
            }),
            React.createElement(
              'span',
              { onClick: function onClick() {
                  return _this3.onRemoveImage();
                }, __source: {
                  fileName: _jsxFileName,
                  lineNumber: 78
                },
                __self: this
              },
              React.createElement(IconCross, {
                __source: {
                  fileName: _jsxFileName,
                  lineNumber: 79
                },
                __self: this
              }),
              'Remove'
            ),
            React.createElement('div', { className: 'imageDelete', __source: {
                fileName: _jsxFileName,
                lineNumber: 82
              },
              __self: this
            })
          )
        ) : React.createElement(
          'div',
          { className: cx(isImageValid && 'd-b', 'ImageCard'), __source: {
              fileName: _jsxFileName,
              lineNumber: 86
            },
            __self: this
          },
          !content.image || !isImageValid ? React.createElement(
            'div',
            { className: 'ImageCardUrl', __source: {
                fileName: _jsxFileName,
                lineNumber: 88
              },
              __self: this
            },
            React.createElement(
              'div',
              {
                className: cx('imageUploader', isVideoTemplate && 'display-none'), __source: {
                  fileName: _jsxFileName,
                  lineNumber: 89
                },
                __self: this
              },
              React.createElement(IconCamera, {
                __source: {
                  fileName: _jsxFileName,
                  lineNumber: 94
                },
                __self: this
              }),
              React.createElement('input', {
                disabled: save,
                type: 'file',
                className: 'bot-response__ImageInput',
                placeholder: 'Add Image URL',
                key: 'imageUpload-' + uniqueKey,
                onChange: function onChange(event) {
                  _this3.setState({ imageEdited: false });
                  _this3.onImageUpload(event, 'image', type);
                },
                accept: 'image/*',
                __source: {
                  fileName: _jsxFileName,
                  lineNumber: 95
                },
                __self: this
              }),
              React.createElement(
                'span',
                { className: 'button-image-title mt-1', __source: {
                    fileName: _jsxFileName,
                    lineNumber: 107
                  },
                  __self: this
                },
                ' Upload Image'
              )
            ),
            React.createElement(
              'div',
              { className: 'imageInputUrl', __source: {
                  fileName: _jsxFileName,
                  lineNumber: 109
                },
                __self: this
              },
              React.createElement(
                'div',
                {
                  className: cx('text-center mt-2 mb-2 text-info', isVideoTemplate && 'display-none'), __source: {
                    fileName: _jsxFileName,
                    lineNumber: 110
                  },
                  __self: this
                },
                'or'
              ),
              React.createElement('input', {
                type: 'text',
                value: isVideoTemplate ? content.video : this.state.imageEdited && content.image.indexOf('data:image') >= 0 ? '' : content.image,
                placeholder: isVideoTemplate ? 'Add Video URL' : 'Add Image URL',
                key: 'imageInputUrl-' + uniqueKey,
                onChange: function onChange(event) {
                  _this3.setState({ imageEdited: false });
                  _this3.props.onImageInputUrl(event, isVideoTemplate ? 'video' : 'image');
                },
                __source: {
                  fileName: _jsxFileName,
                  lineNumber: 117
                },
                __self: this
              })
            )
          ) : React.createElement(
            'div',
            { className: 'bot-response__ItemCardImageRender', __source: {
                fileName: _jsxFileName,
                lineNumber: 142
              },
              __self: this
            },
            React.createElement(
              'div',
              { className: 'image-holder', style: { position: 'relative' }, __source: {
                  fileName: _jsxFileName,
                  lineNumber: 143
                },
                __self: this
              },
              React.createElement('img', { src: content.image, className: 'card-image', alt: '', __source: {
                  fileName: _jsxFileName,
                  lineNumber: 144
                },
                __self: this
              }),
              React.createElement(
                'div',
                { className: 'bot-response__ItemCardImageEdit', __source: {
                    fileName: _jsxFileName,
                    lineNumber: 145
                  },
                  __self: this
                },
                React.createElement(
                  'span',
                  { onClick: this.onImageEdit, __source: {
                      fileName: _jsxFileName,
                      lineNumber: 146
                    },
                    __self: this
                  },
                  React.createElement(IconEdit, {
                    __source: {
                      fileName: _jsxFileName,
                      lineNumber: 147
                    },
                    __self: this
                  }),
                  'Edit'
                ),
                React.createElement(
                  'span',
                  { onClick: this.props.onRemoveImage, __source: {
                      fileName: _jsxFileName,
                      lineNumber: 150
                    },
                    __self: this
                  },
                  React.createElement(IconCross, {
                    __source: {
                      fileName: _jsxFileName,
                      lineNumber: 151
                    },
                    __self: this
                  }),
                  'Remove'
                )
              ),
              React.createElement('div', { className: 'imageDelete', __source: {
                  fileName: _jsxFileName,
                  lineNumber: 155
                },
                __self: this
              })
            )
          )
        )
      );
    }
  }]);

  return ImageUpload;
}(Component);

export default ImageUpload;