var _jsxFileName = 'src/lib/components/TemplateListPreview.js';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import cx from 'classnames';

var TemplateListPreview = function (_Component) {
  _inherits(TemplateListPreview, _Component);

  function TemplateListPreview() {
    _classCallCheck(this, TemplateListPreview);

    return _possibleConstructorReturn(this, (TemplateListPreview.__proto__ || Object.getPrototypeOf(TemplateListPreview)).apply(this, arguments));
  }

  _createClass(TemplateListPreview, [{
    key: 'generateListContent',
    value: function generateListContent() {
      var _this2 = this;

      var _props = this.props,
          content = _props.content,
          showMore = _props.content.showMore,
          channel = _props.channel,
          displaySize = _props.displaySize;

      if (channel === 'Google Assistant') {
        // we have to make sure that it is carousel or list;
        var items = content.list ? content.style === 'compact' ? content.list : content.list.slice(1) : content;
        return items.map(function (item) {
          if (item.buttons.length) {
            return item.buttons.map(function (button, index) {
              return React.createElement(
                'div',
                { key: index, className: 'card-button', __source: {
                    fileName: _jsxFileName,
                    lineNumber: 22
                  },
                  __self: _this2
                },
                React.createElement(
                  'div',
                  { className: 'card-button-details', __source: {
                      fileName: _jsxFileName,
                      lineNumber: 23
                    },
                    __self: _this2
                  },
                  React.createElement(
                    'div',
                    { className: 'main-title', __source: {
                        fileName: _jsxFileName,
                        lineNumber: 24
                      },
                      __self: _this2
                    },
                    item.title + ' ' + (item.subtitle ? item.subtitle : ' ')
                  ),
                  item.image && React.createElement(
                    'div',
                    { className: '', __source: {
                        fileName: _jsxFileName,
                        lineNumber: 28
                      },
                      __self: _this2
                    },
                    React.createElement('img', { src: item.image, __source: {
                        fileName: _jsxFileName,
                        lineNumber: 29
                      },
                      __self: _this2
                    })
                  )
                ),
                React.createElement(
                  'div',
                  { className: 'button-title', __source: {
                      fileName: _jsxFileName,
                      lineNumber: 33
                    },
                    __self: _this2
                  },
                  button.title
                )
              );
            });
          }
        });
      } else {
        var list = content.style === 'compact' ? content.list : content.list.slice(1);
        return list.map(function (item, index) {
          if (displaySize && index < displaySize || !displaySize) {
            return React.createElement(
              'div',
              {
                __source: {
                  fileName: _jsxFileName,
                  lineNumber: 45
                },
                __self: _this2
              },
              React.createElement(
                'div',
                {
                  className: 'custom-panel-radius panel-body',
                  'data-is-main-parent': 'true',
                  key: index, __source: {
                    fileName: _jsxFileName,
                    lineNumber: 46
                  },
                  __self: _this2
                },
                React.createElement(
                  'div',
                  { className: 'row', __source: {
                      fileName: _jsxFileName,
                      lineNumber: 50
                    },
                    __self: _this2
                  },
                  React.createElement(
                    'div',
                    { className: 'flex-display', __source: {
                        fileName: _jsxFileName,
                        lineNumber: 51
                      },
                      __self: _this2
                    },
                    React.createElement(
                      'div',
                      { className: 'grid-display', __source: {
                          fileName: _jsxFileName,
                          lineNumber: 52
                        },
                        __self: _this2
                      },
                      React.createElement(
                        'div',
                        { className: 'list-elements', __source: {
                            fileName: _jsxFileName,
                            lineNumber: 53
                          },
                          __self: _this2
                        },
                        React.createElement(
                          'h4',
                          { className: 'list-header-titleContainer', __source: {
                              fileName: _jsxFileName,
                              lineNumber: 54
                            },
                            __self: _this2
                          },
                          content.header.title
                        ),
                        React.createElement(
                          'h4',
                          { className: 'list-heading', __source: {
                              fileName: _jsxFileName,
                              lineNumber: 55
                            },
                            __self: _this2
                          },
                          item.title
                        ),
                        React.createElement(
                          'p',
                          { className: 'list-subtitle', __source: {
                              fileName: _jsxFileName,
                              lineNumber: 56
                            },
                            __self: _this2
                          },
                          item.subtitle
                        ),
                        channel === 'Facebook' && React.createElement(
                          'div',
                          { className: 'list-buttons', __source: {
                              fileName: _jsxFileName,
                              lineNumber: 58
                            },
                            __self: _this2
                          },
                          _this2.generateButtons(item)
                        )
                      ),
                      channel !== 'Facebook' && channel !== 'Amazon Alexa' && React.createElement(
                        'div',
                        { className: 'list-buttons', __source: {
                            fileName: _jsxFileName,
                            lineNumber: 64
                          },
                          __self: _this2
                        },
                        _this2.generateButtons(item)
                      )
                    ),
                    React.createElement(
                      'div',
                      { className: 'd-flex', __source: {
                          fileName: _jsxFileName,
                          lineNumber: 69
                        },
                        __self: _this2
                      },
                      item.image && React.createElement(
                        'div',
                        { className: 'flex-align-right', __source: {
                            fileName: _jsxFileName,
                            lineNumber: 71
                          },
                          __self: _this2
                        },
                        React.createElement('img', {
                          src: item.image,
                          className: 'img-responsive pull-right',
                          width: '70',
                          alt: 'list-preview',
                          __source: {
                            fileName: _jsxFileName,
                            lineNumber: 72
                          },
                          __self: _this2
                        })
                      )
                    )
                  )
                )
              ),
              showMore ? React.createElement(
                'div',
                {
                  __source: {
                    fileName: _jsxFileName,
                    lineNumber: 85
                  },
                  __self: _this2
                },
                _this2.generateButtons(showMore, 'card-button')
              ) : null
            );
          }
        });
      }
    }
  }, {
    key: 'generateButtons',
    value: function generateButtons(item, cxs) {
      var _this3 = this;

      var buttons = item.buttons;

      return buttons.map(function (button, index) {
        return React.createElement(
          'div',
          { key: index, className: cx(cxs ? cxs : 'list-button'), __source: {
              fileName: _jsxFileName,
              lineNumber: 97
            },
            __self: _this3
          },
          button.title
        );
      });
    }
  }, {
    key: 'isListPreview',
    value: function isListPreview() {
      var content = this.props.content;

      if (content.list) {
        var items = content.style === 'compact' ? content.list : content.list.slice(1);
        if (items.length === 1 && items[0].buttons.length === 0) {
          return false;
        }
      }
      return true;
    }
  }, {
    key: 'generateListTitles',
    value: function generateListTitles() {
      var _this4 = this;

      var content = this.props.content;

      var items = content.list ? content.style === 'compact' ? content.list : content.list.slice(1) : content;
      return items.map(function (item, index) {
        return React.createElement(
          'h4',
          { key: index, __source: {
              fileName: _jsxFileName,
              lineNumber: 124
            },
            __self: _this4
          },
          item.title
        );
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          content = _props2.content,
          preview = _props2.preview,
          channel = _props2.channel;

      return React.createElement(
        'div',
        {
          __source: {
            fileName: _jsxFileName,
            lineNumber: 131
          },
          __self: this
        },
        preview && content && React.createElement(
          'div',
          {
            __source: {
              fileName: _jsxFileName,
              lineNumber: 133
            },
            __self: this
          },
          (channel === 'default' || channel === 'websdk' || channel === 'Webapp' || channel === 'Facebook') && React.createElement(
            'div',
            {
              className: cx('bot-response__list-message', channel === 'Facebook' && 'bot-response__fb-message-list'), __source: {
                fileName: _jsxFileName,
                lineNumber: 138
              },
              __self: this
            },
            React.createElement(
              'div',
              {
                __source: {
                  fileName: _jsxFileName,
                  lineNumber: 143
                },
                __self: this
              },
              React.createElement(
                'div',
                { className: 'panel panel-default list-custom-template', __source: {
                    fileName: _jsxFileName,
                    lineNumber: 144
                  },
                  __self: this
                },
                content.style !== 'compact' && React.createElement(
                  'div',
                  {
                    className: cx('custom-panel-radius panel-body list-header-bg', !content.header.title && 'mt-n-17'),
                    style: content.header.image && channel !== 'Facebook' ? {
                      backgroundImage: 'url(' + content.header.image + ')'
                    } : { display: 'none' }, __source: {
                      fileName: _jsxFileName,
                      lineNumber: 146
                    },
                    __self: this
                  },
                  channel === 'Facebook' && content.header.image && React.createElement(
                    'div',
                    { className: 'list-header-imageContainer', __source: {
                        fileName: _jsxFileName,
                        lineNumber: 159
                      },
                      __self: this
                    },
                    React.createElement('img', { src: content.header.image, alt: '', __source: {
                        fileName: _jsxFileName,
                        lineNumber: 160
                      },
                      __self: this
                    })
                  )
                ),
                React.createElement(
                  'div',
                  { className: 'custom-panel-radius panel-body list-temp-heading', __source: {
                      fileName: _jsxFileName,
                      lineNumber: 166
                    },
                    __self: this
                  },
                  this.generateListContent()
                )
              )
            )
          ),
          channel === 'Amazon Alexa' && React.createElement(
            'div',
            { className: 'bot-response__amazonalexa-message-list', __source: {
                fileName: _jsxFileName,
                lineNumber: 175
              },
              __self: this
            },
            this.generateListContent()
          ),
          channel === 'Google Assistant' && (this.isListPreview() ? React.createElement(
            'div',
            { className: 'bot-response__google-message-list', __source: {
                fileName: _jsxFileName,
                lineNumber: 182
              },
              __self: this
            },
            React.createElement(
              'div',
              {
                __source: {
                  fileName: _jsxFileName,
                  lineNumber: 183
                },
                __self: this
              },
              React.createElement(
                'div',
                {
                  __source: {
                    fileName: _jsxFileName,
                    lineNumber: 184
                  },
                  __self: this
                },
                React.createElement(
                  'div',
                  { className: 'panel panel-default button-div border-radius-top-20 ', __source: {
                      fileName: _jsxFileName,
                      lineNumber: 185
                    },
                    __self: this
                  },
                  React.createElement(
                    'div',
                    { className: 'panel-body', __source: {
                        fileName: _jsxFileName,
                        lineNumber: 186
                      },
                      __self: this
                    },
                    React.createElement(
                      'div',
                      {
                        __source: {
                          fileName: _jsxFileName,
                          lineNumber: 187
                        },
                        __self: this
                      },
                      React.createElement(
                        'div',
                        { className: 'col-xs-12', __source: {
                            fileName: _jsxFileName,
                            lineNumber: 188
                          },
                          __self: this
                        },
                        this.generateListTitles(),
                        this.generateListContent()
                      )
                    )
                  )
                )
              )
            )
          ) : React.createElement(
            'div',
            { className: 'bot-response__google-message-text', __source: {
                fileName: _jsxFileName,
                lineNumber: 199
              },
              __self: this
            },
            'No preview'
          ))
        )
      );
    }
  }]);

  return TemplateListPreview;
}(Component);

export default TemplateListPreview;