var _jsxFileName = 'src/lib/components/TemplateQuickRepliesButton.js';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import cx from 'classnames';
import { isDynamicContent } from '../utility/utility';
import generateTemplateMarkup from './TemplateItemMarkupGenerator';

var QuickReplies = function (_Component) {
  _inherits(QuickReplies, _Component);

  function QuickReplies() {
    _classCallCheck(this, QuickReplies);

    return _possibleConstructorReturn(this, (QuickReplies.__proto__ || Object.getPrototypeOf(QuickReplies)).apply(this, arguments));
  }

  _createClass(QuickReplies, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.inputButtonTextArea.focus();
      this.inputButtonTextArea && this.inputButtonTextArea.focus();
    }
  }, {
    key: 'onChange',
    value: function onChange(value, field) {
      var _props = this.props,
          content = _props.content,
          onChange = _props.onChange,
          onReplyChange = _props.onReplyChange,
          message = _props.message;

      onReplyChange(value, 0, field, true);

      onChange(generateTemplateMarkup(message, 'quickreply'), 'quickreply_templateMarkup', 0);

      this.setState({
        value: value
      });
    }
  }, {
    key: 'onItemChange',
    value: function onItemChange(value, index, type) {
      var _props2 = this.props,
          onChange = _props2.onChange,
          onReplyChange = _props2.onReplyChange,
          message = _props2.message;

      if (isDynamicContent(value)) {
        onReplyChange(value, index, type, true);
        onChange(generateTemplateMarkup(message, 'quickreply'), 'quickreply_templateMarkup', 0);
      } else {
        onReplyChange(value, index, type, false);
        onChange(generateTemplateMarkup(message, 'quickreply'), 'quickreply_templateMarkup', 0);
      }
      this.setState({
        value: value
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props3 = this.props,
          placeholder = _props3.placeholder,
          id = _props3.id,
          index = _props3.index,
          content = _props3.content,
          display = _props3.display,
          uniqueKey = _props3.uniqueKey,
          dynamicTemplate = _props3.dynamicTemplate;


      return React.createElement(
        'div',
        { className: 'modal quickModal', id: id, style: { display: display }, __source: {
            fileName: _jsxFileName,
            lineNumber: 65
          },
          __self: this
        },
        React.createElement(
          'div',
          { className: 'modal-dialog', __source: {
              fileName: _jsxFileName,
              lineNumber: 66
            },
            __self: this
          },
          React.createElement(
            'div',
            { className: 'modal-content', __source: {
                fileName: _jsxFileName,
                lineNumber: 67
              },
              __self: this
            },
            React.createElement(
              'div',
              { className: 'modal-header', __source: {
                  fileName: _jsxFileName,
                  lineNumber: 68
                },
                __self: this
              },
              React.createElement(
                'div',
                { style: { position: 'relative' }, __source: {
                    fileName: _jsxFileName,
                    lineNumber: 69
                  },
                  __self: this
                },
                React.createElement(
                  'p',
                  {
                    __source: {
                      fileName: _jsxFileName,
                      lineNumber: 70
                    },
                    __self: this
                  },
                  'If subscriber clicks'
                ),
                dynamicTemplate && React.createElement(
                  'div',
                  { className: 'bot-response__Key', __source: {
                      fileName: _jsxFileName,
                      lineNumber: 72
                    },
                    __self: this
                  },
                  React.createElement('textarea', {
                    className: 'w-100',
                    maxLength: '80',
                    key: uniqueKey + '-keyName',
                    placeholder: 'Enter key name:',
                    value: content.keyName,
                    onChange: function onChange(event) {
                      _this2.setState({ value: event.target.value });
                      _this2.onChange(event.target.value, 'keyName');
                    },
                    __source: {
                      fileName: _jsxFileName,
                      lineNumber: 73
                    },
                    __self: this
                  })
                ),
                React.createElement('textarea', {
                  ref: function ref(input) {
                    return _this2.inputButtonTextArea = input;
                  },
                  className: 'quickReplyTitle',
                  cols: '5',
                  rows: content && content.title.length > 33 ? 3 : 1,
                  placeholder: placeholder,
                  key: 'title-' + uniqueKey + id,
                  value: content && content.title,
                  onChange: function onChange(event) {
                    return _this2.onItemChange(event.target.value, index, 'title');
                  },
                  __source: {
                    fileName: _jsxFileName,
                    lineNumber: 86
                  },
                  __self: this
                })
              ),
              React.createElement(
                'button',
                {
                  type: 'button',
                  onClick: function onClick() {
                    return _this2.props.onHideModal(index);
                  },
                  className: 'close',
                  'data-target': '#' + id, __source: {
                    fileName: _jsxFileName,
                    lineNumber: 99
                  },
                  __self: this
                },
                '\xD7'
              )
            ),
            React.createElement(
              'div',
              { className: 'modal-body', __source: {
                  fileName: _jsxFileName,
                  lineNumber: 107
                },
                __self: this
              },
              React.createElement(
                'div',
                { className: 'payloadRender m-b-2 mb-2', __source: {
                    fileName: _jsxFileName,
                    lineNumber: 108
                  },
                  __self: this
                },
                React.createElement(
                  'p',
                  { className: 'mt-3 m-t-3', __source: {
                      fileName: _jsxFileName,
                      lineNumber: 109
                    },
                    __self: this
                  },
                  'Payload'
                ),
                React.createElement('textarea', {
                  className: 'bot-response__ItemTextArea ml-2 m-l-2',
                  ref: function ref(input) {
                    return _this2.inputExternalUrl = input;
                  },
                  cols: '5',
                  rows: content && content.payload.length > 41 ? 3 : 1,
                  placeholder: 'Enter a quick reply Payload',
                  key: 'payload-' + uniqueKey + id,
                  onChange: function onChange(event) {
                    return _this2.onItemChange(event.target.value, index, 'payload');
                  },
                  value: content && content['payload'],
                  __source: {
                    fileName: _jsxFileName,
                    lineNumber: 110
                  },
                  __self: this
                })
              )
            )
          )
        )
      );
    }
  }]);

  return QuickReplies;
}(Component);

export default QuickReplies;