import IconText from '../assets/icons/IconResponseText';
import IconCard from '../assets/icons/IconResponseCard';
import IconCarousel from '../assets/icons/IconCarousel';
import IconList from '../assets/icons/IconResponseList';
import IconImage from '../assets/icons/IconResponseImage';
import IconCustom from '../assets/icons/IconCustom';
import IconButtonOption2 from '../assets/icons/IconResponseButtonOption2';
import IconVideo from '../assets/icons/IconVideo';

export var RESPONSE_TYPES = [{
  type: 'text',
  title: 'Text',
  content: '',
  templateMarkup: '<div class="panel panel-default button-div border-radius-top-20" data-element="true" data-title="{{{this}}}"> <div class="panel-body"> <div class="row"> <div class="col-xs-12 buttondesign"> <h5 class="uob-amex card-title" style="font-weight: bold;">{{this}} </h5> </div> </div> </div> </div>',
  icon: IconText
}, {
  type: 'carousel',
  oftype: 'card',
  title: 'Card',
  content: [{
    title: '',
    subtitle: '',
    image: '',
    buttons: []
  }],
  templateMarkup: '{{#each this}} <div class="panel panel-default button-div border-radius-top-20" data-element="true" data-title="{{{title}}}" data-subTitle="{{{subtitle}}}" data-image="{{image}}"> <div class="panel-heading card-image"> <img src="{{image}}" class="img-responsive"> </div> <div class="panel-body"> <div class="row"> <div class="col-xs-12 buttondesign"> <h5 class="uob-amex card-title" style="font-weight: bold;">{{title}} </h5> <p class="account-number">{{subtitle}} </p> </div> </div> </div> {{#each buttons}} <button type="button" class="btn btn-primary btn-sm btn-block" id="button{{@index}}" data-button="true" data-title="{{title}}" data-type="{{type}}" data-payload="{{payload}}">{{title}} </button> {{/each}} </div> {{/each}}',
  icon: IconCard
}, {
  type: 'button',
  title: 'Button',
  content: {
    title: '',
    buttons: []
  },
  templateMarkup: '<div class="panel panel-default button-div border-radius-top-20" data-element="true" data-title="{{{title}}}"> <div class="panel-body"> <div class="row"> <div class="col-xs-12 buttondesign"> <h5 class="uob-amex card-title" style="font-weight: bold;">{{title}} </h5> </div> </div> </div> {{#each buttons}} <button type="button" class="btn btn-primary btn-sm btn-block" id="button{{@index}}" data-button="true" data-title="{{title}}" data-type="{{type}}" data-payload="{{payload}}">{{title}} </button> {{/each}} </div>',
  icon: IconButtonOption2
}, {
  type: 'carousel',
  title: 'Carousel',
  content: [{
    title: '',
    subtitle: '',
    image: '',
    buttons: []
  }],
  templateMarkup: '{{#each this}} <div class="panel panel-default button-div border-radius-top-20" data-element="true" data-title="{{{title}}}" data-subTitle="{{{subtitle}}}" data-image="{{image}}"> <div class="panel-heading card-image"> <img src="{{image}}" class="img-responsive"> </div> <div class="panel-body"> <div class="row"> <div class="col-xs-12 buttondesign"> <h5 class="uob-amex card-title" style="font-weight: bold;">{{title}} </h5> <p class="account-number">{{subtitle}} </p> </div> </div> </div> {{#each buttons}} <button type="button" class="btn btn-primary btn-sm btn-block" id="button{{@index}}" data-button="true" data-title="{{title}}" data-type="{{type}}" data-payload="{{payload}}">{{title}} </button> {{/each}} </div> {{/each}}',
  icon: IconCarousel
}, {
  type: 'list',
  title: 'List',
  content: {
    header: {
      title: '',
      image: ''
    },
    list: [{
      title: '',
      subtitle: '',
      image: '',
      buttons: []
    }],
    style: 'compact'
  },
  icon: IconList,
  templateMarkup: '<div class="panel panel-default list-custom-template"> {{#each this}} <div class="panel-body" data-element="true" data-title="{{{title}}}" data-subTitle="{{{subtitle}}}" data-image="{{image}}"> <div class="row"> <div class="col-md-7 col-xs-7"> {{#if title}} <h4 class="list-heading">{{title}} </h4> {{/if}} {{#if subtitle}} <p class="list-subtitle">{{subtitle}} </p> {{/if}} {{#each buttons}} <button class="btn btn-primary btn-outline" data-button="true" data-title="{{title}}" data-type="{{type}}" data-payload="{{payload}}" data-webview-type="{{webview_type}}" data-auth="{{auth_required}}" data-intent="{{intent}}" data-postback="{{postback}}" data-extra-payload="{{extra_payload}}" data-button-life="{{life}}" data-message="{{message}}">{{title}} </button> {{/each}} </div> <div class="col-md-5 col-xs-5 text-right"> <img width="100" src="{{image}}" class="img-responsive pull-right"> </div> </div> </div> {{/each}} </div>',
  templateType: 'LT'
}, {
  type: 'image',
  title: 'Image',
  content: {
    image: ''
  },
  icon: IconImage,
  templateMarkup: '<div class="panel panel-default button-div border-radius-top-20" data-element="true" data-image="{{image}}"> <div class="panel-heading card-image"> <img src="{{image}}" class="img-responsive"> </div> </div>',
  templateType: 'I'
}, {
  type: 'carousel',
  oftype: 'video',
  title: 'Video',
  content: [{
    title: '',
    subtitle: '',
    video: '',
    buttons: []
  }],
  icon: IconVideo
}, {
  type: 'dynamic',
  title: 'Custom',
  content: '',
  templateMarkup: '',
  icon: IconCustom
  // Custom Template currently enabled for all channels (including default)
  // hide: true
}, {
  type: 'dynamic',
  source: 'rblist',
  title: 'Advanced List',
  content: {
    list: [{
      title: '',
      subtitle: '',
      image: '',
      buttons: []
    }]
  },
  icon: IconList,
  quick_replies: []
}, {
  type: 'hook',
  title: 'Hook',
  content: '',
  templateMarkup: '<div class="panel abc panel-default button-div border-radius-top-20" data-element="true" data-title="{{{title}}}"> <div class="panel-body"> <div class="row"> <div class="col-xs-12 buttondesign"> <h5 class="uob-amex card-title" style="font-weight: bold;">{{title}} </h5> </div> </div> </div> {{#each buttons}} <button type="button" class="btn btn-primary btn-sm btn-block" id="button{{@index}}" data-button="true" data-title="{{title}}" data-type="{{type}}" data-payload="{{payload}}">{{title}} </button> {{/each}} </div>',
  icon: IconCustom
}];

export var CHANNEL_RESPONSE_TYPES = {
  'Amazon Alexa': ['text', 'carousel', 'list', 'button', 'dynamic'],
  'Google Assistant': ['text', 'carousel', 'button', 'list', 'dynamic'],
  Facebook: ['text', 'carousel', 'button', 'image', 'dynamic']
};

export var LANGUAGES = {
  en: 'English',
  hi: 'Hindi',
  es: 'Spanish',
  th: 'Thai',
  ja: 'Japnese',
  zh: 'Chinese',
  ar: 'Arabic',
  si: 'Singalese',
  vi: 'Vietnamese'
};