var _jsxFileName = 'src/lib/components/TemplateTextArea.js';

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import cx from 'classnames';

import TemplateTextAreaPreview from './TemplateTextPreview';

var defaultRows = 2;

var TextArea = function (_Component) {
  _inherits(TextArea, _Component);

  function TextArea(props) {
    _classCallCheck(this, TextArea);

    var _this = _possibleConstructorReturn(this, (TextArea.__proto__ || Object.getPrototypeOf(TextArea)).call(this, props));

    _this.state = {
      rows: defaultRows
    };
    _this.handleSave = _this.handleSave.bind(_this);
    return _this;
  }

  /**
   * @param event - can be an event or a string[content]
   */


  _createClass(TextArea, [{
    key: 'handleSave',
    value: function handleSave(event) {
      var _props = this.props,
          onChange = _props.onChange,
          type = _props.type;

      var __content = (typeof event === 'undefined' ? 'undefined' : _typeof(event)) === 'object' ? event.target.value : event;
      var wordLimit = type === 'carousel' ? 20 : 35;
      var rows = ~~(__content.length / wordLimit) + 1;
      if (rows > defaultRows) {
        this.setState({
          rows: rows
        });
      } else {
        this.setState({
          rows: defaultRows
        });
      }

      onChange(__content, 'content');
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      var content = this.props.content;

      if (content) {
        var rows = ~~(content.length / 35) + 1;
        if (rows > defaultRows) {
          this.setState({
            rows: rows
          });
        }
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          content = _props2.content,
          mode = _props2.mode,
          placeholder = _props2.placeholder,
          preview = _props2.preview,
          channel = _props2.channel,
          type = _props2.type,
          uniqueKey = _props2.uniqueKey;

      return React.createElement(
        'div',
        {
          __source: {
            fileName: _jsxFileName,
            lineNumber: 60
          },
          __self: this
        },
        React.createElement(
          'div',
          { className: 'bot-response__ItemTextAreaWrapper m-t-2 mt-2', __source: {
              fileName: _jsxFileName,
              lineNumber: 61
            },
            __self: this
          },
          React.createElement(
            'div',
            {
              className: cx('bot-response__ItemTextArea', !content.length && mode !== 'preview' && 'error'), __source: {
                fileName: _jsxFileName,
                lineNumber: 62
              },
              __self: this
            },
            mode === 'preview' ? React.createElement(
              'div',
              { className: 'bot-response__ItemTextPreview', __source: {
                  fileName: _jsxFileName,
                  lineNumber: 68
                },
                __self: this
              },
              content
            ) : React.createElement(
              'div',
              { key: 'textarea-' + channel, __source: {
                  fileName: _jsxFileName,
                  lineNumber: 70
                },
                __self: this
              },
              React.createElement('textarea', {
                className: 'bot-response__ItemTextArea',
                disabled: mode === 'save' || mode === 'preview' ? true : false,
                rows: this.state.rows
                // key={`textarea-${channel}`}
                , key: uniqueKey,
                cols: '30',
                placeholder: placeholder,
                value: content,
                onChange: this.handleSave,
                style: { position: 'relative' },
                __source: {
                  fileName: _jsxFileName,
                  lineNumber: 71
                },
                __self: this
              })
            )
          ),
          React.createElement(TemplateTextAreaPreview, {
            type: type,
            rows: this.state.rows,
            channel: channel,
            preview: preview,
            content: content,
            __source: {
              fileName: _jsxFileName,
              lineNumber: 88
            },
            __self: this
          })
        )
      );
    }
  }]);

  return TextArea;
}(Component);

export default TextArea;