var _jsxFileName = 'src/lib/components/TemplateTextToSpeech.js';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import cx from 'classnames';

import IconPlay from '../assets/icons/IconPlay';
import IconSquare from '../assets/icons/IconSquare';
import IconMuted from '../assets/icons/IconMuted';

var TextToSpeech = function (_Component) {
  _inherits(TextToSpeech, _Component);

  function TextToSpeech(props) {
    _classCallCheck(this, TextToSpeech);

    var _this = _possibleConstructorReturn(this, (TextToSpeech.__proto__ || Object.getPrototypeOf(TextToSpeech)).call(this, props));

    _this.state = {
      isBrowserSupported: false,
      isSpeaking: false
    };
    _this.textToSpeech = _this.textToSpeech.bind(_this);
    return _this;
  }

  _createClass(TextToSpeech, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      if ('speechSynthesis' in window) {
        this.setState({
          isBrowserSupported: true
        });
        window.speechSynthesis.onvoiceschanged = function () {
          window.speechSynthesis.getVoices();
        };
      } else {
        this.setState({
          isBrowserSupported: false
        });
      }
    }
  }, {
    key: 'textToSpeech',
    value: function textToSpeech() {
      var _this2 = this;

      var content = this.props.content;
      var isBrowserSupported = this.state.isBrowserSupported;

      if (isBrowserSupported) {
        if (!window.speechSynthesis.speaking) {
          var utter = new SpeechSynthesisUtterance();
          utter.lang = 'en-US';
          utter.text = content;
          window.speechSynthesis.speak(utter);
          this.setState({
            isSpeaking: true
          });
          utter.onend = function () {
            _this2.setState({
              isSpeaking: false
            });
          };
        } else {
          this.setState({
            isSpeaking: false
          });
          window.speechSynthesis.cancel();
        }
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var isBrowserSupported = this.state.isBrowserSupported;

      return React.createElement(
        'div',
        { className: cx(!isBrowserSupported && 'browserCompatible'), __source: {
            fileName: _jsxFileName,
            lineNumber: 62
          },
          __self: this
        },
        isBrowserSupported ? React.createElement(
          'div',
          {
            __source: {
              fileName: _jsxFileName,
              lineNumber: 64
            },
            __self: this
          },
          this.state.isSpeaking ? React.createElement(IconSquare, {
            className: 'iconSquare',
            textToSpeech: this.textToSpeech,
            __source: {
              fileName: _jsxFileName,
              lineNumber: 66
            },
            __self: this
          }) : React.createElement(IconPlay, { className: 'iconPlay', textToSpeech: this.textToSpeech, __source: {
              fileName: _jsxFileName,
              lineNumber: 71
            },
            __self: this
          })
        ) : React.createElement(
          'div',
          {
            __source: {
              fileName: _jsxFileName,
              lineNumber: 75
            },
            __self: this
          },
          React.createElement(IconMuted, {
            __source: {
              fileName: _jsxFileName,
              lineNumber: 76
            },
            __self: this
          }),
          React.createElement(
            'p',
            {
              __source: {
                fileName: _jsxFileName,
                lineNumber: 77
              },
              __self: this
            },
            ' Your browser doesn\'t support audio'
          )
        )
      );
    }
  }]);

  return TextToSpeech;
}(Component);

export default TextToSpeech;